Package: rgeos
Title: Interface to Geometry Engine - Open Source ('GEOS')
Version: 0.6-1
Date: 2022-12-12
Depends: R (>= 3.3.0), methods, sp (>= 1.1-0)
Imports: utils, stats, graphics
LinkingTo: sp
Suggests: maptools (>= 0.8-5), testthat, XML, maps, rgdal
NeedsCompilation: yes
LazyLoad: yes
Description: Interface to Geometry Engine - Open Source ('GEOS') using the C 'API' for topology operations on geometries. Please note that 'rgeos' will be retired during 2023, plan transition to sf functions using 'GEOS' at your earliest convenience. The 'GEOS' library is external to the package, and, when installing the package from source, must be correctly installed first. Windows and Mac Intel OS X binaries are provided on 'CRAN'. ('rgeos' >= 0.5-1): Up to and including 'GEOS' 3.7.1, topological operations succeeded with some invalid geometries for which the same operations fail from and including 'GEOS' 3.7.2. The 'checkValidity=' argument defaults and structure have been changed, from default FALSE to integer default '0L' for 'GEOS' < 3.7.2 (no check), '1L' 'GEOS' >= 3.7.2 (check and warn). A value of '2L' is also provided that may be used, assigned globally using 'set_RGEOS_CheckValidity(2L)', or locally using the 'checkValidity=2L' argument, to attempt zero-width buffer repair if invalid geometries are found. The previous default (FALSE, now '0L') is fastest and used for 'GEOS' < 3.7.2, but will not warn users of possible problems before the failure of topological operations that previously succeeded. From 'GEOS' 3.8.0, repair of geometries may also be attempted using 'gMakeValid()', which may, however, return a collection of geometries of different types.
Authors@R: c(
	person("Roger", "Bivand", role = c("cre", "aut"), email = "Roger.Bivand@nhh.no", comment=c(ORCID="0000-0003-2392-6140")),
	person("Colin", "Rundel", role = "aut"),
	person("Edzer", "Pebesma", role = "ctb"),
	person("Rainer", "Stuetz", role = "ctb"),
	person("Karl Ove", "Hufthammer", role = "ctb"),
        person("Patrick", "Giraudoux", role = "ctb"),
        person("Martin", "Davis", role = c("cph", "ctb")),
        person("Sandro", "Santilli", role = c("cph", "ctb")))
License: GPL (>= 2)
URL: https://r-forge.r-project.org/projects/rgeos/ https://libgeos.org
        http://rgeos.r-forge.r-project.org/index.html
SystemRequirements: GEOS (>= 3.2.0); for building from source: GEOS
        from https://libgeos.org; GEOS OSX frameworks built by William
        Kyngesburye at http://www.kyngchaos.com/ may be used for source
        installs on OSX.
RoxygenNote: 6.1.1
Packaged: 2022-12-12 20:17:30 UTC; rsb
Author: Roger Bivand [cre, aut] (<https://orcid.org/0000-0003-2392-6140>),
  Colin Rundel [aut],
  Edzer Pebesma [ctb],
  Rainer Stuetz [ctb],
  Karl Ove Hufthammer [ctb],
  Patrick Giraudoux [ctb],
  Martin Davis [cph, ctb],
  Sandro Santilli [cph, ctb]
Maintainer: Roger Bivand <Roger.Bivand@nhh.no>
Repository: CRAN
Date/Publication: 2022-12-14 08:10:02 UTC

RGEOSUnaryPredFunc = function(spgeom, byid, func) {
    stopifnot(is.logical(byid))
    byid = as.logical(byid)
    if (is.na(byid)) stop("Invalid value for byid, must be logical")
    if (inherits(spgeom, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom)) 
        spgeom <- createSPComment(spgeom)

    if (func == "rgeos_isempty")
        x <- .Call("rgeos_isempty", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else if (func == "rgeos_issimple")
        x <- .Call("rgeos_issimple", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else if (func == "rgeos_isring")
        x <- .Call("rgeos_isring", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else if (func == "rgeos_hasz")
        x <- .Call("rgeos_hasz", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else if (func == "rgeos_isvalidreason")
        x <- .Call("rgeos_isvalidreason", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else if (func == "rgeos_isvalid")
        x <- .Call("rgeos_isvalid", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else stop("no such function:", func)
    
    if(byid) {
        id <- unique(row.names(spgeom))
        names(x) <- id
    }
    return(x)
}

gIsEmpty = function(spgeom, byid = FALSE) { 
    return( RGEOSUnaryPredFunc(spgeom, byid,"rgeos_isempty") )
}
gIsSimple  = function(spgeom, byid = FALSE) { 
    return( RGEOSUnaryPredFunc(spgeom, byid,"rgeos_issimple") )
}
gIsRing  = function(spgeom, byid = FALSE) { 
    return( RGEOSUnaryPredFunc(spgeom, byid,"rgeos_isring") )
}
gHasZ  = function(spgeom, byid = FALSE) { 
    return( RGEOSUnaryPredFunc(spgeom, byid,"rgeos_hasz") )
}
gIsValid  = function(spgeom, byid = FALSE, reason=FALSE) {
	if (reason) 
		return( RGEOSUnaryPredFunc(spgeom, byid,"rgeos_isvalidreason") )	    	
	else
		return( RGEOSUnaryPredFunc(spgeom, byid,"rgeos_isvalid") )
}

RGEOSisEmpty = function(spgeom, byid = FALSE) { 
    .Deprecated("gIsEmpty")
    return( gIsEmpty(spgeom, byid) )
}
RGEOSisSimple  = function(spgeom, byid = FALSE) { 
    .Deprecated("gIsSimple")
    return( gIsSimple(spgeom, byid) )
}
RGEOSisRing  = function(spgeom, byid = FALSE) { 
    .Deprecated("gIsRing")
    return( gIsRing(spgeom, byid) )
}
RGEOSHasZ  = function(spgeom, byid = FALSE) { 
    .Deprecated("gHasZ")
    return( gHasZ(spgeom, byid) )
}
RGEOSisValid  = function(spgeom, byid = FALSE, reason=FALSE) {
    .Deprecated("gIsValid")
    return( gIsValid(spgeom, byid, reason) )
}

library(testthat)
library(XML)
library(rgeos)

# Some functions have different names between GEOS and JTS

process_testxml = function(xmlfile, n, total, descSkip) {
    
    funcTranslate=list( "getboundary"       = list(func=gBoundary,res=readWKT,arg1=readWKT),
                        "getCentroid"       = list(func=gCentroid,res=readWKT,arg1=readWKT),
                        "convexhull"        = list(func=gConvexHull,res=readWKT,arg1=readWKT),
                        "getInteriorPoint"  = list(func=gPointOnSurface,res=readWKT,arg1=readWKT),

                        "isSimple"          = list(func=gIsSimple,res=as.logical,arg1=readWKT),
                        "isValid"           = list(func=gIsValid,res=as.logical,arg1=readWKT),

                        "isWithinDistance"  = list(func=gWithinDistance,res=as.logical,arg1=readWKT,arg2=readWKT,arg3=as.numeric),
                        "intersects"        = list(func=gIntersects,res=as.logical,arg1=readWKT,arg2=readWKT),
                        "contains"          = list(func=gContains,res=as.logical,arg1=readWKT,arg2=readWKT),
                        "within"            = list(func=gWithin,res=as.logical,arg1=readWKT,arg2=readWKT),


                        "intersection"      = list(func=gIntersection,res=readWKT,arg1=readWKT,arg2=readWKT),
                        "union"             = list(func=gUnion,res=readWKT,arg1=readWKT,arg2=readWKT),
                        "difference"        = list(func=gDifference,res=readWKT,arg1=readWKT,arg2=readWKT),
                        "symdifference"     = list(func=gSymdifference,res=readWKT,arg1=readWKT,arg2=readWKT),

                        "relate"            = list(func=gRelate,res=as.logical,arg1=readWKT,arg2=readWKT,arg3=as.character),

                        "covers"            = list(func=gCovers,res=as.logical,arg1=readWKT,arg2=readWKT),
                        "coveredBy"         = list(func=gCoveredBy,res=as.logical,arg1=readWKT,arg2=readWKT))
    
    
    context(paste('(',n,'/',total,')',basename(xmlfile)))
    #x = xmlRoot(xmlTreeParse(I(readLines(xmlfile)),ignoreBlanks=TRUE))
    x = xmlRoot(xmlTreeParse(readLines(xmlfile),ignoreBlanks=TRUE))
    
    nodes = xmlSApply(x,xmlName)

    test_that("valid node types",{
        validNodeTypes = c("precisionModel","case","comment")
        expect_that( all(nodes %in% validNodeTypes), is_true() )
    })


    #Handle precisionModel nodes - only use the first model
    pmAttrs =  xmlAttrs( x[[ which(nodes == "precisionModel")[1] ]] )

    test_that("precisionModel attribute tests", {
        expect_that( length(pmAttrs) == 1 | length(pmAttrs) == 3, is_true() )

        if (length(pmAttrs) == 1) {
            type = pmAttrs[["type"]]
        } else if (length(pmAttrs) == 3) {
            setScale(as.numeric( pmAttrs[["scale"]] ))

            expect_that( pmAttrs[["offsetx"]], equals("0.0") )
            expect_that( pmAttrs[["offsety"]], equals("0.0") )
        } 
    })

    #Handle case nodes
    for ( i in which(nodes == "case") ) {
        caseNodes = xmlSApply(x[[i]],xmlName)

        whichDesc = which(caseNodes == "desc")
        whichTests = which(caseNodes == "test")

        desc = xmlValue( x[[i]][[ whichDesc[1] ]] )
    
        if (desc %in% descSkip)
            next

        whichArgs = which(caseNodes != "desc" & caseNodes != "test")
    
        args = rep( NA,length(whichArgs) )
        # argument nodes can either contain the value or have a file attribute
        for ( j in whichArgs) {
            if (is.null( xmlAttrs(x[[i]][[j]]) )) {
                args[[ xmlName(x[[i]][[j]]) ]] = xmlValue(x[[i]][[j]])
            } else {
                file = xmlAttrs(x[[i]][[j]])[["file"]]
                args[[ xmlName(x[[i]][[j]]) ]] = paste( readLines(file), collapse="" )
            }
        }
    
        #make sure the arg names are lowercase for the sake of consistency
        names(args) = tolower(names(args))
    
        for ( j in whichTests ) {
        
            test_that(paste(desc,'- test nodes in proper format') , {
                expect_that( xmlSize( x[[i]][[j]] ), equals(1) )
                expect_that( xmlName( x[[i]][[j]][[1]] ), equals("op") )
            })
        
            if ( xmlSize( x[[i]][[j]] ) == 1 & xmlName( x[[i]][[j]][[1]] ) == "op" ) {

                opAttrs = xmlAttrs( x[[i]][[j]][[1]] )
                opReturn = xmlValue( x[[i]][[j]][[1]] )
                opNArgs = length(opAttrs)-1

                # some ops seem to have a pattern argument that is not used
                if ( 'pattern' %in% names(opAttrs) )
                    opNArgs = opNArgs-1

                opName = opAttrs[['name']]
            
               
            
                test_that(paste(desc,'-',opName), {
                
                    funcdetails = funcTranslate[[opName]]
                    expect_that( is.null(funcdetails), is_false() )
            
                    if ( !is.null(funcdetails) ) {
                        funcNArgs = length( funcdetails )-2
                        expect_that(funcNArgs==opNArgs, is_true())
                    
                        funcArgs = list()
                        for (k in 1:funcNArgs) {
                            argName = paste("arg",k,sep='')

                            argVal = tolower(opAttrs[[argName]])
                            if (argVal %in% names(args))
                                argVal = args[[ argVal ]]
                            funcArgs[k] =  funcdetails[[argName]](argVal)    
                        }
                    
                        funcReturn = do.call(funcdetails[["func"]], funcArgs)
                        expectedReturn = funcdetails[["res"]](opReturn)
                    
                        if (is.logical(funcReturn)) {
                            expect_that(funcReturn == expectedReturn, is_true())
                        } else if (is.null(funcReturn)) {
                            expect_that(is.null(funcReturn) & is.null(expectedReturn), is_true())
                        } else if (gIsEmpty(expectedReturn)) {
                            expect_that(identical(funcReturn,expectedReturn), is_true())
                        } else { # if it isn't logical or NULL it should be a geometry
                            expect_that(gEquals(funcReturn,expectedReturn),is_true())
                        }
                    }
                }) 
            }                
        } 
    }
}

gSimplify = function(spgeom, tol, topologyPreserve=FALSE) {

    stopifnot(is.logical(topologyPreserve))
    if (is.na(topologyPreserve))
	stop("Invalid value for topologyPreserve, must be logical")
	
    if (inherits(spgeom, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom)) 
        spgeom <- createSPComment(spgeom)
    id = row.names(spgeom)
    return( .Call("rgeos_simplify", .RGEOS_HANDLE, spgeom, tol, id, FALSE, topologyPreserve, PACKAGE="rgeos") )
}

gPolygonize = function( splist, getCutEdges=FALSE) {
	
	if (!is.list(splist))
		splist = list(splist)
        if (!all(sapply(splist, inherits, "SpatialLines")))
            stop("list of SpatialLines object required")

	p4slist = lapply(splist,function(x) x@proj4string)
#        splist <- lapply(splist, function(s) {
#            if (inherits(s, "SpatialPolygons") && get_do_poly_check() && notAllComments(s)) {
#                createSPComment(s)
#            } else {
#                s
#            }
#        })
	
	p4s = p4slist[[1]]
	if (length(p4slist) != 1) {
		for(i in 2:length(p4slist)) {
			if (!identical(p4s, p4slist[[i]]))
				stop("spgeoms in splist have different proj4strings")
		}
	}
	

	getCutEdges = as.logical(getCutEdges)
	if (is.na(getCutEdges))
		stop("Invalid value for getCutEdges, must be logical")
	
	nid = sum(sapply(splist, function(x) sapply(slot(x, "lines"),
            function(y) length(slot(y, "Lines")))))
#           sum(sapply(splist,function(x) length(unlist(row.names(x)))))
    id = as.character(1:nid)

    return( .Call("rgeos_polygonize", .RGEOS_HANDLE, splist, id, p4s,
									getCutEdges, PACKAGE="rgeos") )
}





TopologyFunc = function(spgeom, id, byid, func) {
    
    stopifnot(is.logical(byid))
#    byid = as.logical(byid)
    if (is.na(byid)) 
        stop("Invalid value for byid, must be logical")
    
    curids = unique(row.names(spgeom))
    if (is.null(id)) {
        if (byid)   id = curids
        else        id = "1"
    }
    id = as.character(id)

    if (inherits(spgeom, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom)) spgeom <- createSPComment(spgeom)
    
    if ( length(id) != length(unique(id)) )
        stop("Non-unique values for id ")
    
    if ( !(!byid && length(id) == 1) && !(byid && length(id) == length(curids)) )
        stop("Invalid number of values in id" ) 
    if (func == "rgeos_envelope")
        x <- .Call("rgeos_envelope", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_convexhull")
        x <- .Call("rgeos_convexhull", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_boundary")
        x <- .Call("rgeos_boundary", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_getcentroid")
        x <- .Call("rgeos_getcentroid", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_pointonsurface")
        x <- .Call("rgeos_pointonsurface", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_unioncascaded")
        x <- .Call("rgeos_unioncascaded", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_makevalid")
        x <- .Call("rgeos_makevalid", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_makevalidparams")
        x <- .Call("rgeos_makevalidparams", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_coverageunion")
        x <- .Call("rgeos_coverageunion", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else if (func == "rgeos_minimumrotatedrectangle")
        x <- .Call("rgeos_minimumrotatedrectangle", .RGEOS_HANDLE, spgeom, id, byid, PACKAGE="rgeos")
    else stop("no such function:", func)


    return( x )
}

gEnvelope = function(spgeom, byid=FALSE, id = NULL) {
    return( TopologyFunc(spgeom,id,byid,"rgeos_envelope") ) 
}
gConvexHull = function(spgeom, byid=FALSE, id = NULL) {
    return( TopologyFunc(spgeom,id,byid,"rgeos_convexhull") ) 
}
gBoundary = function(spgeom, byid=FALSE, id = NULL) {
     return( TopologyFunc(spgeom,id,byid,"rgeos_boundary") ) 
}
gCentroid = function(spgeom, byid=FALSE, id = NULL) {
    return( TopologyFunc(spgeom,id,byid,"rgeos_getcentroid") ) 
}
gPointOnSurface = function(spgeom, byid=FALSE, id = NULL) {
    return( TopologyFunc(spgeom,id,byid,"rgeos_pointonsurface") ) 
}
gLineMerge = function(spgeom, byid=FALSE, id = NULL) {
#    return( TopologyFunc(spgeom,id,byid,"rgeos_linemerge") ) 
    if (!inherits(spgeom,"SpatialLines"))
        stop("Invalid geometry, may only be applied to lines")
    spgeom <- as(spgeom, "SpatialLines")
    if (is.null(id))
        id = rep("1",length(row.names(spgeom)))

#    if (any(is.na(id))) stop("No NAs permitted in id")

    ids <- split(1:length(id), id)
    out <- vector(mode="list", length=length(ids))
    for (i in seq(along.with=ids)) {
        out[[i]] <- .Call("rgeos_linemerge", .RGEOS_HANDLE,
        spgeom[ids[[i]]], names(ids)[i], FALSE, PACKAGE="rgeos") 
    }
    res <- do.call("rbind.SpatialLines", out)
    res
}

gUnionCascaded = function(spgeom, id = NULL) {
    
    if (!inherits(spgeom,"SpatialPolygons"))
        stop("Invalid geometry, may only be applied to polygons")
    spgeom <- as(spgeom, "SpatialPolygons")

    if (is.null(id))
        id = rep("1",length(row.names(spgeom)))

#    if (any(is.na(id))) stop("No NAs permitted in id")

    if (get_do_poly_check() && notAllComments(spgeom)) spgeom <- createSPComment(spgeom)

    ids <- split(1:length(id), id)
    sl <- sapply(ids, length)
    out <- vector(mode="list", length=length(ids))
    for (i in seq(along.with=ids)) {
        out[[i]] <- TopologyFunc(groupID(spgeom[ids[[i]]], id[ids[[i]]]),
            names(ids)[i], TRUE, "rgeos_unioncascaded")
    }
    res <- do.call("rbind.SpatialPolygons", out)

    res
}

gMakeValid = function(spgeom, byid=FALSE, id = NULL, original=NULL, keepCollapsed=NULL) {

    if (version_GEOS0() < "3.8.0")
        stop("No UnaryUnion in this version of GEOS")
    if (version_GEOS0() < "3.10.0") {
        return( TopologyFunc(spgeom, id, byid, "rgeos_makevalid") ) 
    } else {
        if (is.null(original)) {
            envvar <- Sys.getenv("GEOS_MAKE_VALID")
            if (nzchar(envvar)) {
                original <- TRUE
                if (envvar == "STRUCTURE") original <- FALSE
            } else {
                original <- TRUE
            }
        }
        if (original) {
            keepCollapsed <- FALSE
        } else {
            if(is.null(keepCollapsed)) {
                envvar <- Sys.getenv("GEOS_MAKE_VALID_KEEPCOLLAPSED")
                if (nzchar(envvar)) {
                    keepCollapsed <- FALSE
                    if (envvar == "TRUE") keepCollapsed <- TRUE
                } else {
                    keepCollapsed <- FALSE
                }
            }
        } 
        stopifnot(is.logical(original))
        stopifnot(is.logical(keepCollapsed))
        attr(byid, "original") <- original
        attr(byid, "keepCollapsed") <- keepCollapsed
        return( TopologyFunc(spgeom, id, byid, "rgeos_makevalidparams") ) 
    }
}

gCoverageUnion = function(spgeom, byid=FALSE, id = NULL) {

    if (version_GEOS0() < "3.8.0")
        stop("No CoverageUnion in this version of GEOS")
    return( TopologyFunc(spgeom, id, byid, "rgeos_coverageunion") ) 

}

gMinumumRotatedRectangle <- function(spgeom, byid=FALSE, id = NULL) {

    if (version_GEOS0() < "3.9.0")
        stop("No MinumumRotatedRectangle in this version of GEOS")
    return( TopologyFunc(spgeom, id, byid, "rgeos_minimumrotatedrectangle") ) 

}


gMaximumInscribedCircle <- function(spgeom, byid=FALSE, id = NULL, tol=.Machine$double.eps^(1/2), checkValidity=NULL) {    

    if (version_GEOS0() < "3.9.0")
        stop("No MaximumInscribedCircle in this version of GEOS")

    if (!inherits(spgeom,"SpatialPolygons"))
        stop("Invalid geometry, may only be applied to polygons")

    stopifnot(is.logical(byid))
    byid = as.logical(byid)
    if (is.na(byid)) 
        stop("Invalid value for byid, must be logical")

    if (is.null(checkValidity)) checkValidity <- get_RGEOS_CheckValidity()
    if(checkValidity > 0L) {
        val1 <- isTRUE(all(gIsValid(spgeom, byid=TRUE)))
        nm_1 <- deparse(substitute(spgeom))
        if (!val1) message(nm_1, " is invalid")
        if (checkValidity == 1L && !all(val1)) warning("Invalid objects found; consider using set_RGEOS_CheckValidity(2L)")
        if (checkValidity == 2L) {
            if (!val1) {
                spgeom <- gBuffer(spgeom, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_1, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom, byid=TRUE)))) stop("Zero width buffer repair of spgeom1 failed")
            }
        }
    }

    spgeom <- as(spgeom, "SpatialPolygons")
    curids = unique(row.names(spgeom))
    if (is.null(id)) {
        if (byid)   id = curids
        else        id = "1"
    }
    id = as.character(id)

#    if (any(is.na(id))) stop("No NAs permitted in id")

    if (get_do_poly_check() && notAllComments(spgeom)) spgeom <- createSPComment(spgeom)

    .Call("rgeos_maximuminscribedcircle", .RGEOS_HANDLE,
        spgeom, id, byid, tol, PACKAGE="rgeos")


#    return( TopologyFunc(spgeom, id, byid, tol, "rgeos_maximuminscribedcircle") ) 

}


gUnaryUnion = function(spgeom, id = NULL, checkValidity=NULL) {

    if (version_GEOS0() < "3.3.0")
        stop("No UnaryUnion in this version of GEOS")
    
    if (!inherits(spgeom,"SpatialPolygons"))
        stop("Invalid geometry, may only be applied to polygons")

    if (is.null(checkValidity)) checkValidity <- get_RGEOS_CheckValidity()
    if(checkValidity > 0L) {
        val1 <- isTRUE(all(gIsValid(spgeom, byid=TRUE)))
        nm_1 <- deparse(substitute(spgeom))
        if (!val1) message(nm_1, " is invalid")
        if (checkValidity == 1L && !all(val1)) warning("Invalid objects found; consider using set_RGEOS_CheckValidity(2L)")
        if (checkValidity == 2L) {
            if (!val1) {
                spgeom <- gBuffer(spgeom, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_1, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom, byid=TRUE)))) stop("Zero width buffer repair of spgeom1 failed")
            }
        }
    }

    spgeom <- as(spgeom, "SpatialPolygons")
    if (is.null(id))
        id = rep("1",length(row.names(spgeom)))

#    if (any(is.na(id))) stop("No NAs permitted in id")

    if (get_do_poly_check() && notAllComments(spgeom)) spgeom <- createSPComment(spgeom)

    ids <- split(1:length(id), id)
    out <- vector(mode="list", length=length(ids))
    for (i in seq(along.with=ids)) {
        out[[i]] <- .Call("rgeos_unaryunion", .RGEOS_HANDLE,
        spgeom[ids[[i]]], names(ids)[i], FALSE, PACKAGE="rgeos") 
    }
    res <- do.call("rbind.SpatialPolygons", out)
    res
}

gDelaunayTriangulation <- function(spgeom, tolerance=0.0, onlyEdges=FALSE) {

    if (version_GEOS0() < "3.4.0")
        stop("No DelaunayTriangulation in this version of GEOS")

    if (!inherits(spgeom, "SpatialPoints"))
        stop("Invalid geometry, may only be applied to points")
    if (nrow(zerodist(spgeom)) > 0)
        stop("duplicate points not permitted")
    stopifnot(is.numeric(tolerance))
    stopifnot(length(tolerance) == 1)
    stopifnot(is.logical(onlyEdges))
    stopifnot(length(onlyEdges) == 1)

    .Call("rgeos_delaunaytriangulation", .RGEOS_HANDLE,
        spgeom, tolerance, onlyEdges, PACKAGE="rgeos")
    
}

gNode <- function(spgeom){

    if (version_GEOS0() < "3.4.0")
        stop("No noding in this version of GEOS")

    if (!inherits(spgeom, "SpatialLines"))
        stop("Invalid geometry, may only be applied to lines")

    .Call("rgeos_node", .RGEOS_HANDLE, spgeom, PACKAGE="rgeos")

}

RGEOSEnvelope = function(spgeom, byid=FALSE, id = NULL) {
    .Deprecated("gEnvelope")
    return( gEnvelope(spgeom, id, byid) )
}
RGEOSConvexHull = function(spgeom, byid=FALSE, id = NULL) {
    .Deprecated("gConvexHull")
    return( gConvexHull(spgeom, id, byid) )
}
RGEOSBoundary = function(spgeom, byid=FALSE, id = NULL) {
    .Deprecated("gBoundary")
    return( gBoundary(spgeom, id, byid) )
}
RGEOSGetCentroid = function(spgeom, byid=FALSE, id = NULL) {
    .Deprecated("gCentroid")
    return( gCentroid(spgeom, id, byid) )
}
RGEOSPointOnSurface = function(spgeom, byid=FALSE, id = NULL) {
    .Deprecated("gPointOnSurface")
    return( gPointOnSurface(spgeom, id, byid) )
}
RGEOSLineMerge = function(spgeom, byid=FALSE, id = NULL) {
    .Deprecated("gLineMerge")
    return( gLineMerge(spgeom, id, byid) )
}
RGEOSUnionCascaded = function(spgeom, id = NULL) {
    .Deprecated("gUnionCascaded")
    return( gUnionCascaded(spgeom, id) )
}

#########################
###
### SpatialRings
###
#########################

Ring <- function(coords,ID=as.character(NA)) {
    if (ncol(coords) != 2) 
        stop("coords must be a two-column matrix")
    
    n = nrow(coords)
    area2 = sum( (coords[-1,1]-coords[-n,1])*(coords[-1,2]+coords[-n,2]) )
    if (area2 < 0) {
        # if area2 is negative coordinates are ccw, reverse them
        coords[,1] = rev(coords[,1])
        coords[,2] = rev(coords[,2])
    }
    
    coords <- coordinates(coords)
    new("Ring", coords = coords, ID = ID)
}

.bboxSRs <- function(lst) {
    bb = sapply(lst, bbox)
    res = matrix(c(min(bb[1,]), min(bb[2,]), max(bb[3,]), max(bb[4,])), 2, 2)
    dimnames(res) = list(c("x", "y"), c("min", "max"))
    return(res)
}

SpatialRings <- function(RingList, proj4string=CRS(as.character(NA))) {
    if (any(sapply(RingList, function(x) !is(x, "Ring")))) 
        stop("Ring list not exclusively filled with Ring objects")
    Sp <- new("Spatial", bbox = .bboxSRs(RingList), proj4string=proj4string)
    res <- new("SpatialRings", Sp, rings=RingList)
    return(res)
}


bbox.Ring <- function(obj) {
    rx <- range(obj@coords[,1])
    ry <- range(obj@coords[,2])
    res = rbind(r1 = rx, r2 = ry)
    dimnames(res)[[2]] <- c("min", "max")
    return(res)
}
setMethod("bbox", "Ring", bbox.Ring)


plotSpatialRings <- function(SR, xlim = NULL, ylim = NULL,
                             col = 1, lwd = 1, lty=1, add = FALSE, axes = FALSE, ..., 
                             setParUsrBB=FALSE) {

    if (!add) 
        plot(as(SR, "Spatial"), xlim = xlim, ylim = ylim, axes = axes, ..., setParUsrBB=setParUsrBB)
    

    lst <- SR@rings
    if (length(col) != length(lst)) 
        col <- rep(col[1], length(lst))
    if (length(lwd) != length(lst)) 
        lwd <- rep(lwd[1], length(lst))
    if (length(lty) != length(lst)) 
        lty <- rep(lty[1], length(lst))

    for (i in seq(along.with=lst)) {
        crds <- coordinates(lst[[i]])
        lines(crds, col = col[i], lwd = lwd[i], lty = lty[i], ...)
    }
}

setMethod("plot", 
          signature(x = "SpatialRings", y = "missing"), 
          function(x, y, ...) plotSpatialRings(x, ...) )

setMethod("coordinates", "Ring", function(obj) obj@coords)
setMethod("coordinates", "SpatialRings", function(obj) lapply(obj@rings, coordinates))


#if (!isGeneric("lines"))
#    setGeneric("lines", function(x, y, ...)
#        standardGeneric("lines"))

#setMethod("lines", "Ring", function(x, y = NULL, ...) invisible(lines(coordinates(x), ...)))
#setMethod("lines", "SpatialRings", function(x, y = NULL, ...) {
#    f = function(x, ...) lines(x, ...)
#    invisible(lapply(x@rings, f, ...))
#})

if (!isGeneric("row.names"))
	setGeneric("row.names", function(x) standardGeneric("row.names"))
if (!isGeneric("row.names<-")) 
	setGeneric("row.names<-", function(x, value) standardGeneric("row.names<-"))

setMethod("row.names", "SpatialRings", function(x) sapply(slot(x, "rings"), slot, "ID"))
setReplaceMethod("row.names", signature(x = "SpatialRings", value = "character"),
                 function(x, value) spChFIDs(x, value))

setMethod("[", "SpatialRings", 
    function(x, i, j, ..., drop = TRUE) {
        if (any(is.na(i))) stop("NAs not permitted in row index")
        
        if (is.logical(i)) {
            if (length(i) == 1 && i) {
                i = 1:length(x@rings)
            } else {
                i <- which(i)
            }
        } else if (is.character(i)) {
            i <- match(i, row.names(x))
        }
        
        x@rings = x@rings[i]
        x@bbox = .bboxSRs(x@rings)
        return(x)
    }
)


setMethod("coordnames", signature(x = "SpatialRings"), function(x) coordnames(x@rings[[1]]))
setMethod("coordnames", signature(x = "Ring"), function(x) dimnames(coordinates(x))[[2]])

setReplaceMethod("coordnames", 
                 signature(x = "SpatialRings", value = "character"),
                 function(x, value) {
                     dimnames(x@bbox)[[1]] = value
                     for (i in seq(along = x@rings))
                        coordnames(x@rings[[i]]) = value
                     return(x)
                 }
)
setReplaceMethod("coordnames",signature(x = "Ring", value = "character"),
                 function(x, value) {
                     dimnames(x@coords)[[2]] = value
                     return(x)
                 }
)



chFIDsSpatialRings <- function(obj, x) {
    nl <- length(slot(obj, "rings"))
    if (length(x) != nl) stop("lengths differ")
    if (length(x) > length(unique(x))) stop("duplicate IDs")

    rings <- slot(obj, "rings")
    for (i in 1:nl) obj@rings[[i]]@ID = x[i]
    
    return(obj)
}
setMethod("spChFIDs", signature(obj="SpatialRings", x="character"), chFIDsSpatialRings)

setAs("Ring", 
      "SpatialPoints",
      function(from) { 
          SpatialPoints(do.call("rbind", coordinates(from)))
      }
)

setAs("SpatialRings", 
      "SpatialPoints", 
      function(from) { 
          SpatialPoints(do.call("rbind", 
                        lapply(from@rings, function(x) as(x, "SpatialPoints"))),
                        CRS(proj4string(from)))
      }
)


#########################
###
### SpatialRingsDataFrame
###
#########################

SpatialRingsDataFrame = function(sr, data, match.ID = TRUE) {
    if (match.ID) {
        sr_IDs <- row.names(sr)
        data_IDs <- row.names(data)
        mtch <- match(sr_IDs, data_IDs)
        if (any(is.na(mtch)))
            stop("row.names of data and Rings IDs do not match")
        if (length(unique(mtch)) != length(sr_IDs))
            stop("row.names of data and Rings IDs do not match")
        data <- data[mtch, , drop=FALSE]
    }
    if (nrow(data) != length(sr@rings))
        stop("length of data.frame does not match number of Ring elements")
    
    return( new("SpatialRingsDataFrame", sr, data = data) )
}

setAs("SpatialRingsDataFrame","SpatialRings", function(from) SpatialRings(from@rings))
setAs("SpatialRingsDataFrame", "data.frame", function(from) from@data)

setMethod("names","SpatialRingsDataFrame", function(x) names(x@data))    
setReplaceMethod("names", signature(x = "SpatialRingsDataFrame", value = "character"),
                 function(x, value) { names(x@data)<-value; x })

setMethod("row.names","SpatialRingsDataFrame", function(x) sapply(slot(x, "rings"), slot, "ID"))    
setReplaceMethod("row.names", signature(x = "SpatialRingsDataFrame", value = "character"),
              function(x, value) spChFIDs(x, value))


setMethod("[", c("SpatialRingsDataFrame", "ANY", "ANY"), 
    function(x, i, j, ... , drop = TRUE) {
        missing.i = missing(i)
        missing.j = missing(j)
        nargs = nargs() # e.g., a[3,] gives 2 for nargs, a[3] gives 1.
        
        if (missing.i && missing.j) {
            i = TRUE
            j = TRUE
        } else if (missing.j && !missing.i) {
            if (nargs == 2) {
                j = i
                i = TRUE
            } else {
                j = TRUE
            }
        } else if (missing.i && !missing.j) {
            i = TRUE
        }
        
        if (is.matrix(i)) stop("matrix argument not supported in SpatialRingsDataFrame selection")
        if (is.logical(i)) {
            if (length(i) == 1 && i)
                i = 1:length(x@rings)
            else
                i = which(i)
        } else if (is.character(i)) {
                i = match(i, row.names(x))
        }
        
        if (any(is.na(i))) stop("NAs not permitted in row index")
        
        x@rings = x@rings[i]
        x@data = x@data[i, j, ..., drop = FALSE]
        x@bbox = .bboxSRs(x@rings)
        
        return(x)
    }
)

#setMethod("lines","SpatialRingsDataFrame", function(x, y = NULL, ...) lines(as(x, "SpatialRings"), ...))    
setMethod("dim","SpatialRingsDataFrame", function(x) dim(x@data))


chFIDsSpatialRingsDataFrame <- function(obj, x) {
    SR <- as(obj, "SpatialRings")
    SRx <- spChFIDs(SR, x)
    df <- as(obj, "data.frame")
    row.names(df) <- sapply(slot(SRx, "rings"), function(x) slot(x, "ID"))
    SpatialRingsDataFrame(SRx, data=df)
}

setMethod("spChFIDs", signature(obj="SpatialRingsDataFrame", x="character"), chFIDsSpatialRingsDataFrame)



#########################
###
### SpatialCollections
###
#########################


SpatialCollections <- function( points = NULL, lines = NULL,
								rings = NULL, polygons = NULL,
								plotOrder = c(4,3,2,1),
								proj4string=CRS(as.character(NA))) {

	plotOrder=as.integer(plotOrder)
	stopifnot(is.integer(plotOrder))
	stopifnot(length(plotOrder) == 4)
	
	stopifnot(inherits(points,"SpatialPoints") | is.null(points))
	stopifnot(inherits(lines,"SpatialLines") | is.null(lines))
	stopifnot(inherits(rings,"SpatialRings") | is.null(rings))
	stopifnot(inherits(polygons,"SpatialPolygons") | is.null(polygons))
	stopifnot(is(proj4string, "CRS"))
	
	bb = c()
	if (!is.null(points)) bb = rbind(bb,c(bbox(points)))
	if (!is.null(lines)) bb = rbind(bb,c(bbox(lines)))
	if (!is.null(rings)) bb = rbind(bb,c(bbox(rings)))
	if (!is.null(polygons)) bb = rbind(bb,c(bbox(polygons)))
	
	if (length(bb) == 0) {
		bbox = matrix( rep(NA, 2), 2, 2)
	} else {
		bbox = matrix(c(min(bb[,1]), min(bb[,2]), max(bb[,3]), max(bb[,4])), 2, 2)
	}
	dimnames(bbox) = list(c("x", "y"), c("min", "max"))
	
	
	
	Sp <- new("Spatial", bbox = bbox, proj4string=proj4string)	
    res <- new("SpatialCollections", Sp, plotOrder=plotOrder, pointobj=points, 
				lineobj=lines, ringobj=rings, polyobj=polygons)
	#validObject(res)

    return(res)
}


plotSpatialCollections <- function(SC, 
								   pointopt = list(), lineopt = list(),
								   ringopt = list(), polyopt = list(),
								   pch = 3, cex = 1, bg = 1,
								   col = 1, lwd = 1, lty=1,
								   border = par("fg"), xpd = NULL, 
								   density = NULL, angle = 45, pbg=NULL,
								   xlim = NULL, ylim = NULL,
								   add = FALSE, axes = FALSE, ...,
	  							   setParUsrBB=FALSE) {
		
	if (!add) {
		plot(as(SC,"Spatial"), xlim=xlim, ylim=ylim, axes=axes, 
			 ..., setParUsrBB=setParUsrBB)
	}
	add=TRUE
	
	call = match.call()
	if (is.null(call$col) & is.null(polyopt[["col"]]))
		polyopt[["col"]] = NA
		
	for (i in order(SC@plotOrder)) {
		
		if (i == 1 & !is.null(SC@pointobj)) { # plot points
			ptcol = col
			ptlwd = lwd
			
			if (!is.null(pointopt[["pch"]])) ptpch = pointopt[["pch"]]
			if (!is.null(pointopt[["cex"]])) ptcex = pointopt[["cex"]]
			if (!is.null(pointopt[["col"]])) ptcol = pointopt[["col"]]
			if (!is.null(pointopt[["lwd"]])) ptlwd = pointopt[["lwd"]]
			if (!is.null(pointopt[["bg"]]))  ptbg  = pointopt[["bg"]]
			
			plot(SC@pointobj, pch=pch, axes=axes, add=add, xlim=xlim, ylim=ylim, 
				 cex=cex, col=ptcol, lwd=ptlwd, bg=bg, ..., setParUsrBB=setParUsrBB)
			
		} else if (i == 2 & !is.null(SC@lineobj)) { #plot lines
			lcol = col
			llwd = lwd
			llty = lty
			
			if (!is.null(lineopt[["col"]])) lcol = lineopt[["col"]]
			if (!is.null(lineopt[["lwd"]])) llwd = lineopt[["lwd"]]
			if (!is.null(lineopt[["lty"]])) llty = lineopt[["lty"]]
			
			plot(SC@lineobj, xlim=xlim, ylim=ylim, col=lcol, lwd=llwd, lty=llty,
				 add=add, axes=axes, ..., setParUsrBB=setParUsrBB)
			
		} else if (i == 3 & !is.null(SC@ringobj)) { #plot rings
			rcol = col
			rlwd = lwd
			rlty = lty
			
			if (!is.null(ringopt[["col"]])) rcol = ringopt[["col"]]
			if (!is.null(ringopt[["lwd"]])) rlwd = ringopt[["lwd"]]
			if (!is.null(ringopt[["lty"]])) rlty = ringopt[["lty"]]
			
			plot(SC@ringobj, xlim=xlim, ylim=ylim, col=rcol, lwd=rlwd, lty=rlty,
				 add=add, axes=axes, ..., setParUsrBB=setParUsrBB)
				
		} else if (i == 4 & !is.null(SC@polyobj)) { #plot polygons
			pcol = col
			if (!is.null(polyopt[["col"]])) pcol = polyopt[["col"]]
			
			plot(SC@polyobj, col=pcol, border=border, add=add, xlim=xlim, ylim=ylim,
				 xpd=xpd, density=density, angle=angle, pbg=pbg, axes=axes, ...,
				 setParUsrBB=setParUsrBB)
		}
	}
}
		
setMethod("plot", signature(x = "SpatialCollections", y = "missing"),
	function(x, y, ...) plotSpatialCollections(x, ...))
	
setMethod("row.names", "SpatialCollections", function(x) {
	
	ans = list()
	if (!is.null(x@pointobj)) ans$points = row.names(x@pointobj)
	if (!is.null(x@lineobj)) ans$lines = row.names(x@lineobj)
	if (!is.null(x@ringobj)) ans$rings = row.names(x@ringobj)
	if (!is.null(x@polyobj)) ans$polygons = row.names(x@polyobj)
	
	return(ans)
})

library(testthat)
library(rgeos)

setScale()

context("Translate Rings")

test_that("translate linear ring", {

    lr1 = readWKT("LINEARRING (1 1, 1 2, 2 2, 2 1, 1 1)")
    lr2 = readWKT("LINEARRING (1 1, 2 1, 2 2, 1 2, 1 1)")
    gclr1 = readWKT("GEOMETRYCOLLECTION( LINEARRING (1 1, 1 2, 2 2, 2 1, 1 1), LINEARRING (1 1, 1 2, 2 2, 2 1, 1 1) )")
    gclr2 = readWKT("GEOMETRYCOLLECTION( LINEARRING (1 1, 1 2, 2 2, 2 1, 1 1), LINEARRING (1 1, 2 1, 2 2, 1 2, 1 1) )")
    gclr3 = readWKT("GEOMETRYCOLLECTION( LINEARRING (1 1, 2 1, 2 2, 1 2, 1 1), LINEARRING (1 1, 2 1, 2 2, 1 2, 1 1) )")
    
    Ring11 = Ring(cbind( x=c(1,1,2,2,1),y=c(1,2,2,1,1) ),ID="1")
    Ring12 = Ring(cbind( x=c(1,1,2,2,1),y=c(1,2,2,1,1) ),ID="2")
    Ring21 = Ring(cbind( x=c(1,2,2,1,1),y=c(1,1,2,2,1) ),ID="1")
    Ring22 = Ring(cbind( x=c(1,2,2,1,1),y=c(1,1,2,2,1) ),ID="2")
    
    splr1   = SpatialRings( list(Ring11) ); #rownames(splr1@bbox) = c("x","y")
    splr2   = SpatialRings( list(Ring21) ); #rownames(splr2@bbox) = c("x","y")
    spgclr1 = SpatialRings( list(Ring11,Ring12) ); #rownames(spgclr1@bbox) = c("x","y")
    spgclr2 = SpatialRings( list(Ring11,Ring22) ); #rownames(spgclr2@bbox) = c("x","y")
    spgclr3 = SpatialRings( list(Ring21,Ring22) ); #rownames(spgclr3@bbox) = c("x","y")
    

    expect_that( lr1  , is_identical_to(splr1) )
    expect_that( lr2  , is_identical_to(splr2) )
    expect_that( gclr1, is_identical_to(spgclr1) )
    expect_that( gclr2, is_identical_to(spgclr2) )
    expect_that( gclr3, is_identical_to(spgclr3) )
    
    expect_that( splr1  , is_identical_to( translate(splr1)))
    expect_that( splr2  , is_identical_to( translate(splr2)))
    expect_that( spgclr1, is_identical_to( translate(spgclr1)))
    expect_that( spgclr2, is_identical_to( translate(spgclr2)))
    expect_that( spgclr3, is_identical_to( translate(spgclr3)))
    
    expect_that( lr1  , is_identical_to( translate(lr1) ))
    expect_that( lr2  , is_identical_to( translate(lr2) ))
    expect_that( gclr1, is_identical_to( translate(gclr1) ))
    expect_that( gclr2, is_identical_to( translate(gclr2) ))
    expect_that( gclr3, is_identical_to( translate(gclr3) ))

})

suppressPackageStartupMessages(library(rgeos))
# g1 is invalid
g1 <- readWKT('POLYGON((0 0, 10 10, 0 10, 10 0, 0 0))')
g2 <- readWKT('POLYGON((2 2, 8 2, 8 8, 2 8, 2 2))')

# binary operators
try(g3 <- gUnion(g1, g2))
try(g3 <- gDifference(g1, g2))
try(g3 <- gIntersection(g1, g2))
try(g3 <- gSymdifference(g1, g2))

# unary operators
try(g3 <- gSimplify(g1, tol=0.1))
try(g3 <- gPolygonize(list(as(g1, "SpatialLines"))))
try(g3 <- gEnvelope(g1))
try(g3 <- gConvexHull(g1))
try(g3 <- gBoundary(g1))
try(g3 <- gCentroid(g1))
try(g3 <- gPointOnSurface(g1))

# binary predicates
try(res <- gContains(g1, g2))
try(res <- gIntersects(g1, g2))
try(res <- gContainsProperly(g1, g2))
try(res <- gCovers(g1, g2))
try(res <- gCoveredBy(g1, g2))
try(res <- gDisjoint(g1, g2))
try(res <- gTouches(g1, g2))
try(res <- gCrosses(g1, g2))
try(res <- gWithin(g1, g2))
try(res <- gOverlaps(g1, g2))
try(res <- gEquals(g1, g2))
try(res <- gEqualsExact(g1, g2))
try(res <- gRelate(g1, g2))

# unary predicates
try(res <- gIsEmpty(g1))
try(res <- gIsSimple(g1))
try(res <- gIsRing(g1))
try(res <- gIsValid(g1))
try(res <- gIsValid(g1, reason = TRUE))

suppressPackageStartupMessages(library(rgeos))
nc34 <- readWKT(readLines(system.file("wkts/nc34.wkt", package="rgeos")))
xF <- gSimplify(nc34, tol=5, topologyPreserve=FALSE)
xT <- gSimplify(nc34, tol=5, topologyPreserve=TRUE)
# https://github.com/r-spatial/sf/issues/1655#issuecomment-826358383

RGEOSMiscFunc = function(spgeom, byid, func) {
    stopifnot(is.logical(byid))
    if (!is.na(is.projected(spgeom)) && !is.projected(spgeom))
     warning("Spatial object is not projected; GEOS expects planar coordinates")
    byid = as.logical(byid)
    if (is.na(byid)) stop("Invalid value for byid, must be logical")
    if (inherits(spgeom, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom)) 
        spgeom <- createSPComment(spgeom)
    if (func == "rgeos_area")    
        x <- .Call("rgeos_area", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else if (func == "rgeos_length")    
        x <- .Call("rgeos_length", .RGEOS_HANDLE, spgeom, byid, PACKAGE="rgeos")
    else stop("no such function:", func)

    if(byid) names(x) <- unique(row.names(spgeom))
    
    return(x)
}

gArea = function(spgeom, byid=FALSE) {
    return( RGEOSMiscFunc(spgeom,byid,"rgeos_area") )
}

gLength = function(spgeom, byid=FALSE) {
    return(RGEOSMiscFunc(spgeom,byid,"rgeos_length"))
}


RGEOSDistanceFunc = function(spgeom1, spgeom2, byid, func, densifyFrac = 1) {
    stopifnot(is.logical(byid))
    if (!is.na(is.projected(spgeom1)) && !is.projected(spgeom1))
     warning("Spatial object 1 is not projected; GEOS expects planar coordinates")
    if (!is.null(spgeom2) && !is.na(is.projected(spgeom2)) && 
        !is.projected(spgeom2))
     warning("Spatial object 2 is not projected; GEOS expects planar coordinates")
    byid = as.logical(byid)
    if (any(is.na(byid)) ) stop("Invalid value for byid, must be logical")

    if( length(byid) < 1 || length(byid) > 2 )
        stop("Invalid length for byid, must be of length 1 or 2")

    if (length(byid) == 1)
        byid <- rep(byid,2)

    if(!is.null(spgeom1) & !is.null(spgeom2)) {
        if(!identical(spgeom1@proj4string,spgeom2@proj4string))
            warning("spgeom1 and spgeom2 have different proj4 strings")
    }

    if (func == "rgeos_hausdorffdistancedensify")
        x <- .Call("rgeos_hausdorffdistancedensify", .RGEOS_HANDLE, spgeom1, spgeom2, densifyFrac, byid, PACKAGE="rgeos")
    else if (func == "rgeos_hausdorffdistance")
        x <- .Call("rgeos_hausdorffdistance", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_distance")
        x <- .Call("rgeos_distance", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else stop("no such function:", func)

    
    if(any(byid)) {
        id1 = row.names(spgeom1) 
        if (is.null(spgeom2))
            id2 = id1
        else 
            id2 = row.names(spgeom2)
        
        if (length(id1) == ncol(x)) colnames(x) = id1
        if (length(id2) == nrow(x)) rownames(x) = id2
    }

    return(x)
} 

gDistance = function(spgeom1, spgeom2=NULL, byid=FALSE, hausdorff=FALSE, densifyFrac = NULL) {
	if (hausdorff) {
		if(is.null(densifyFrac)) {
			return( RGEOSDistanceFunc(spgeom1, spgeom2, byid, "rgeos_hausdorffdistance") )
		} else {
			if (!is.numeric(densifyFrac))
		        stop("densifyFrac must be numeric")

		    if (densifyFrac > 1 | densifyFrac <= 0)
		        stop("densifyFrac must be in the range (0,1]")

		    return( RGEOSDistanceFunc(spgeom1, spgeom2, byid, "rgeos_hausdorffdistancedensify", densifyFrac) )
		}
	} else {
    	return( RGEOSDistanceFunc(spgeom1, spgeom2, byid, "rgeos_distance") )
	}
}

gWithinDistance = function(spgeom1, spgeom2=NULL, dist, byid=FALSE, hausdorff=FALSE, densifyFrac=NULL) {
    #TODO - include a tolerance?
    return( gDistance(spgeom1,spgeom2,byid, hausdorff, densifyFrac) <= dist )
}


gTopoDim <- function(obj) {
    td <- NULL
    if (inherits(obj, "SpatialPolygons")) td <- 2L
    if (inherits(obj, "SpatialRings")) td <- 2L
    if (inherits(obj, "SpatialLines")) td <- 1L
    if (inherits(obj, "SpatialPoints")) td <- 0L
    if (is.null(td)) stop("class not supported:", class(obj))
    td
}


#' Closest Points of two Geometries
#'
#' Return closest points of two geometries.
#'
#' @param spgeom1,spgeom2 sp objects as defined in package sp.
#' @return The closest points of the two geometries or NULL on exception.
#'   The first point comes from spgeom1 geometry and the second point comes
#'   from spgeom2.
#' @seealso gDistance
#' @rdname misc-gNearestPoints
#' @author Rainer Stuetz
#' @keywords spatial
#' @examples
#' g1 <- readWKT("MULTILINESTRING((34 54, 60 34), (0 10, 50 10, 100 50))")
#' g2 <- readWKT("MULTIPOINT(30 0, 100 30)")
#' plot(g1, pch=4, axes=TRUE)
#' plot(g2, add=TRUE)
#' plot(gNearestPoints(g1, g2), add=TRUE, col="red", pch=7)
#' gDistance(g1, g2)
#' @export
gNearestPoints <- function(spgeom1, spgeom2) {


    if (version_GEOS0() < "3.4.0")
        stop("No NearestPoints in this version of GEOS")

  stopifnot(identical(proj4string(spgeom1), proj4string(spgeom2)))

  x <- .Call("rgeos_nearestpoints", .RGEOS_HANDLE, spgeom1, spgeom2,
             PACKAGE="rgeos")
  if (!is.null(x)) {
    rownames(x) <- seq_len(nrow(x))
    SpatialPoints(x, proj4string=CRS(proj4string(spgeom1)))
  } else {
    x
  }
}


#Deprecated function names
RGEOSArea = function(spgeom, byid=FALSE) {
    .Deprecated("gArea")
    return( gArea(spgeom, byid) )
}
RGEOSLength = function(spgeom, byid=FALSE) {
    .Deprecated("gLength")
    return( gLength(spgeom, byid) )
}
RGEOSDistance = function(spgeom1, spgeom2=NULL, byid=FALSE) {
    .Deprecated("gDistance")
    return( gDistance(spgeom1, spgeom2, byid) )
}
RGEOSisWithinDistance = function(spgeom1, spgeom2=NULL, dist, byid=FALSE) {
    .Deprecated("gWithinDistance")
    return( gWithinDistance(spgeom1, spgeom2, dist, byid) )
}
RGEOSHausdorffDistance = function(spgeom1, spgeom2=NULL, byid=FALSE) {
    .Deprecated("gDistance")
    return( gDistance(spgeom1, spgeom2, byid, TRUE) )
}

library("testthat")
library("rgeos")
library("sp")


context("Misc - gNearestPoints")

coord <- function(x) unname(coordinates(x))


test_that("gNearestPoints works with different geometries as inputs", {

  g1 <- readWKT("POINT(0 0)")
  g2 <- readWKT("POINT(10 0)")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(0 0, 10 0)")))
  expect_identical(gDistance(g1, g2), 10)


  g1 <- readWKT("POINT(0 0)")
  g2 <- readWKT("MULTIPOINT(10 0, 50 30)")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(0 0, 10 0)")))
  expect_identical(gDistance(g1, g2), 10)


  g1 <- readWKT("POINT(3 0)")
  g2 <- readWKT("LINESTRING(0 10, 50 10, 100 50)")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(3 0, 3 10)")))
  expect_identical(gDistance(g1, g2), 10)


  g1 <- readWKT("POINT(3 0)")
  g2 <- readWKT("MULTILINESTRING((34 54, 60 34), (0 10, 50 10, 100 50))")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(3 0, 3 10)")))
  expect_identical(gDistance(g1, g2), 10)


  g1 <- readWKT("POINT(35 60)")
  g2 <- readWKT("POLYGON((34 54, 60 34, 60 54, 34 54),
                         (50 50, 52 50, 52 48, 50 48, 50 50))")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(35 60, 35 54)")))
  expect_identical(gDistance(g1, g2), 6)


  g1 <- readWKT("POINT(35 60)")
  g2 <- readWKT("MULTIPOLYGON(((34 54, 60 34, 60 54, 34 54),
                               (50 50, 52 50, 52 48, 50 48, 50 50)),
                              ((100 100, 150 100, 150 150, 100 150, 100 100),
                               (120 120, 120 130, 130 130, 130 120, 120 120))))")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(35 60, 35 54)")))
  expect_identical(gDistance(g1, g2), 6)


  g1 <- readWKT("MULTIPOINT(10 0, 50 30)")
  g2 <- readWKT("POINT(10 0)")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(10 0, 10 0)")))
  expect_identical(gDistance(g1, g2), 0)


  g1 <- readWKT("MULTIPOINT(10 0, 50 30)")
  g2 <- readWKT("MULTIPOINT(0 0, 150 30)")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(10 0, 0 0)")))
  expect_identical(gDistance(g1, g2), 10)


  g1 <- readWKT("MULTIPOINT(3 0, 200 30)")
  g2 <- readWKT("LINESTRING(0 10, 50 10, 100 50)")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(3 0, 3 10)")))
  expect_identical(gDistance(g1, g2), 10)


  g1 <- readWKT("MULTIPOINT(3 0, 200 30)")
  g2 <- readWKT("LINESTRING(0 10, 50 10, 100 50)")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(3 0, 3 10)")))
  expect_identical(gDistance(g1, g2), 10)


  g1 <- readWKT("MULTIPOINT(3 0, -50 30)")
  g2 <- readWKT("MULTILINESTRING((34 54, 60 34), (0 10, 50 10, 100 50))")
  expect_identical(coord(gNearestPoints(g1, g2)),
                   coord(readWKT("MULTIPOINT(3 0, 3 10)")))
  expect_identical(gDistance(g1, g2), 10)


  # empty geometry
  dat <- data.frame(x = 1)
  g1 <- SpatialPointsDataFrame(rgeos::readWKT("POINT(0 0)"), dat)
  g2 <- SpatialLinesDataFrame(readWKT("LINESTRING (-1 0, 1 0)"), dat)
  expect_null(gNearestPoints(subset(g1, x > 1), g2))
})

order_relations = function(rel, minDimension) {
	stopifnot(minDimension %in% 0:2)
	rel = sapply(rel, function(x)
			paste0(substring(x, c(1,4),c(2,5)), collapse=""))
		# our interest is in chars
		# 1-2 = inner of x with inner/border of y
		# 4-5 = border of x with inner/border of y
	ret = vector("numeric", length(rel)) * NA
	for (d in minDimension:2) {
		r = regexpr(as.character(d), rel, fixed = TRUE)
		sel = which(r != -1)
		if (length(sel) > 0)
			ret[sel] = 4 - r[sel] + 4 * d
	}
	order(ret, decreasing = TRUE, na.last = NA)
}

listifyMatrix = function(x) { # put columns in list elements
	if (!is.list(x)) {
		if (length(x) == 0)
			return(list(x))
		if (!is.matrix(x)) { # vector!
			nm = names(x)
			x = matrix(x, 1, length(x))
		} else
			nm = dimnames(x)[[2]]
		x = lapply(1:ncol(x), function(i) x[,i])
		names(x) = nm
	}
	x
}

overGeomGeom = function(x, y, returnList = FALSE, fn = NULL, ..., minDimension = -1) {
	stopifnot(identicalCRS(x, y))
	if (gridded(x))
		x = as(x, "SpatialPolygons")
	if (gridded(y))
		y = as(y, "SpatialPolygons")

	if (minDimension %in% 0:2)
		ret = apply(gRelate(x, y, byid = TRUE), 2, order_relations, minDimension = minDimension)
	else
		ret = apply(gIntersects(x, y, byid = TRUE), 2, which)
	ret = listifyMatrix(ret) # if not already list, create one now
	if (! returnList) # pick first, or NA if length is 0:
		sapply(ret, function(x) (x)[1])
	else 
		ret
}

# taken from: overDFGeneric in sp; 
# if modified here, consider modifying there as well!
overGeomGeomDF = function(x, y, returnList = FALSE, fn = NULL, ..., minDimension = -1) {
    r = overGeomGeom(x, y, returnList = TRUE, minDimension = minDimension)
    #ret = sp:::.overDF(r, y@data, length(x), returnList, fn, ...)
	#  length(x) differs from length(r) in case of SpatialMultiPoints!!!
	#  reason to change is sp::overMultiPoints
    ret = overDF_for_rgeos(r, y@data, length(r), returnList, fn, ...)
    if (!returnList)
        row.names(ret) = row.names(r)
    ret
}

#setMethod("over",
#    signature(x = "SpatialPoints", y = "SpatialPolygons"),
#	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialPoints", y = "SpatialLines"),
	        overGeomGeom)
#setMethod("over",
#    signature(x = "SpatialPoints", y = "SpatialPoints"),
#	        overGeomGeom)
#setMethod("over",
#    signature(x = "SpatialPolygons", y = "SpatialPoints"),
#	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialPolygons", y = "SpatialLines"),
	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialPolygons", y = "SpatialPolygons"),
	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialPoints"),
	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialPolygons"),
	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialLines"),
	        overGeomGeom)

# all with DataFrame:
#setMethod("over",
#    signature(x = "SpatialPoints", y = "SpatialPolygonsDataFrame"),
#	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialPoints", y = "SpatialLinesDataFrame"),
	        overGeomGeomDF)
#setMethod("over",
#    signature(x = "SpatialPoints", y = "SpatialPointsDataFrame"),
#	        overGeomGeomDF)
#setMethod("over",
#    signature(x = "SpatialPolygons", y = "SpatialPointsDataFrame"),
#	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialPolygons", y = "SpatialLinesDataFrame"),
	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialPolygons", y = "SpatialPolygonsDataFrame"),
	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialPointsDataFrame"),
	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialPolygonsDataFrame"),
	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialLinesDataFrame"),
	        overGeomGeomDF)

# lines & grids:
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialPixels"),
	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialGrid"),
	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialPixelsDataFrame"),
	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialLines", y = "SpatialGridDataFrame"),
	        overGeomGeomDF)
setMethod("over",
    signature(x = "SpatialPixels", y = "SpatialLines"),
	        overGeomGeom)
setMethod("over",
    signature(x = "SpatialGrid", y = "SpatialLinesDataFrame"),
	        overGeomGeomDF)

source("process_testxml.R")

# xml files to skip
fileSkip = c("TestValid2.xml","ExternalRobustness.xml","TestRobustOverlayFloat.xml","TestRobustOverlayFixed.xml")

# tests to skip
descSkip = c(# TestFunctionLAPrec.xml
             "LA - line and sliver intersecting, dimensional collapse",
             # TestFunctionAAPrec.xml
             "AA - intersecting slivers, dimensional collapse",
             "AA - sliver triangle with multiple intersecting boxes",
             "AA - sliver triangles, at angle to each other",
             "AA - B sliver crossing A triangle in line segment with length < 1",
             "AA - A hole close to shell, B coincident with A",
             "AA - hole close to shell, B coincident with A",
             "AA - sliver triangle, cut by polygon",
             "AA - polygon with outward sliver, cut by polygon",
             "AA - hole close to shell",
             "AA - A sliver triangle cutting all the way across B",
             "AA - A polygon with sliver cutting all the way across B",
             "AA - B hole close to shell, A coincident with B",
             # TestInteriorPoint.xml
             "L - linestring with single segment")

xmldir = 'tests/testxml'
testdirs = list.files(system.file(xmldir,package="rgeos"))

for (d in testdirs) {
    testfiles = list.files(system.file(file.path(xmldir,d),package="rgeos")) 
    
    for (f in testfiles)  {

        # files to skip
        if (f %in% fileSkip)
            next

        xmlfile =  system.file(file.path(xmldir,d,f),package="rgeos")

        n = which(f==testfiles)
        total = length(testfiles)
        
        process_testxml(xmlfile, n, total, descSkip)
    }
}

RGEOSBinPredFunc = function(spgeom1, spgeom2, byid, func, optparam=NULL) {
    stopifnot(is.logical(byid))
    byid = as.logical(byid)
    if (any(is.na(byid)) ) stop("Invalid value for byid, must be logical")

    if( length(byid) < 1 || length(byid) > 2 )
        stop("Invalid length for byid, must be of length 1 or 2")

    if (length(byid) == 1)
        byid <- rep(byid,2)

    if (is.null(spgeom2) && inherits(spgeom1, "SpatialPolygons") 
        && get_do_poly_check() && notAllComments(spgeom1)) 
        spgeom1 <- createSPComment(spgeom1)

    if(!is.null(spgeom1) & !is.null(spgeom2)) {
        if(!identical(spgeom1@proj4string,spgeom2@proj4string))
            warning("spgeom1 and spgeom2 have different proj4 strings")
        if (inherits(spgeom1, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom1)) 
            spgeom1 <- createSPComment(spgeom1)
        if (inherits(spgeom2, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom2)) 
            spgeom2 <- createSPComment(spgeom2)
    }
	
    if ( func == "rgeos_equalsexact" )         
        x <- .Call("rgeos_equalsexact", .RGEOS_HANDLE, spgeom1, spgeom2, optparam, byid, PACKAGE="rgeos")
    else if (func == "rgeos_relatepattern")
        x <- .Call("rgeos_relatepattern", .RGEOS_HANDLE, spgeom1, spgeom2, optparam, byid, PACKAGE="rgeos")
    else if (func == "rgeos_contains")
        x <- .Call("rgeos_contains", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_contains_prepared")
        x <- .Call("rgeos_contains_prepared", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_intersects")
        x <- .Call("rgeos_intersects", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_intersects_prepared")
        x <- .Call("rgeos_intersects_prepared", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_containsproperly_prepared")
        x <- .Call("rgeos_containsproperly_prepared", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_covers_prepared")
        x <- .Call("rgeos_covers_prepared", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_disjoint")
        x <- .Call("rgeos_disjoint", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_touches")
        x <- .Call("rgeos_touches", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_crosses")
        x <- .Call("rgeos_crosses", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_within")
        x <- .Call("rgeos_within", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_overlaps")
        x <- .Call("rgeos_overlaps", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_equals")
        x <- .Call("rgeos_equals", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else if (func == "rgeos_relate")
        x <- .Call("rgeos_relate", .RGEOS_HANDLE, spgeom1, spgeom2, byid, PACKAGE="rgeos")
    else stop("No such function:", func)    
    if(any(byid)) {
        id1 = unique(row.names(spgeom1))
        if (!get_RGEOS_DENSE()) {
            if (length(id1) == length(x)) names(x) <- id1
        } else {
# Michael Chirico bug report and fix 2019-08-16
            if (byid[1L]) colnames(x) <- id1
            if (byid[2L]) {
                if (is.null(spgeom2)) id2 <- id1
                else id2 <- unique(row.names(spgeom2))
                rownames(x) <- id2
            } 
            
#            if (is.null(spgeom2)) id2 = id1
#            else id2 = unique(row.names(spgeom2))
#            colnames(x) <- id1
#            rownames(x) <- id2
        }
    }
    
    return(x)
}



gContains = function(spgeom1, spgeom2 = NULL, byid = FALSE, prepared=TRUE, returnDense=TRUE, STRsubset=FALSE, checkValidity=FALSE) {
    stopifnot(is.logical(STRsubset))
    stopifnot(length(STRsubset)==1)
    oSTRsubset <- get_RGEOS_STR()
    set_RGEOS_STR(STRsubset)
    if (STRsubset) returnDense=FALSE
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    func = "rgeos_contains"
    if (prepared)
		func = paste(func,"_prepared",sep="")

    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,func)
    set_RGEOS_DENSE(oreturnDense)
    set_RGEOS_STR(oSTRsubset)
    res
}
gIntersects = function(spgeom1, spgeom2 = NULL, byid = FALSE, prepared=TRUE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    func = "rgeos_intersects"
    if (prepared)
		func = paste(func,"_prepared",sep="")

    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,func)
    set_RGEOS_DENSE(oreturnDense)
    res
}

gContainsProperly = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_containsproperly_prepared")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gCovers = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_covers_prepared")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gCoveredBy = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom2,spgeom1,rev(byid),"rgeos_covers_prepared")
    set_RGEOS_DENSE(oreturnDense)
    res
}


gDisjoint = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_disjoint")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gTouches = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_touches")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gCrosses = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_crosses")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gWithin = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_within")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gOverlaps = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_overlaps")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gEquals = function(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_equals")
    set_RGEOS_DENSE(oreturnDense)
    res
}

gEqualsExact = function(spgeom1, spgeom2 = NULL, tol=0.0, byid = FALSE, returnDense=TRUE, checkValidity=FALSE) {
    stopifnot(is.logical(returnDense))
    stopifnot(length(returnDense)==1)
    oreturnDense <- get_RGEOS_DENSE()
    set_RGEOS_DENSE(returnDense)
    tol <- as.numeric(tol)
    if ( is.na(tol) ) 
        stop("Invalid value for tolerance, must be numeric")

    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
    res <- RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_equalsexact", tol)
    set_RGEOS_DENSE(oreturnDense)
    res
}

gRelate = function(spgeom1, spgeom2 = NULL, pattern = NULL, byid = FALSE, checkValidity=FALSE) {
    
    if(checkValidity) {
        val1 <- gIsValid(spgeom1)
        val2 <- gIsValid(spgeom2)
        if (!val1) message(deparse(substitute(spgeom1)), " is invalid")
        if (!val2) message(deparse(substitute(spgeom2))," is invalid")
        if (!all(c(val1, val2))) stop("Invalid objects found")
    }
    
	if (is.null(pattern)) {
		return( RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_relate") )
	} else {
		if ( !is.character(pattern) )
			stop("Invalid value for pattern, must be character")
		pattern = toupper(pattern)
		
	    if (length(pattern) != 1)
	        stop("Pattern must have length of 1")
    
	    if (nchar(pattern) != 9 || !grepl("[0-2TF\\*]{9}",pattern) )
	        stop("Invalid pattern, see documentation for proper format")
    
		return( RGEOSBinPredFunc(spgeom1,spgeom2,byid,"rgeos_relatepattern",pattern) )
	}
}





RGEOSDisjoint = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gDisjoint")
    return( gDisjoint(spgeom1,spgeom2, byid) )
}
RGEOSTouches = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gTouches")
    return( gTouches(spgeom1,spgeom2, byid) )
}
RGEOSIntersects = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gIntersects")
    return( gIntersects(spgeom1,spgeom2, byid) )
}
RGEOSCrosses = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gCrosses")
    return( gCrosses(spgeom1,spgeom2, byid) )
}
RGEOSWithin = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gWithin")
    return( gWithin(spgeom1,spgeom2, byid) )
}
RGEOSContains = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gContains")
    return( gContains(spgeom1,spgeom2, byid) )
}
RGEOSOverlaps = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gOverlaps")
    return( gOverlaps(spgeom1,spgeom2, byid) )
}
RGEOSEquals = function(spgeom1, spgeom2 = NULL, byid = FALSE) {
    .Deprecated("gEquals")
    return( gEquals(spgeom1,spgeom2, byid) )
}
RGEOSEqualsExact = function(spgeom1, spgeom2 = NULL, tol=0.0, byid = FALSE) {
    .Deprecated("gEqualsExact")
    return( gEqualsExact(spgeom1, spgeom2, byid, tol) )
}
RGEOSRelate = function(spgeom1, spgeom2 = NULL, pattern = NULL, byid = FALSE) {
    .Deprecated("gRelate")
    return( gRelate(spgeom1,spgeom2, byid, pattern) )
}

RGEOSBinTopoFunc = function(spgeom1, spgeom2, byid, ids=NULL, drop_lower_td=FALSE, unaryUnion_if_byid_false=TRUE, func) {
  .Deprecated("", package="rgeos", msg="GEOS support is provided by the sf and terra packages among others")
    stopifnot(is.logical(byid))
    stopifnot(is.logical(drop_lower_td))
    stopifnot(length(drop_lower_td) == 1)
    stopifnot(is.logical(unaryUnion_if_byid_false))
    stopifnot(length(unaryUnion_if_byid_false) == 1)
    byid = as.logical(byid)
    if (any(is.na(byid)) ) 
        stop("Invalid value for byid, must be logical")
    if (!length(byid) %in% c(1,2))
        stop("Invalid length for byid, must be of length 1 or 2")
    if (length(byid) == 1)
        byid <- rep(byid,2)

    if (missing(spgeom1) | missing(spgeom2))
        stop("spgeom1 and spgeom2 must both be specified")
        
    if(!identical(spgeom1@proj4string,spgeom2@proj4string))
        warning("spgeom1 and spgeom2 have different proj4 strings")

    if (inherits(spgeom1, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom1))
        spgeom1 <- createSPComment(spgeom1)
    if (inherits(spgeom2, "SpatialPolygons") && get_do_poly_check() && notAllComments(spgeom2)) 
        spgeom2 <- createSPComment(spgeom2)
    id1 = row.names(spgeom1) 
    id2 = row.names(spgeom2)    
    if(all(byid)) {
        if (is.null(ids)) ids = paste(rep(id1,each=length(id2)),rep(id2,length(id1)))
        idlen = length(id1)*length(id2)
    } else if (byid[1]) {
        if (is.null(ids)) ids = id1
        idlen = length(id1)
    } else if (byid[2]) {
        if (is.null(ids)) ids = id2
        idlen = length(id2)
    } else {
        if (is.null(ids)) ids = "1"
        idlen = 1
    }
    
    if (idlen != length(ids))
        stop(paste("ids vector has incorrect length of",length(ids),"expected length of",idlen))
#    oboth_poly <- get("both_poly", envir=.RGEOS_HANDLE)
#    odrop_not_poly <- get("drop_not_poly", envir=.RGEOS_HANDLE)
#    both_poly <-(inherits(spgeom1, "SpatialPolygons") &&
#        inherits(spgeom2, "SpatialPolygons"))
#    assign("both_poly", (inherits(spgeom1, "SpatialPolygons") &&
#        inherits(spgeom2, "SpatialPolygons")), envir=.RGEOS_HANDLE)
#    if (drop_not_poly) assign("drop_not_poly", drop_not_poly, envir=.RGEOS_HANDLE)

    tds <- c(gTopoDim(spgeom1), gTopoDim(spgeom2))
    min_tds <- as.integer(min(tds))
    attr(byid, "min_tds") <- min_tds
    attr(byid, "drop_lower_td") <- drop_lower_td
    attr(byid, "unaryUnion_if_byid_false") <- unaryUnion_if_byid_false
    if (func == "rgeos_difference")
        x <- .Call("rgeos_difference", .RGEOS_HANDLE, spgeom1, spgeom2, byid, ids, PACKAGE="rgeos")
    else if (func == "rgeos_symdifference")
        x <- .Call("rgeos_symdifference", .RGEOS_HANDLE, spgeom1, spgeom2, byid, ids, PACKAGE="rgeos")
    else if (func == "rgeos_intersection")
        x <- .Call("rgeos_intersection", .RGEOS_HANDLE, spgeom1, spgeom2, byid, ids, PACKAGE="rgeos")
    else if (func == "rgeos_union")
        x <- .Call("rgeos_union", .RGEOS_HANDLE, spgeom1, spgeom2, byid, ids, PACKAGE="rgeos")
    else stop("no such function:", func)

#    assign("both_poly", oboth_poly, envir=.RGEOS_HANDLE)
#    assign("drop_not_poly", odrop_not_poly, envir=.RGEOS_HANDLE)

    return(x)
}

gDifference = function(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_lower_td=FALSE, unaryUnion_if_byid_false=TRUE, checkValidity=NULL) {
    if (is.null(checkValidity)) checkValidity <- get_RGEOS_CheckValidity()
    if(checkValidity > 0L) {
        val1 <- isTRUE(all(gIsValid(spgeom1, byid=TRUE)))
        val2 <- isTRUE(all(gIsValid(spgeom2, byid=TRUE)))
        nm_1 <- deparse(substitute(spgeom1))
        nm_2 <- deparse(substitute(spgeom2))
        if (!val1) message(nm_1, " is invalid")
        if (!val2) message(nm_2," is invalid")
        if (checkValidity == 1L && !all(c(val1, val2))) warning("Invalid objects found; consider using set_RGEOS_CheckValidity(2L)")
        if (checkValidity == 2L) {
            if (!val1) {
                spgeom1 <- gBuffer(spgeom1, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_1, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom1, byid=TRUE)))) stop("Zero width buffer repair of spgeom1 failed")
            }
            if (!val2) {
                spgeom2 <- gBuffer(spgeom2, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_2, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom2, byid=TRUE)))) stop("Zero width buffer repair of spgeom2 failed")
            }
        }
    }
    
    return( RGEOSBinTopoFunc(spgeom1, spgeom2, byid, id, drop_lower_td,
        unaryUnion_if_byid_false, "rgeos_difference") )
}

gSymdifference = function(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_lower_td=FALSE, unaryUnion_if_byid_false=TRUE, checkValidity=NULL) {
    if (is.null(checkValidity)) checkValidity <- get_RGEOS_CheckValidity()
    if(checkValidity > 0L) {
        val1 <- isTRUE(all(gIsValid(spgeom1, byid=TRUE)))
        val2 <- isTRUE(all(gIsValid(spgeom2, byid=TRUE)))
        nm_1 <- deparse(substitute(spgeom1))
        nm_2 <- deparse(substitute(spgeom2))
        if (!val1) message(nm_1, " is invalid")
        if (!val2) message(nm_2," is invalid")
        if (checkValidity == 1L && !all(c(val1, val2))) warning("Invalid objects found; consider using set_RGEOS_CheckValidity(2L)")
        if (checkValidity == 2L) {
            if (!val1) {
                spgeom1 <- gBuffer(spgeom1, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_1, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom1, byid=TRUE)))) stop("Zero width buffer repair of spgeom1 failed")
            }
            if (!val2) {
                spgeom2 <- gBuffer(spgeom2, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_2, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom2, byid=TRUE)))) stop("Zero width buffer repair of spgeom2 failed")
            }
        }
    }
    
    return( RGEOSBinTopoFunc(spgeom1, spgeom2, byid, id, drop_lower_td,
        unaryUnion_if_byid_false, "rgeos_symdifference") )
}

gIntersection = function(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_not_poly, drop_lower_td=FALSE, unaryUnion_if_byid_false=TRUE, checkValidity=NULL) {
    if (!missing(drop_not_poly)) {
        warning("drop_not_poly argument name deprecated, use drop_lower_td")
        drop_lower_td <- drop_not_poly
    }
    if (is.null(checkValidity)) checkValidity <- get_RGEOS_CheckValidity()
    if(checkValidity > 0L) {
        val1 <- isTRUE(all(gIsValid(spgeom1, byid=TRUE)))
        val2 <- isTRUE(all(gIsValid(spgeom2, byid=TRUE)))
        nm_1 <- deparse(substitute(spgeom1))
        nm_2 <- deparse(substitute(spgeom2))
        if (!val1) message(nm_1, " is invalid")
        if (!val2) message(nm_2," is invalid")
        if (checkValidity == 1L && !all(c(val1, val2))) warning("Invalid objects found; consider using set_RGEOS_CheckValidity(2L)")
        if (checkValidity == 2L) {
            if (!val1) {
                spgeom1 <- gBuffer(spgeom1, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_1, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom1, byid=TRUE)))) stop("Zero width buffer repair of spgeom1 failed")
            }
            if (!val2) {
                spgeom2 <- gBuffer(spgeom2, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_2, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom2, byid=TRUE)))) stop("Zero width buffer repair of spgeom2 failed")
            }
        }
    }
    
    return( RGEOSBinTopoFunc(spgeom1, spgeom2, byid, id, drop_lower_td,
        unaryUnion_if_byid_false, "rgeos_intersection") )
}

gUnion = function(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_lower_td=FALSE, unaryUnion_if_byid_false=TRUE, checkValidity=NULL) {
    if (is.null(checkValidity)) checkValidity <- get_RGEOS_CheckValidity()
    if(checkValidity > 0L) {
        val1 <- isTRUE(all(gIsValid(spgeom1, byid=TRUE)))
        val2 <- isTRUE(all(gIsValid(spgeom2, byid=TRUE)))
        nm_1 <- deparse(substitute(spgeom1))
        nm_2 <- deparse(substitute(spgeom2))
        if (!val1) message(nm_1, " is invalid")
        if (!val2) message(nm_2," is invalid")
        if (checkValidity == 1L && !all(c(val1, val2))) warning("Invalid objects found; consider using set_RGEOS_CheckValidity(2L)")
        if (checkValidity == 2L) {
            if (!val1) {
                spgeom1 <- gBuffer(spgeom1, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_1, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom1, byid=TRUE)))) stop("Zero width buffer repair of spgeom1 failed")
            }
            if (!val2) {
                spgeom2 <- gBuffer(spgeom2, byid=TRUE, width=0.0)
                message("Attempting to make ", nm_2, " valid by zero-width buffering")
                if (!isTRUE(all(gIsValid(spgeom2, byid=TRUE)))) stop("Zero width buffer repair of spgeom2 failed")
            }
        }
    }
    
    return( RGEOSBinTopoFunc(spgeom1, spgeom2, byid, id, drop_lower_td,
        unaryUnion_if_byid_false, "rgeos_union") )
}

bbox2SP <- function(n, s, w ,e ,bbox=NA, proj4string=CRS("+init=epsg:4326")){
  if (all(!is.na(bbox), is.matrix(bbox), dim(bbox)==c(2,2))) {
      n<-bbox[2,2]
      s<-bbox[2,1]
      w<-bbox[1,1]
      e<-bbox[1,2]
    }
  box1 <- matrix(c(w, s, w, n, e, n, e, s, w, s), ncol=2, byrow=TRUE)
  box1 <- SpatialPolygons(list(Polygons(list(Polygon(box1)),ID=1)),
      proj4string=proj4string)
  box1
}

.RGEOS_HANDLE <- new.env(FALSE, parent=globalenv())

set_RGEOS_HANDLE <- function(handle) {
    assign("GEOSptr", handle, envir=.RGEOS_HANDLE)
}

set_RGEOS_DENSE <- function(value) {
    stopifnot(is.logical(value))
    stopifnot(length(value) == 1)
    assign("returnDense", value, envir=.RGEOS_HANDLE)
}

get_RGEOS_DENSE <- function() {
    get("returnDense", envir=.RGEOS_HANDLE)
}

set_RGEOS_dropSlivers <- function(value) {
    stopifnot(is.logical(value))
    stopifnot(length(value) == 1)
    assign("dropSlivers", value, envir=.RGEOS_HANDLE)
}

get_RGEOS_dropSlivers <- function() {
    get("dropSlivers", envir=.RGEOS_HANDLE)
}

set_RGEOS_warnSlivers <- function(value) {
    stopifnot(is.logical(value))
    stopifnot(length(value) == 1)
    assign("warnSlivers", value, envir=.RGEOS_HANDLE)
}

get_RGEOS_warnSlivers <- function() {
    get("warnSlivers", envir=.RGEOS_HANDLE)
}

set_RGEOS_polyThreshold <- function(value) {
    stopifnot(is.numeric(value))
    stopifnot(length(value) == 1)
    stopifnot(value >= 0.0)
    assign("polyThreshold", value, envir=.RGEOS_HANDLE)
}

get_RGEOS_polyThreshold <- function() {
    get("polyThreshold", envir=.RGEOS_HANDLE)
}

set_RGEOS_CheckValidity <- function(value) {
    stopifnot(is.integer(value))
    stopifnot(length(value) == 1)
    stopifnot(value >= 0L && value < 3L)
    assign("CheckValidity", value, envir=.RGEOS_HANDLE)
}

get_RGEOS_CheckValidity <- function() {
    get("CheckValidity", envir=.RGEOS_HANDLE)
}

set_RGEOS_STR <- function(value) {
    stopifnot(is.logical(value))
    stopifnot(length(value) == 1)
    assign("STRsubset", value, envir=.RGEOS_HANDLE)
}

get_RGEOS_STR <- function() {
    get("STRsubset", envir=.RGEOS_HANDLE)
}



init_RGEOS <- function() {
    .Call('rgeos_Init', PACKAGE="rgeos")
}

finish_RGEOS <- function() {
    .Call('rgeos_finish', .RGEOS_HANDLE, PACKAGE="rgeos")
}

version_GEOS <- function(runtime=TRUE) {
    stopifnot(is.logical(runtime))
    stopifnot(length(runtime) == 1L)
    res0 <- .Call("rgeos_GEOSversion", runtime, PACKAGE="rgeos")
    res1 <- strsplit(res0, " ")[[1]]
    res <- res1[1]
    if (length(res1) > 1) attr(res, "rev") <- res1[2]
    res
}

version_GEOS0 <- function() {
#    substring(version_GEOS(), 1, 5)
    package_version(gsub("[a-zA-Z]", "", strsplit(version_GEOS(), "-")[[1]][1]))
}

version_sp_linkingTo <- function() {
    .Call("rgeos_sp_linkingTo_version")
}

.onLoad <- function(lib, pkg) {
#  require(methods, quietly = TRUE, warn.conflicts = FALSE)
#  require("sp")
#  require("stringr")
#  library.dynam('rgeos', pkg, lib)

  set_RGEOS_HANDLE(init_RGEOS())
  if (!isTRUE(all.equal(version_GEOS(TRUE), version_GEOS(FALSE),
    check.attributes=FALSE))) {
    warning("rgeos: versions of GEOS runtime ", c(version_GEOS(TRUE)),
    "\nand GEOS at installation ", version_GEOS(FALSE), "differ")
  }
  assign("scale", 100000000, envir=.RGEOS_HANDLE)
  assign("do_poly_check", TRUE, envir=.RGEOS_HANDLE)
#  assign("both_poly", FALSE, envir=.RGEOS_HANDLE)
#  assign("drop_not_poly", FALSE, envir=.RGEOS_HANDLE)
  assign("polyThreshold", 0.0, envir=.RGEOS_HANDLE)
  assign("dropSlivers", FALSE, envir=.RGEOS_HANDLE)
  assign("warnSlivers", TRUE, envir=.RGEOS_HANDLE)
  assign("returnDense", TRUE, envir=.RGEOS_HANDLE)
  assign("STRsubset", FALSE, envir=.RGEOS_HANDLE)
  cV <- ifelse(c(version_GEOS0()) < "3.7.2", 0L, 1L)
  assign("CheckValidity", cV, envir=.RGEOS_HANDLE)
}

.onAttach <- function(lib, pkg) {
  fn <- system.file("SVN_VERSION", package="rgeos")
  if (file.exists(fn)) {
    svn_version <- scan(fn, what=character(1), sep="\n", quiet=TRUE)
  } else {
    svn_version <- "(unknown)"
  }
  Smess <- paste("rgeos version: ", utils::packageDescription("rgeos")$Version,
    ", (SVN revision ", svn_version, ")\n", sep="")
  Smess <- paste(Smess, "GEOS runtime version:",
    version_GEOS(), "\n")
  Smess <- paste(Smess, "Please note that rgeos will be retired during 2023,\nplan transition to sf functions using GEOS at your earliest convenience.\n")
  if (gIsOverlayNG()) Smess <- paste(Smess, "GEOS using OverlayNG\n")
  splVersion <- version_sp_linkingTo()
  Smess <- paste(Smess, "Linking to sp version:", splVersion, "\n")
  spVcheck <- NULL
  if("sp" %in% .packages()) spVcheck <- utils::packageVersion("sp") == splVersion
  if (!is.null(spVcheck) && !spVcheck) paste(Smess, 
    "sp version used to install rgeos and loaded sp version differ\n")

  Smess <- paste(Smess, "Polygon checking:", get_do_poly_check(), "\n")
  packageStartupMessage(Smess, appendLF = TRUE)
}

.onUnload <- function(libpath) {
  invisible(finish_RGEOS())
}

rgeos_extSoftVersion <- function() {
  res <- c("GEOS"=strsplit(version_GEOS(), "-")[[1]][1], "OverlayNG"=gIsOverlayNG(), "sp"=version_sp_linkingTo())
  res
}

poly_findInBoxGEOS <- function(spl, as_points=TRUE) {
    stopifnot(is(spl, "SpatialPolygons"))
    stopifnot(is.logical(as_points))
    stopifnot(!is.na(as_points))
    pls <- slot(spl, "polygons")
    res <- .Call("rgeos_poly_findInBox", .RGEOS_HANDLE, pls, as_points,
       PACKAGE="rgeos")
    res
}

gUnarySTRtreeQuery <- function(obj) {
    if(inherits(obj, "SpatialLines")) type <- "line"
    else if(inherits(obj, "SpatialPolygons")) type <- "poly"
    else if(inherits(obj, "Polygons")) type <- "Poly"
    else stop(paste("unsupported class:", class(obj)))
    if (type == "line") lst <- slot(obj, "lines")
    else if (type == "poly") lst <- slot(obj, "polygons")
    else lst <- slot(obj, "Polygons")
    res <- .Call("rgeos_unary_STRtree_query", .RGEOS_HANDLE, lst,
        PACKAGE="rgeos")
    res
}

gBinarySTRtreeQuery <- function(obj1, obj2) {
    if(inherits(obj1, "SpatialLines")) type1 <- "line"
    else if(inherits(obj1, "SpatialPolygons")) type1 <- "poly"
    else stop(paste("unsupported class:", class(obj1)))
    if(inherits(obj2, "SpatialLines")) type2 <- "line"
    else if(inherits(obj2, "SpatialPoints")) type2 <- "pts"
    else if(inherits(obj2, "SpatialPolygons")) type2 <- "poly"
    else stop(paste("unsupported class:", class(obj2)))
    if (type1 == "line") lst1 <- slot(obj1, "lines")
    else lst1 <- slot(obj1, "polygons")
    if (type2 == "line") lst2 <- slot(obj2, "lines")
    else if (type2 == "pts") lst2 <- as(obj2, "SpatialPoints")
    else lst2 <- slot(obj2, "polygons")
    res <- .Call("rgeos_binary_STRtree_query", .RGEOS_HANDLE, lst1, lst2,
        PACKAGE="rgeos")
    res
}


set_do_poly_check <- function(value) {
  stopifnot(is.logical(value))
  stopifnot(length(value) == 1)
  assign("do_poly_check", value, envir=.RGEOS_HANDLE)
}

get_do_poly_check <- function() {
  get("do_poly_check", envir=.RGEOS_HANDLE)
}

notAllComments <- function(spgeom) {
    if (!get_do_poly_check()) return(FALSE)
    if (!inherits(spgeom, "SpatialPolygons")) return(TRUE)
    if (is.null(comment(spgeom))) return(TRUE)
    return(comment(spgeom) != "TRUE")
}


createSPComment = function(sppoly,which=NULL,overwrite=TRUE) {
    if (!inherits(sppoly, "SpatialPolygons")) 
        stop("not a SpatialPolygons object")
    if (get_do_poly_check() && notAllComments(sppoly)) { 
      if (is.null(which))
        which = 1:length(sppoly@polygons)
    
      sppoly@polygons[which] = lapply(sppoly@polygons[which], function(p) {
        
        if (!overwrite && !is.null(attr(p, "comment"))) {
            return(p)
        } else if (all(sapply(slot(p, "Polygons"), function(j)
            is.null(slot(j, "coords"))))) {
            comment(p) <- paste(rep(0, length(slot(p, "Polygons"))),
                collapse=" ")
            return(p)
        } else {
            attr(p, "comment") = createPolygonsComment(p)
            return(p)
        }
      })
      comment(sppoly) <- as.character(any(sapply(slot(sppoly, "polygons"),
                function(x) !is.null(comment(x))), na.rm=TRUE))
    }

    return(sppoly)
}

createPolygonsComment = function(poly) {
    if (!is(poly, "Polygons")) 
        stop("not a Polygons object")

    holes = sapply(poly@Polygons, function(x) x@hole)
    if (!any(holes)) {
        comm = rep(0,length(poly@Polygons))
    } else {
        comm = .Call("rgeos_PolyCreateComment", .RGEOS_HANDLE, poly@Polygons, PACKAGE="rgeos")    
    }
    
    return(paste(comm,collapse=" "))
}

getScale <- function() {
    return( mget("scale",.RGEOS_HANDLE)$scale )
}

setScale <- function(scale=100000000) {
    
    maxPreciseValue <- 9007199254740992.0
    
    if(scale > maxPreciseValue){
        stop("Specified scale is larger than maximum allowed")
    }
    
    assign("scale",scale,envir=.RGEOS_HANDLE)
}

checkP4S = function(p4s) {
    
    if ( is.null(p4s) )
        p4s = CRS(as.character(NA))

    if( is.character(p4s))
        p4s = CRS(p4s) 
    
    if (length(p4s) != 1)
        stop("proj4string must be of length 1")
    
    if ( !inherits(p4s, "CRS")) {
        stop("proj4string has invalid class")
    }
    
    return( p4s )
}

translate = function(spgeom) {
    
    rn = row.names(spgeom)
    if (!is.list(rn))
        rn = list(rn)
    
    ids = as.character( unlist( sapply(rn, unique) ) )
    x = .Call("rgeos_double_translate", .RGEOS_HANDLE, spgeom, ids, 0, PACKAGE="rgeos")
    return(x)
}

groupID = function(spgeom, ids) {
    
    if (inherits(spgeom,"SpatialCollections"))
        stop("groupID does not work with SpatialCollections objects")
        
    if (length(row.names(spgeom)) != length(ids)) 
        stop("length of ids does not match number of geometries")
    if (storage.mode(ids) != "character") ids <- as.character(ids)
    
    newids = unique(ids)
    
    if (length(row.names(spgeom)) == 1 || length(row.names(spgeom)) == length(newids) || 
        inherits(spgeom,"SpatialPoints") ) {
        
        row.names(spgeom) <- ids
        return(spgeom)
    }
    
    
    if ( inherits(spgeom,"SpatialLines")  ) {
        
        lineslist = list()
        k=1
        for (curid in newids) {

            if (is.na(curid)) next # RSB 101124
            
            linelist = list()
            l = 1
            for ( i in which(ids == curid) ){
                    
                L = length(spgeom@lines[[i]]@Lines)
                linelist[l:(l+L-1)] = spgeom@lines[[i]]@Lines
                l=l+L
            }
            
            lineslist[[k]] = Lines(linelist, curid)
            k=k+1
        }

        ans = SpatialLines(lineslist,proj4string = spgeom@proj4string)
        
    } else if ( inherits(spgeom,"SpatialPolygons") ) {
        
        polyslist = list()
        k=1
        for (curid in newids) {

            if (is.na(curid)) next # RSB 101124

            comment = c()
            polylist = list()
            l = 1
            for ( i in which(ids == curid) ){
                
                L = length(spgeom@polygons[[i]]@Polygons)
                
                comm = attr(spgeom@polygons[[i]],"comment")
                if (is.null(comm)) comm = rep(0,L)
                else comm = as.integer( strsplit(comm," ")[[1]] )
                comm[comm!=0] = comm[comm!=0] + l-1 
                comment = c(comment, comm)
                    
                polylist[l:(l+L-1)] = spgeom@polygons[[i]]@Polygons
                l=l+L
            }
            
            polyslist[[k]] = Polygons(polylist, curid)
            attr(polyslist[[k]],"comment") = paste(comment, collapse=" ")
            k=k+1
        }

        ans = SpatialPolygons(polyslist,proj4string = spgeom@proj4string)
        
    } else {
        stop("Unknown object class")
    }
    
    return(ans)
}

gIsOverlayNG <- function() {
    version_GEOS0() >= "3.9.0"
}

library(testthat)
library(rgeos)

setScale()

context("Translate Points")

test_that("translate points", {
    
    p = readWKT("POINT(1 1)")
    mp = readWKT("MULTIPOINT(1 1, 2 2, 3 3, 4 4, 5 5)") 
    gcp1 = readWKT("GEOMETRYCOLLECTION( POINT(1 1), POINT(2 2), POINT(3 3), POINT(4 4), POINT(5 5))")
    gcp2 = readWKT("GEOMETRYCOLLECTION( POINT(1 1), POINT(2 2), MULTIPOINT(3 3, 4 4, 5 5))")
    gcp3 = readWKT("GEOMETRYCOLLECTION( POINT(1 1), POINT(2 2), MULTIPOINT(3 3, 4 4),POINT(5 5))")
    gcp4 = readWKT("GEOMETRYCOLLECTION( MULTIPOINT(1 1, 2 2), MULTIPOINT(3 3, 4 4, 5 5))")
    gcp5 = readWKT("GEOMETRYCOLLECTION( MULTIPOINT(1 1, 2 2), MULTIPOINT(3 3, 4 4),POINT(5 5))")
    
    spp = SpatialPoints(list(x=1,y=1))
    spmp = SpatialPoints(list(x=1:5,y=1:5))
    
    rownames(spp@coords) = c("1")
    expect_that( identical(p,spp), is_true())
    expect_that( identical(spp, translate(spp)), is_true())
    
    rownames(spmp@coords) = c("1","1","1","1","1")
    expect_that( identical(mp,spmp), is_true() )
    expect_that( identical(spmp,translate(spmp)), is_true())
    
    rownames(spmp@coords) = c("1","2","3","4","5")
    expect_that( identical(gcp1,spmp), is_true() )
	expect_that( identical(spmp,translate(spmp)), is_true())
    
    rownames(spmp@coords) = c("1","2","3","3","3")
    expect_that( identical(gcp2,spmp), is_true() )
    expect_that( identical(spmp,translate(spmp)), is_true())

    rownames(spmp@coords) = c("1","2","3","3","4")
    expect_that( identical(gcp3,spmp), is_true() )
    expect_that( identical(spmp,translate(spmp)), is_true())
    
    rownames(spmp@coords) = c("1","1","2","2","2")    
    expect_that( identical(gcp4,spmp), is_true() )
    expect_that( identical(spmp,translate(spmp)), is_true())
    
    rownames(spmp@coords) = c("1","1","2","2","3")
    expect_that( identical(gcp5,spmp), is_true() )
    expect_that( identical(spmp,translate(spmp)), is_true())

    
    expect_that( identical(p, translate(p) ), is_true())
    expect_that( identical(mp, translate(mp) ), is_true())
    expect_that( identical(gcp1, translate(gcp1) ), is_true())
    expect_that( identical(gcp2, translate(gcp2) ), is_true())
    expect_that( identical(gcp3, translate(gcp3) ), is_true())
    expect_that( identical(gcp4, translate(gcp4) ), is_true())
    expect_that( identical(gcp5, translate(gcp5) ), is_true())
    
})

library(testthat)
library(rgeos)

setScale()

context("Translate Lines")

test_that("translate lines", {

    l = readWKT("LINESTRING (1 1, 2 2, 3 3, 4 4)")

    ml1 = readWKT("MULTILINESTRING ((1 1, 2 2, 3 3, 4 4),(1 1, 2 2, 3 3, 4 4))")
    ml2 = readWKT("MULTILINESTRING ((1 1, 2 2, 3 3, 4 4),(4 1, 3 2, 2 3, 1 4))")

    gcl1 = readWKT("GEOMETRYCOLLECTION( LINESTRING (1 1, 2 2, 3 3, 4 4), LINESTRING (1 1, 2 2, 3 3, 4 4) )")
    gcl2 = readWKT("GEOMETRYCOLLECTION( LINESTRING (1 1, 2 2, 3 3, 4 4), MULTILINESTRING ((1 1, 2 2, 3 3, 4 4),(4 1, 3 2, 2 3, 1 4)), LINESTRING (1 1, 2 2, 3 3, 4 4) )")


    Line1 = Line(cbind( x=1:4,y=1:4 ))
    Line2 = Line(cbind( x=4:1,y=1:4 ))
    
    Linesl = Lines( list(Line1), ID = "1" )
    Linesl2 = Lines( list(Line1), ID = "2" )
    
    Linesml1 = Lines( list(Line1, Line1), ID = "1" )
    Linesml2 = Lines( list(Line1, Line2), ID = "1" )
    
    #FIXME - weirdness with rownames in the bbox
    spl    = SpatialLines( list(Linesl) ); rownames(spl@bbox) = c("x","y")
    spml1  = SpatialLines( list(Linesml1) ); rownames(spml1@bbox) = c("x","y")
    spml2  = SpatialLines( list(Linesml2) ); rownames(spml2@bbox) = c("x","y")
    
    spgcl1 = SpatialLines( list(Linesl,Linesl2) ); rownames(spgcl1@bbox) = c("x","y")
    Linesml2@ID = "2"
    Linesl2@ID = "3"
    spgcl2 = SpatialLines( list(Linesl,Linesml2,Linesl2) ); rownames(spgcl2@bbox) = c("x","y")


    expect_that( l   , is_identical_to(spl) )
    expect_that( ml1 , is_identical_to(spml1) )
    expect_that( ml2 , is_identical_to(spml2) )
    expect_that( gcl1, is_identical_to(spgcl1) )
    expect_that( gcl2, is_identical_to(spgcl2) )
    
    expect_that( spl   , is_identical_to( translate(spl)))
    expect_that( spml1 , is_identical_to( translate(spml1)))
    expect_that( spml2 , is_identical_to( translate(spml2)))
    expect_that( spgcl1, is_identical_to( translate(spgcl1)))
    expect_that( spgcl2, is_identical_to( translate(spgcl2)))
    
    expect_that( l   , is_identical_to( translate(l) ))
    expect_that( ml1 , is_identical_to( translate(ml1) ))
    expect_that( ml2 , is_identical_to( translate(ml2) ))
    expect_that( gcl1, is_identical_to( translate(gcl1) ))
    expect_that( gcl2, is_identical_to( translate(gcl2) ))

})

#library(testthat)
#library(rgeos)
#
#setScale()
#context("Translation empty geometries")
#
#test_that("empty geometrycollection", {
#	gc1 = readWKT("GEOMETRYCOLLECTION EMPTY")
#
#	expect_that( gc1,  is_identical_to(translate(gc1)) )
#})
#
#
#test_that("empty points", {
#    p1 = readWKT("POINT EMPTY")
#    p2 = readWKT("MULTIPOINT EMPTY")
#    p3 = readWKT("GEOMETRYCOLLECTION(POINT EMPTY)")
#    p4 = readWKT("GEOMETRYCOLLECTION(MULTIPOINT EMPTY)")
#    
#    expect_that( p1,  is_identical_to(p2) )
#    expect_that( p2,  is_identical_to(p3) )
#    expect_that( p3,  is_identical_to(p4) )
#    
#    expect_that( p1,  is_identical_to(translate(p1)) )
#    expect_that( p2,  is_identical_to(translate(p2)) )
#    expect_that( p3,  is_identical_to(translate(p3)) )
#    expect_that( p4,  is_identical_to(translate(p4)) )
#    
#    pg1 = readWKT("GEOMETRYCOLLECTION(POINT EMPTY,POINT EMPTY)")
#    pg2 = readWKT("GEOMETRYCOLLECTION(POINT EMPTY,MULTIPOINT EMPTY)")
#    pg3 = readWKT("GEOMETRYCOLLECTION(MULTIPOINT EMPTY,POINT EMPTY)")
#    pg4 = readWKT("GEOMETRYCOLLECTION(MULTIPOINT EMPTY,MULTIPOINT EMPTY)")
#
#    pg5 = readWKT("GEOMETRYCOLLECTION(POINT (1 1),POINT EMPTY)")
#    pg6 = readWKT("GEOMETRYCOLLECTION(POINT (1 1),MULTIPOINT EMPTY)")
#    pg7 = readWKT("GEOMETRYCOLLECTION(MULTIPOINT (1 1),POINT EMPTY)")
#    pg8 = readWKT("GEOMETRYCOLLECTION(MULTIPOINT (1 1),MULTIPOINT EMPTY)")
#
#    pg9 = readWKT("GEOMETRYCOLLECTION(POINT EMPTY,POINT (1 1))")
#    pg10= readWKT("GEOMETRYCOLLECTION(POINT EMPTY,MULTIPOINT (1 1))")
#    pg11= readWKT("GEOMETRYCOLLECTION(MULTIPOINT EMPTY,POINT (1 1))")
#    pg12= readWKT("GEOMETRYCOLLECTION(MULTIPOINT EMPTY,MULTIPOINT (1 1))")
#
#    expect_that( pg1,  is_identical_to(pg2) )
#    expect_that( pg2,  is_identical_to(pg3) )
#    expect_that( pg3,  is_identical_to(pg4) )
#
#    expect_that( pg5,  is_identical_to(pg5) )
#    expect_that( pg6,  is_identical_to(pg7) )
#    expect_that( pg7,  is_identical_to(pg8) )
#    
#    expect_that( pg9,  is_identical_to(pg10) )
#    expect_that( pg10, is_identical_to(pg11) )
#    expect_that( pg11, is_identical_to(pg12) )
#    
#    expect_that( pg1,  is_identical_to(translate(pg1)) )
#    expect_that( pg2,  is_identical_to(translate(pg2)) )
#    expect_that( pg3,  is_identical_to(translate(pg3)) )
#    expect_that( pg4,  is_identical_to(translate(pg4)) )
#    expect_that( pg5,  is_identical_to(translate(pg5)) )
#    expect_that( pg6,  is_identical_to(translate(pg6)) )
#    expect_that( pg7,  is_identical_to(translate(pg7)) )
#    expect_that( pg8,  is_identical_to(translate(pg8)) )
#    expect_that( pg9,  is_identical_to(translate(pg9)) )
#    expect_that(pg10,  is_identical_to(translate(pg10)) )
#    expect_that(pg11,  is_identical_to(translate(pg11)) )
#    expect_that(pg12,  is_identical_to(translate(pg12)) )
#    
#})
#
#test_that("empty linestrings", {
#
#    l1 = readWKT("LINESTRING EMPTY")
#    l2 = readWKT("MULTILINESTRING EMPTY")
#    l3 = readWKT("GEOMETRYCOLLECTION(LINESTRING EMPTY)")
#    l4 = readWKT("GEOMETRYCOLLECTION(MULTILINESTRING EMPTY)")
#    
#    expect_that( l1, is_identical_to(l2) )
#    expect_that( l2, is_identical_to(l3) )
#    expect_that( l3, is_identical_to(l4) )
#    
#    expect_that( l1, is_identical_to(translate(l1)) )
#    expect_that( l2, is_identical_to(translate(l2)) )
#    expect_that( l3, is_identical_to(translate(l3)) )
#    expect_that( l4, is_identical_to(translate(l4)) )
#    
#    
#    ml1 = readWKT("MULTILINESTRING((1 1,2 2), EMPTY)")
#    ml2 = readWKT("MULTILINESTRING(EMPTY, (1 1,2 2))")
#    
#    expect_that( ml1, is_identical_to(translate(ml1)) )
#    expect_that( ml2, is_identical_to(translate(ml2)) )
#    
#    
#    lg1 = readWKT("GEOMETRYCOLLECTION(LINESTRING EMPTY,LINESTRING EMPTY)")
#    lg2 = readWKT("GEOMETRYCOLLECTION(MULTILINESTRING EMPTY,MULTILINESTRING EMPTY)")
#    lg3 = readWKT("GEOMETRYCOLLECTION(LINESTRING EMPTY,MULTILINESTRING EMPTY)")
#    lg4 = readWKT("GEOMETRYCOLLECTION(MULTILINESTRING EMPTY,LINESTRING EMPTY)")
#    
#    lg5 = readWKT("GEOMETRYCOLLECTION(LINESTRING EMPTY,LINESTRING(1 1,2 2))")
#    lg6 = readWKT("GEOMETRYCOLLECTION(MULTILINESTRING EMPTY,MULTILINESTRING((1 1,2 2)))")
#    lg7 = readWKT("GEOMETRYCOLLECTION(LINESTRING EMPTY,MULTILINESTRING((1 1,2 2)))")
#    lg8 = readWKT("GEOMETRYCOLLECTION(MULTILINESTRING EMPTY,LINESTRING(1 1,2 2))")
#    
#    lg9 = readWKT("GEOMETRYCOLLECTION(LINESTRING(1 1,2 2),LINESTRING EMPTY)")
#    lg10= readWKT("GEOMETRYCOLLECTION(MULTILINESTRING((1 1,2 2)),MULTILINESTRING EMPTY)")
#    lg11= readWKT("GEOMETRYCOLLECTION(LINESTRING(1 1,2 2),MULTILINESTRING EMPTY)")
#    lg12= readWKT("GEOMETRYCOLLECTION(MULTILINESTRING((1 1,2 2)),LINESTRING EMPTY)")
#
#    expect_that( lg1,  is_identical_to(lg2) )
#    expect_that( lg2,  is_identical_to(lg3) )
#    expect_that( lg3,  is_identical_to(lg4) )
#
#    expect_that( lg5,  is_identical_to(lg5) )
#    expect_that( lg6,  is_identical_to(lg7) )
#    expect_that( lg7,  is_identical_to(lg8) )
#    
#    expect_that( lg9,  is_identical_to(lg10) )
#    expect_that( lg10, is_identical_to(lg11) )
#    expect_that( lg11, is_identical_to(lg12) )
#    
#    expect_that( lg1, is_identical_to(translate(lg1)) )
#    expect_that( lg2, is_identical_to(translate(lg2)) )
#    expect_that( lg3, is_identical_to(translate(lg3)) )
#    expect_that( lg4, is_identical_to(translate(lg4)) )
#    expect_that( lg5, is_identical_to(translate(lg5)) )
#    expect_that( lg6, is_identical_to(translate(lg6)) )
#    expect_that( lg7, is_identical_to(translate(lg7)) )
#    expect_that( lg8, is_identical_to(translate(lg8)) )
#    expect_that( lg9, is_identical_to(translate(lg9)) )
#    expect_that( lg10, is_identical_to(translate(lg10)) )
#    expect_that( lg11, is_identical_to(translate(lg11)) )
#    expect_that( lg12, is_identical_to(translate(lg12)) )
#})
#
#
#test_that("empty linearrings", {
#
#    lr1 = readWKT("LINEARRING EMPTY")
#    lr2 = readWKT("GEOMETRYCOLLECTION(LINEARRING EMPTY)")
#    
#    expect_that( lr1, is_identical_to(lr2) )
#    
#    expect_that( lr1, is_identical_to(translate(lr1)) )
#    expect_that( lr2, is_identical_to(translate(lr2)) )
#    
#    lrg1 = readWKT("GEOMETRYCOLLECTION(LINEARRING EMPTY,LINEARRING EMPTY)")
#    lrg2 = readWKT("GEOMETRYCOLLECTION(LINEARRING EMPTY,LINEARRING(1 1,2 2,3 1,1 1))")
#    lrg3 = readWKT("GEOMETRYCOLLECTION(LINEARRING(1 1,2 2,3 1,1 1),LINEARRING EMPTY)")
#
#    expect_that( lrg1, is_identical_to(translate(lrg1)) )
#    expect_that( lrg2, is_identical_to(translate(lrg2)) )
#    expect_that( lrg3, is_identical_to(translate(lrg3)) )
#
#})
#
#
#test_that("empty polygons", {
#
#    p1 = readWKT("POLYGON EMPTY")
#    p2 = readWKT("MULTIPOLYGON EMPTY")
#    p3 = readWKT("GEOMETRYCOLLECTION(POLYGON EMPTY)")
#    p4 = readWKT("GEOMETRYCOLLECTION(MULTIPOLYGON EMPTY)")
#    
#    expect_that( p1, is_identical_to(p2) )
#    expect_that( p2, is_identical_to(p3) )
#    expect_that( p3, is_identical_to(p4) )
#    
#    expect_that( p1, is_identical_to(translate(p1)) )
#    expect_that( p2, is_identical_to(translate(p2)) )
#    expect_that( p3, is_identical_to(translate(p3)) )
#    expect_that( p4, is_identical_to(translate(p4)) )
#    
#    
#    mp1 = readWKT("MULTIPOLYGON(((1 1,2 2,3 1,1 1)), EMPTY)")
#    mp2 = readWKT("MULTIPOLYGON(EMPTY, ((1 1,2 2,3 1,1 1)))")
#    
#    expect_that( mp1, is_identical_to(translate(mp1)) )
#    expect_that( mp2, is_identical_to(translate(mp2)) )
#    
#    
#    pg1 = readWKT("GEOMETRYCOLLECTION(POLYGON EMPTY,POLYGON EMPTY)")
#    pg2 = readWKT("GEOMETRYCOLLECTION(POLYGON EMPTY,MULTIPOLYGON EMPTY)")
#    pg3 = readWKT("GEOMETRYCOLLECTION(MULTIPOLYGON EMPTY,POLYGON EMPTY)")
#    pg4 = readWKT("GEOMETRYCOLLECTION(MULTIPOLYGON EMPTY,MULTIPOLYGON EMPTY)")
#    
#    pg5 = readWKT("GEOMETRYCOLLECTION(POLYGON EMPTY, POLYGON((1 1,2 2,3 1,1 1)) )")
#    pg6 = readWKT("GEOMETRYCOLLECTION(MULTIPOLYGON EMPTY, POLYGON((1 1,2 2,3 1,1 1)) )")
#    pg7 = readWKT("GEOMETRYCOLLECTION(POLYGON EMPTY, MULTIPOLYGON(((1 1,2 2,3 1,1 1))) )")
#    pg8 = readWKT("GEOMETRYCOLLECTION(MULTIPOLYGON EMPTY, MULTIPOLYGON(((1 1,2 2,3 1,1 1))) )")
#
#    pg9 = readWKT("GEOMETRYCOLLECTION(POLYGON((1 1,2 2,3 1,1 1)), POLYGON EMPTY)")
#    pg10= readWKT("GEOMETRYCOLLECTION(POLYGON((1 1,2 2,3 1,1 1)), MULTIPOLYGON EMPTY)")
#    pg11= readWKT("GEOMETRYCOLLECTION(MULTIPOLYGON(((1 1,2 2,3 1,1 1))), POLYGON EMPTY)")
#    pg12= readWKT("GEOMETRYCOLLECTION(MULTIPOLYGON(((1 1,2 2,3 1,1 1))), MULTIPOLYGON EMPTY)")
#
#    expect_that( pg1, is_identical_to(pg2) )
#    expect_that( pg2, is_identical_to(pg3) )
#    expect_that( pg3, is_identical_to(pg4) )
#    
#    expect_that( pg5, is_identical_to(pg6) )
#    expect_that( pg6, is_identical_to(pg7) )
#    expect_that( pg7, is_identical_to(pg8) )
#
#    expect_that( pg9, is_identical_to(pg10) )
#    expect_that(pg10, is_identical_to(pg11) )
#    expect_that(pg11, is_identical_to(pg12) )
#
#    expect_that( pg1, is_identical_to(translate(pg1)) )
#    expect_that( pg2, is_identical_to(translate(pg2)) )
#    expect_that( pg3, is_identical_to(translate(pg3)) )
#    expect_that( pg4, is_identical_to(translate(pg4)) )
#    expect_that( pg5, is_identical_to(translate(pg5)) )
#    expect_that( pg6, is_identical_to(translate(pg6)) )
#    expect_that( pg7, is_identical_to(translate(pg7)) )
#    expect_that( pg8, is_identical_to(translate(pg8)) )
#    expect_that( pg9, is_identical_to(translate(pg9)) )
#    expect_that( pg10,is_identical_to(translate(pg10)))
#    expect_that( pg11,is_identical_to(translate(pg11)))
#    expect_that( pg12,is_identical_to(translate(pg12)))
#
#})

library(testthat)
library(rgeos)

setScale()

context("Translation Polygon Collections")

test_that("translate polygon collection", {

    gcp1=readWKT("GEOMETRYCOLLECTION( POLYGON((1 1,5 1,5 5,1 5,1 1)), POLYGON((3 5,5 7, 1 7, 3 5)), POLYGON((5 3,7 5,7 1,5 3)) )")
    gcp2=readWKT("GEOMETRYCOLLECTION( MULTIPOLYGON( ((1 1,5 1,5 5,1 5,1 1)), ((3 5,5 7, 1 7, 3 5)) ), POLYGON((5 3,7 5,7 1,5 3)) )")
    gcp3=readWKT("GEOMETRYCOLLECTION( POLYGON((1 1,5 1,5 5,1 5,1 1)), MULTIPOLYGON( ((3 5,5 7, 1 7, 3 5)), ((5 3,7 5,7 1,5 3)) ))")
    gcp4=readWKT("GEOMETRYCOLLECTION( MULTIPOLYGON( ((1 1,5 1,5 5,1 5,1 1)), ((3 5,5 7, 1 7, 3 5)), ((5 3,7 5,7 1,5 3)) ))")
    
    gcph1=readWKT("GEOMETRYCOLLECTION( POLYGON((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2)), POLYGON((3 5,5 7, 1 7, 3 5),(3 5.5,4 6.5, 2 6.5, 3 5.5)), POLYGON((5 3,7 5,7 1,5 3)) )")
    gcph2=readWKT("GEOMETRYCOLLECTION( MULTIPOLYGON( ((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2)), ((3 5,5 7, 1 7, 3 5),(3 5.5,4 6.5, 2 6.5, 3 5.5)) ), POLYGON((5 3,7 5,7 1,5 3)) )")
    gcph3=readWKT("GEOMETRYCOLLECTION( POLYGON((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2)), MULTIPOLYGON( ((3 5,5 7, 1 7, 3 5),(3 5.5,4 6.5, 2 6.5, 3 5.5)), ((5 3,7 5,7 1,5 3)) ))")
    
    
    Poly1 = Polygon(list(x=c(1,5,5,1,1),y=c(1,1,5,5,1)), hole=FALSE)
    Poly2 = Polygon(list(x=c(2,2,3,3,2),y=c(2,3,3,2,2)), hole=TRUE)
    Poly3 = Polygon(list(x=c(3,3,4,4,3),y=c(3,4,4,3,3)), hole=TRUE)
    Poly4 = Polygon(list(x=c(3,5,1,3),y=c(5,7,7,5)), hole=FALSE)
    Poly5 = Polygon(list(x=c(3,4,2,3),y=c(5.5,6.5,6.5,5.5)), hole=TRUE)
    Poly6 = Polygon(list(x=c(5,7,7,5),y=c(3,5,1,3)), hole=FALSE)
   
    Polygcp11 = Polygons(list(Poly1), ID="1")
    Polygcp12 = Polygons(list(Poly4), ID="2")
    Polygcp13 = Polygons(list(Poly6), ID="3")
    Polygcp21 = Polygons(list(Poly1,Poly4), ID="1")
    Polygcp22 = Polygons(list(Poly6), ID="2")
    Polygcp31 = Polygons(list(Poly1), ID="1")
    Polygcp32 = Polygons(list(Poly4,Poly6), ID="2")
    Polygcp4  = Polygons(list(Poly1,Poly4,Poly6), ID="1")
    
    Polygcph11 = Polygons(list(Poly1,Poly2), ID="1")
    Polygcph12 = Polygons(list(Poly4,Poly5), ID="2")
    Polygcph13 = Polygons(list(Poly6), ID="3")
    Polygcph21 = Polygons(list(Poly1,Poly2,Poly4,Poly5), ID="1")
    Polygcph22 = Polygons(list(Poly6), ID="2")
    Polygcph31 = Polygons(list(Poly1,Poly2), ID="1")
    Polygcph32 = Polygons(list(Poly4,Poly5,Poly6), ID="2")

    comment(Polygcp11) <- "0"
    comment(Polygcp12) <- "0"
    comment(Polygcp13) <- "0"
    comment(Polygcp21) <- "0 0"
    comment(Polygcp22) <- "0"
    comment(Polygcp31) <- "0"
    comment(Polygcp32) <- "0 0"
    comment(Polygcp4) <- "0 0 0"

    comment(Polygcph11) <- "0 1"
    comment(Polygcph12) <- "0 1"
    comment(Polygcph13) <- "0"
    comment(Polygcph21) <- "0 1 0 3"
    comment(Polygcph22) <- "0"
    comment(Polygcph31) <- "0 1"
    comment(Polygcph32) <- "0 1 0"

    spgcp1  = SpatialPolygons( list(Polygcp11,Polygcp12,Polygcp13) )
    spgcp2  = SpatialPolygons( list(Polygcp21,Polygcp22) )
    spgcp3  = SpatialPolygons( list(Polygcp31,Polygcp32) )
    spgcp4  = SpatialPolygons( list(Polygcp4) )
    spgcph1 = SpatialPolygons( list(Polygcph11,Polygcph12,Polygcph13) )
    spgcph2 = SpatialPolygons( list(Polygcph21,Polygcph22) )
    spgcph3 = SpatialPolygons( list(Polygcph31,Polygcph32) )
    
    expect_that( gcp1 , is_identical_to(spgcp1) )
    expect_that( gcp2 , is_identical_to(spgcp2) )
    expect_that( gcp3 , is_identical_to(spgcp3) )
    expect_that( gcp4 , is_identical_to(spgcp4) )
    expect_that( gcph1, is_identical_to(spgcph1) )
    expect_that( gcph2, is_identical_to(spgcph2) )
    expect_that( gcph3, is_identical_to(spgcph3) )
    
    expect_that( spgcp1 , is_identical_to( translate(spgcp1)))
    expect_that( spgcp2 , is_identical_to( translate(spgcp2)))
    expect_that( spgcp3 , is_identical_to( translate(spgcp3)))
    expect_that( spgcp4 , is_identical_to( translate(spgcp4)))
    expect_that( spgcph1, is_identical_to( translate(spgcph1)))
    expect_that( spgcph2, is_identical_to( translate(spgcph2)))
    expect_that( spgcph3, is_identical_to( translate(spgcph3)))
    
    expect_that( gcp1 , is_identical_to( translate(gcp1)))
    expect_that( gcp2 , is_identical_to( translate(gcp2)))
    expect_that( gcp3 , is_identical_to( translate(gcp3)))
    expect_that( gcp4 , is_identical_to( translate(gcp4)))
    expect_that( gcph1, is_identical_to( translate(gcph1)))
    expect_that( gcph2, is_identical_to( translate(gcph2)))
    expect_that( gcph3, is_identical_to( translate(gcph3)))
})

library(testthat)
library(rgeos)

setScale()

context("Translate Polygons")

test_that("translate simple polygon", {

    p=readWKT("POLYGON((1 1,5 1,5 5,1 5,1 1))")
    ph1=readWKT("POLYGON((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2))")
    ph2=readWKT("POLYGON((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2), (3 3,3 4,4 4,4 3,3 3) ) ")
    
    mp=readWKT("MULTIPOLYGON( ((1 1,5 1,5 5,1 5,1 1)),((3 5,5 7, 1 7, 3 5)))")
    mph1=readWKT("MULTIPOLYGON( ((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2)),((3 5,5 7, 1 7, 3 5)))")
    mph2=readWKT("MULTIPOLYGON( ((1 1,5 1,5 5,1 5,1 1)),((3 5,5 7, 1 7, 3 5),(3 5.5,4 6.5, 2 6.5, 3 5.5) ))")
    mph3=readWKT("MULTIPOLYGON( ((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2)),((3 5,5 7, 1 7, 3 5),(3 5.5,4 6.5, 2 6.5, 3 5.5)) )")
    
    Poly1 = Polygon(list(x=c(1,5,5,1,1),y=c(1,1,5,5,1)), hole=FALSE)
    Poly2 = Polygon(list(x=c(2,2,3,3,2),y=c(2,3,3,2,2)), hole=TRUE)
    Poly3 = Polygon(list(x=c(3,3,4,4,3),y=c(3,4,4,3,3)), hole=TRUE)
    Poly4 = Polygon(list(x=c(3,5,1,3),y=c(5,7,7,5)), hole=FALSE)
    Poly5 = Polygon(list(x=c(3,4,2,3),y=c(5.5,6.5,6.5,5.5)), hole=TRUE)
    Poly6 = Polygon(list(x=c(5,7,7,5),y=c(3,5,1,3)), hole=FALSE)
    
    Polysp = Polygons(list(Poly1), ID="1")
    Polysph1 = Polygons(list(Poly1,Poly2), ID="1")
    Polysph2 = Polygons(list(Poly1,Poly2,Poly3), ID="1")
    
    Polysmp = Polygons(list(Poly1,Poly4), ID="1" )
    Polysmph1 = Polygons(list(Poly1,Poly2,Poly4), ID="1" )
    Polysmph2 = Polygons(list(Poly1,Poly4,Poly5), ID="1" )
    Polysmph3 = Polygons(list(Poly1,Poly2,Poly4,Poly5), ID="1" )
    
    comment(Polysp) <- "0"
    comment(Polysph1) <- "0 1"
    comment(Polysph2) <- "0 1 1"
    comment(Polysmp) <- "0 0"
    comment(Polysmph1) <- "0 1 0"
    comment(Polysmph2) <- "0 0 2"
    comment(Polysmph3) <- "0 1 0 3"

    spp     = SpatialPolygons( list(Polysp) )
    spph1   = SpatialPolygons( list(Polysph1) )
    spph2   = SpatialPolygons( list(Polysph2) )
    spmp    = SpatialPolygons( list(Polysmp) )
    spmph1  = SpatialPolygons( list(Polysmph1) )
    spmph2  = SpatialPolygons( list(Polysmph2) )
    spmph3  = SpatialPolygons( list(Polysmph3) )
    
    expect_that( identical(p    , spp), is_true())
    expect_that( identical(ph1  , spph1), is_true())
    expect_that( identical(ph2  , spph2), is_true())
    expect_that( identical(mp   , spmp), is_true())
    expect_that( identical(mph1 , spmph1), is_true())
    expect_that( identical(mph2 , spmph2), is_true())
    expect_that( identical(mph3 , spmph3), is_true())
    
    expect_that( spp   , is_identical_to( translate(spp)))
    expect_that( spph1 , is_identical_to( translate(spph1)))
    expect_that( spph2 , is_identical_to( translate(spph2)))
    expect_that( spmp  , is_identical_to( translate(spmp)))
    expect_that( spmph1, is_identical_to( translate(spmph1)))
    expect_that( spmph2, is_identical_to( translate(spmph2)))
    expect_that( spmph3, is_identical_to( translate(spmph3)))
    
    expect_that( p   , is_identical_to( translate(p)))
    expect_that( ph1 , is_identical_to( translate(ph1)))
    expect_that( ph2 , is_identical_to( translate(ph2)))
    expect_that( mp  , is_identical_to( translate(mp)))
    expect_that( mph1, is_identical_to( translate(mph1)))
    expect_that( mph2, is_identical_to( translate(mph2)))
    expect_that( mph3, is_identical_to( translate(mph3)))
    
})

readWKT = function( text, id = NULL, p4s = NULL) {
    
    #wkt = str_replace(text,"\n","")
    wkt = gsub("\n", "", text)

    if (length(wkt) != 1) stop("WKT must have length 1")
    
	pat = 
	"POINT|LINESTRING|LINEARRING|POLYGON|MULTIPOINT|MULTILINESTRING|MULTIPOLYGON"
    # m =  str_extract_all(wkt, pat)
	m = strsplit(wkt, pat)
    # ngeoms =  length( m[[1]] )
    ngeoms =  length( m[[1]] ) - 1 # "" before first match is always the first
    if(is.null(ngeoms)) ngeoms = 0
    
    if(is.null(id)) {
        if (ngeoms == 0) {
            id = c()
        } else {
            id = 1:ngeoms
        }
    } 
    
    # if the number of ids doesn't take into account sub geometries in geometry collection then create subids
    if( length(id) == 1 & ngeoms != 1)
        id = paste(id,1:ngeoms,sep=".")
    
    if( length(id) != ngeoms )
        stop("number of WKT geometries does not match number of ids")        

    p4s = checkP4S(p4s)
    
    id = as.character(id)
        
    tryCatch(res <- .Call("rgeos_readWKT", .RGEOS_HANDLE, wkt, p4s, 
                            id, PACKAGE="rgeos"), 
             error = function(e) { stop( paste( "Unable to parse: ",wkt,"\n",
                                                "GEOS reported: \"", e$message,"\"",sep=""),call.=FALSE) } )
    
	#if (length(unique(row.names(res))) != ngeoms)
	#if (!is.null(res)) {
	#	if ( sum(sapply(row.names(res),length)) != ngeoms )
    #    	warning(paste("Number of geometries does not match between object and text, check WKT validity.",wkt),call.=FALSE)
    #}

    return( res )
}


writeWKT = function( spgeom, byid = FALSE) {

    stopifnot(is.logical(byid))
    byid = as.logical(byid)
    
    res <- .Call("rgeos_writeWKT", .RGEOS_HANDLE, spgeom, byid)
    
    return(res) 
}

## gpclib:  General Polygon Clipping library for R
## Copyright (C) 2003-2010 Roger D. Peng <rpeng@jhsph.edu>


## R functions for using GPC library and manipulating polygons

setClass("gpc.poly", representation(pts = "list"))
setClass("gpc.poly.nohole", "gpc.poly")

## setValidity("gpc.poly",
##             function(x) {
##                 pts <- x@pts
##                 lens <- sapply(pts, length)
##                 if(!identical(all(lens == 3), TRUE))
##                     "Not all contours have correct elements"
##                 ## correct names (x, y, hole)
##                 contour.names <- lapply(pts, names)
##                 correct.names <- c("x", "y", "hole")
##                 check <- lapply(contour.names, function(n) {
##                     n %in% correct.names
##                 })
##                 if(!identical(all(sapply(check, all)), TRUE))
##                     "Incorrect list names in contours"
##                 ## correct types
##                 ## equal lengths?
##             })

setMethod("show", "gpc.poly",
          function(object) {
              cat("GPC Polygon\n")
              cat("   Num. Contours: ", length(object@pts), "\n")
              if(length(object@pts) == 1)
                  cat("   Num. Vertices: ", length(object@pts[[1]]$x),"\n")
              bbox <- get.bbox(object)
              cat("   BBox (X): ", bbox$x[1], "-->", bbox$x[2], "\n")
              cat("   BBox (Y): ", bbox$y[1], "-->", bbox$y[2], "\n")
              invisible(object)
          })

setGeneric("get.bbox", function(x)
           standardGeneric("get.bbox"))

setMethod("get.bbox", signature(x = "gpc.poly"),
          function(x) {
              pts <- x@pts
              x <- unlist(lapply(pts, "[[", "x"))
              y <- unlist(lapply(pts, "[[", "y"))
              
              if(!is.null(x))
                  xlim <- range(x)
              else
                  xlim <- c(NA, NA)
              if(!is.null(y))
                  ylim <- range(y)
              else
                  ylim <- c(NA, NA)
              list(x = xlim, y = ylim)
          })

setGeneric("plot")

setMethod("plot", "gpc.poly",
          function(x, y, poly.args = list(), xlab = "X", ylab = "Y",
                   asp = 1, add = FALSE, ...) {
              if(!add) {
                  bbox <- get.bbox(x)
                  plot(0, 0, ylim = bbox$y, xlim = bbox$x, type="n",
                       xlab = xlab, ylab = ylab, asp = asp, ...)
              }
              invisible(lapply(x@pts, function(p) {
                  do.call("polygon", append(list(x = p), poly.args))
              }))
          })

setGeneric("intersect")
setGeneric("union")
setGeneric("setdiff")
if (!isGeneric("symdiff")) setGeneric("symdiff", function(x, y)
		standardGeneric("symdiff"))

setMethod("intersect", signature(x = "gpc.poly", y = "gpc.poly"),
          	function(x, y) {
		  		spx = as(x,"SpatialPolygons")
				spy = as(y,"SpatialPolygons")
				spres = gIntersection(spx, spy, drop_lower_td=TRUE)
		
                                if (is.null(spres))
                                    return(new("gpc.poly"))
				as(spres,"gpc.poly")
          	})


setMethod("setdiff", signature(x = "gpc.poly", y = "gpc.poly"),
          	function(x, y) {
		  		spx = as(x,"SpatialPolygons")
				spy = as(y,"SpatialPolygons")
				spres = gDifference(spx,spy, drop_lower_td=TRUE)
		
                                if (is.null(spres))
                                    return(new("gpc.poly"))
				as(spres,"gpc.poly")
          	})

setMethod("union", signature(x = "gpc.poly", y = "gpc.poly"),
          function(x, y) {
		  		spx = as(x,"SpatialPolygons")
				spy = as(y,"SpatialPolygons")
				spres = gUnion(spx,spy, drop_lower_td=TRUE)
		
                                if (is.null(spres))
                                    return(new("gpc.poly"))
				as(spres,"gpc.poly")
          })

setMethod("symdiff", signature(x = "gpc.poly", y = "gpc.poly"),
          function(x, y) {
		  		spx = as(x,"SpatialPolygons")
				spy = as(y,"SpatialPolygons")
				spres = gSymdifference(spx,spy, drop_lower_td=TRUE)

                                if (is.null(spres))
                                    return(new("gpc.poly"))
				as(spres,"gpc.poly")
          })

setGeneric("tristrip", function(x) 
           standardGeneric("tristrip"))
           
setMethod("tristrip", signature(x = "gpc.poly"),
		function(x) {
			stop("rgeos does not currently implement this feature of gpclib")
		
	      	#poly <- as(x, "numeric")
	      	#result <- .Call("Rgpc_polygon_to_tristrip", poly, PACKAGE = "gpclib")
	      	#result <- lapply(result, function(strip) matrix(strip, ncol=2, byrow=TRUE))
	  	})

setGeneric("triangulate", function(x) 
           standardGeneric("triangulate"))
 
setMethod("triangulate", signature(x = "gpc.poly"),
		function(x) {
			stop("rgeos does not currently implement this feature of gpclib")
	      	tristrip <- tristrip(x)
	      	triangles <- lapply(tristrip, 
	                     function(strip) {
	                          n <- nrow(strip)
	                          if (n > 3)
	                              result <- strip[c(1:3,4:2) + 2*rep(0:(n %/% 2 - 2), each=6), ]
	                          else
	                              result <- strip[0,]
	                          if (n %% 2 && n > 2) result <- rbind(result, strip[1:3 + n - 3,])
	                          return(result)
	                          })
	                          
	      	do.call(rbind, triangles)
	  	})

setMethod("[", "gpc.poly",
          function(x, i, j, ..., drop = FALSE) {
              new("gpc.poly", pts = x@pts[i])
          })

setAs("matrix", "gpc.poly",
      function(from, to) {
          if(ncol(from) > 2)
              stop("matrix must have 2 columns")
          p <- list(x = from[,1], y = from[,2], hole = FALSE)
          new("gpc.poly", pts = list(p))
      })

setAs("data.frame", "gpc.poly",
      function(from, to) {
          as(as.matrix(from), "gpc.poly")
      })

## Miscellaneous Utility Functions

setGeneric("append.poly", function(x, y)
           standardGeneric("append.poly"))

setMethod("append.poly",
          signature(x = "gpc.poly", y = "gpc.poly"),
          function(x, y) {
              newpts <- append(x@pts, y@pts)
              new("gpc.poly", pts = newpts)
          })

setGeneric("scale.poly", function(x, ...)
           standardGeneric("scale.poly"))

setMethod("scale.poly", signature(x = "gpc.poly"), 
          function(x, xscale, yscale = xscale, ...) {
              x@pts <- lapply(x@pts, function(p) {
                  p$x <- p$x / xscale
                  p$y <- p$y / yscale
                  p
              })
              x
          })

## Compute the area of each polygon in the polygon set contained in
## `object'.  

setGeneric("area.poly", function(object, ...)
           standardGeneric("area.poly"))

setMethod("area.poly", signature(object = "gpc.poly"),
          function(object, ...) {
              area <- function(x.mat) {
                  if(nrow(x.mat) < 3) 
                      return(0);   
                  x.segmat <- cbind(x.mat, rbind(x.mat[2:nrow(x.mat), ],
                                                 x.mat[1, ]));
                  abs(sum(x.segmat[,1] * x.segmat[,4] - x.segmat[,3]
                          * x.segmat[,2])) / 2
              }
              if(length(object@pts) == 0)
                  return(0)
              a <- sapply(object@pts, function(p) area(cbind(p$x, p$y)))
              holeflags <- sapply(object@pts, "[[", "hole")
              sum(a[!holeflags]) - sum(a[holeflags])
          })

## Added 2003/01/07
setGeneric("get.pts", function(object)
           standardGeneric("get.pts"))

setMethod("get.pts", signature(object = "gpc.poly"),
          function(object) {
              object@pts
          })

## These two functions are needed for the intersect/union/setdiff
## methods.  They basically serialize and unserialize the "gpc.poly"
## object.

## We need separate functions because polygons with holes and polygons
## without holes have different file formats

setAs("numeric", "gpc.poly.nohole", 
      function(from) {
          ## The shortest a vector can be is 8 numbers:  1. Num. Contours;
          ## 2. Num pts for first contour; and three vertices
          if(length(from) < 8)
              stop("numeric vector not long enough")
          expand.poly <- function(x) {
              ## `x' is just a long vector of numbers with a special format
              num.contours <- x[1]; x <- x[-1]
              polyfile <- x
              poly <- vector("list", length = num.contours)
              
              for(i in 1:num.contours) {
                  npts <- polyfile[1]; polyfile <- polyfile[-1]
                  m <- matrix(polyfile[1:(2*npts)], byrow = TRUE, ncol = 2)
                  poly[[i]] <- list(x = m[,1], y = m[,2], hole = FALSE)
                  polyfile <- polyfile[-(1:(2*npts))]
              }
              poly
          }
          new("gpc.poly.nohole", pts = expand.poly(from))
      })

setAs("numeric", "gpc.poly", 
      function(from) {
          ## The shortest a vector can be is 9 numbers:  1. Num. Contours;
          ## 2. Num pts for first contour; 3. hole flag; and three vertices
          if(length(from) < 9)
              stop("numeric vector not long enough")
          expand.poly <- function(x) {
              num.contours <- x[1]; x <- x[-1]
              polyfile <- x
              poly <- vector("list", length = num.contours)
              
              for(i in 1:num.contours) {
                  npts <- polyfile[1]
                  polyfile <- polyfile[-1]
                  hole <- as.logical(polyfile[1])
                  polyfile <- polyfile[-1]
                  
                  m <- matrix(polyfile[1:(2*npts)], byrow = TRUE, ncol = 2)
                  poly[[i]] <- list(x = m[,1], y = m[,2], hole = hole)
                  polyfile <- polyfile[-(1:(2*npts))]
              }
              poly
          }
          new("gpc.poly", pts = expand.poly(from))
      })

##

setAs("gpc.poly", "numeric",
      function(from) {
          flatten.poly <- function(poly) {
              num.contours <- length(poly@pts)
              flat <- lapply(poly@pts, function(p)
                         {
                             v <- as.vector(t(cbind(p$x, p$y)))
                             c(length(p$x), as.numeric(p$hole), v)
                         })
              c(num.contours, unlist(flat))
          }
          flatten.poly(from)
      })

setAs("gpc.poly", "matrix",
      function(from) {
          if(length(from@pts) > 1)
              stop("can only convert a single contour into a matrix")
          pts <- from@pts[[1]]
          m <- cbind(x = pts$x, y = pts$y)
      })

## 'from' is a list(x = ..., y = ...)

setAs("list", "gpc.poly",
      function(from) {
              if(!(all(c("x", "y") %in% names(from))))
                      stop("list should have names 'x' and 'y'")
              if(length(from$x) != length(from$y))
                      stop("'x' and 'y' elements should have the same length")
              as(cbind(from$x,from$y), "gpc.poly")
      })


## Read a polygon from a file

read.polyfile <- function(filename, nohole = TRUE) {
        polyfile <- scan(filename, quiet = TRUE)
        if(nohole) 
                as(polyfile, "gpc.poly.nohole")
        else
                as(polyfile, "gpc.poly")
}

## Write a "gpc.poly" object to a text file

write.polyfile <- function(poly, filename = "GPCpoly.txt") {    
    if(!is(poly, "gpc.poly"))
        stop("'poly' should be of class 'gpc.poly'")
    outfile <- file(filename, "w")
    on.exit(close(outfile))

    num.contours <- length(poly@pts)   
    cat(num.contours, "\n", file = outfile)

    for(i in 1:num.contours) {
        m <- as(poly[i], "matrix")
        cat(nrow(m), "\n", file = outfile, append = TRUE)

        if(!is(poly, "gpc.poly.nohole"))
            cat(as.numeric(poly@pts[[i]]$hole), "\n",
                file = outfile, append = TRUE)       
        write(t(m), file = outfile, ncolumns = 2, append = TRUE)
    }
}

library(testthat)
library(rgeos)

set_do_poly_check(FALSE)
#test_dir(system.file("tests", package = "rgeos"), StopReporter)#SummaryByContextReporter)
#test_package("rgeos")
test_check("rgeos")
set_do_poly_check(TRUE)

#########################
###
### SpatialRings
###
#########################

setClass("Ring", 
    representation(coords = "matrix",ID = "character"),
    validity = function(object) {
        if (any(is.na(object@coords)))
            stop("coords cannot contain missing values")
        if (ncol(object@coords) != 2)
            stop("coords should have 2 columns")
        if (!all(object@coords[1,] == object@coords[nrow(object@coords),]))
            stop("invalid ring, start and end coordinates must be equal")
        return(TRUE)
    }
)


setClass("SpatialRings",
    representation("Spatial", rings = "list"),
    
    prototype = list(bbox = matrix( rep(NA, 2), 2, 2, dimnames = list(NULL, c("min","max"))),
                                    proj4string = CRS(as.character(NA)),
                                    rings = list()),
    
    validity = function(object) {
        if (any(unlist(lapply(object@rings, function(x) !is(x, "Ring"))))) 
            stop("rings not Ring objects")
        if (any(duplicated(sapply(slot(object, "rings"), function(i) slot(i, "ID")))))
            return("non-unique Rings ID slot values")
        return(TRUE)
    }
)

#########################
###
### SpatialRingsDataFrame
###
#########################

setClass("SpatialRingsDataFrame",
    representation("SpatialRings", data = "data.frame"),
    validity = function(object) {
        if (!inherits(object@data, "data.frame"))
            stop("data should be of class data.frame")
        if (nrow(object@data) != length(object@rings))
            stop("number of rows in data.frame and SpatialRings don't match")
        return(TRUE)
    }
)

#########################
###
### SpatialCollections
###
#########################

setClassUnion("SpatialPointsNULL", c("SpatialPoints", "NULL")) 
setClassUnion("SpatialLinesNULL", c("SpatialLines", "NULL")) 
setClassUnion("SpatialRingsNULL", c("SpatialRings", "NULL")) 
setClassUnion("SpatialPolygonsNULL", c("SpatialPolygons", "NULL")) 

setClass("SpatialCollections",
    representation("Spatial", pointobj = "SpatialPointsNULL", 
							  lineobj = "SpatialLinesNULL",
							  ringobj = "SpatialRingsNULL",
							  polyobj = "SpatialPolygonsNULL",
							  plotOrder = "integer"),
    
    prototype = list(bbox = matrix( rep(NA, 2), 2, 2, dimnames = list(c("x","y"), c("min","max"))),
                     proj4string = CRS(as.character(NA)),
                     pointobj = NULL,
					 lineobj = NULL,
					 ringobj = NULL,
					 polyobj = NULL ),
    
    validity = function(object) {
		if (!is.null(object@pointobj)) validObject(object@pointobj)
		if (!is.null(object@lineobj)) validObject(object@lineobj)
		if (!is.null(object@ringobj)) validObject(object@ringobj)
		if (!is.null(object@polyobj)) validObject(object@polyobj)
		
		return(TRUE)
    }
)

gProject <- function(spgeom, sppoint, normalized = FALSE) {

  stopifnot(inherits(spgeom, "SpatialLines") ||
            inherits(spgeom, "SpatialLinesDataFrame"))
  stopifnot(inherits(sppoint, "SpatialPoints") ||
            inherits(sppoint, "SpatialPointsDataFrame"))
  stopifnot(is.finite(normalized))

  x <- .Call("rgeos_project", .RGEOS_HANDLE, spgeom, sppoint, normalized)
  x
}


gInterpolate <- function(spgeom, d, normalized = FALSE) {

  stopifnot(inherits(spgeom, "SpatialLines") ||
            inherits(spgeom, "SpatialLinesDataFrame"))
  stopifnot(all(is.finite(d)))
  stopifnot(is.finite(normalized))

  x <- .Call("rgeos_interpolate", .RGEOS_HANDLE, spgeom, d, normalized)
  rownames(x) <- seq_len(nrow(x))
  SpatialPoints(x, proj4string=CRS(proj4string(spgeom)))
}

library("testthat")
library("rgeos")
library("sp")


context("Linear Referencing")

coord <- function(x) unname(coordinates(x))


test_that("zero-length input arguments fail with error", {

  dat <- data.frame(x = 1)
  p <- SpatialPointsDataFrame(readWKT("POINT(0 0)"), dat)
  l <- SpatialLinesDataFrame(readWKT("LINESTRING (-1 0, 1 0)"), dat)

  expect_error(gProject(l, subset(p, x > 1)))
  expect_error(gProject(subset(l, x > 1), p, normalized = TRUE))

  expect_error(gInterpolate(l, numeric(0)))
  expect_error(gInterpolate(subset(l, x > 1), d = 0.5, normalized = TRUE))

})


test_that("interpolation works with zero length line", {

  l <- readWKT("LINESTRING (10 0, 10 0)")
  expect_identical(coord(gInterpolate(readWKT("LINESTRING (10 0, 10 0)"),
                                      d = 0.5)),
                   coord(head(as(l, "SpatialPoints"), 1)))
})


test_that("repeated coordinates work", {

  l <- readWKT("LINESTRING (10 0, 10 0, 20 0)")
  p <- readWKT("POINT(11 0)")

  d <- gProject(l, p, normalized = TRUE)
  expect_identical(gInterpolate(l, d, normalized = TRUE), p)

  d <- gProject(l, p, normalized = FALSE)
  expect_identical(gInterpolate(l, d, normalized = FALSE), p)
})


test_that("functions work with MultiLineStrings", {

  # https://trac.osgeo.org/geos/ticket/323
  l <- readWKT("MULTILINESTRING ((0 -2, 0 2), (-2 0, 2 0))")
  p <- readWKT("MULTIPOINT(2 1.9, 2 2.1)")
  res <- readWKT("MULTIPOINT(2 0, 0 2)")

  expect_identical(coord(gInterpolate(l, gProject(l, p))), coord(res))
})


test_that("normalization works in gInterpolate", {

  l <- readWKT("LINESTRING(25 50, 100 125, 150 190)")

  expect_equal(gInterpolate(l, 0.5*gLength(l), normalized = FALSE),
               gInterpolate(l, 0.5, normalized = TRUE))
})


test_that("interpolation is correct at endpoints", {

  l <- readWKT("LINESTRING(25 50, 100 125, 150 190)")
  p <- as(l, "SpatialPoints")

  expect_identical(coord(gInterpolate(l, 0, TRUE)), coord(p[1, ]))
  expect_identical(coord(gInterpolate(l, 0, FALSE)), coord(p[1, ]))

  expect_identical(coord(gInterpolate(l, 1, TRUE)),
                   coord(p[length(p), ]))
  expect_identical(coord(gInterpolate(l, gLength(l), FALSE)),
                   coord(p[length(p), ]))
})

rgeos_SpatialPolygons2gpcpoly <- function(from) {
    
    if (!inherits(from,"SpatialPolygons"))
        stop("sp does not inherit from SpatialPolygons")
    
    gpcs = list()
    for(i in 1:length(from@polygons)) {
        polys = from@polygons[[i]]
        
        pts = list()
        for(j in 1:length(polys@Polygons)) {
            coords = polys@Polygons[[j]]@coords
            hole = polys@Polygons[[j]]@hole
            l=nrow(coords)
            
            pts[[j]] = list(x=coords[-l,1],y=coords[-l,2],hole=hole)
        }
        
        gpc = new("gpc.poly", pts = pts)
        gpcs[i] = gpc
    }
    
    if (length(gpcs) == 0)
        gpcs = NULL
    if (length(gpcs) == 1)
        gpcs = gpcs[[1]]

    return(gpcs)
}

rgeos_gpcpoly2SpatialPolygons <- function(from) {
    
    if (!is.list(from))
        from = list(from)
        
    res=lapply(from, function(gpc) {

        if (!inherits(gpc,"gpc.poly"))
            stop("object does not inherit from gpc.poly")
    
        if (length(gpc@pts) < 1)
            stop("must be at least one polygon")
    
        polylist = lapply( gpc@pts, function(pt) {
            x=pt$x
            y=pt$y
            l=length(x)
            
            if (x[1]!=x[l] | y[1]!=y[l]) {
                x = c(x,x[1])
                y = c(y,y[1])
            }
            
			hole = 
			
            return( Polygon(cbind(x,y),pt$hole) )
        })

        
        p = Polygons(polylist,"0")
        attr(p,"comment") = createPolygonsComment(p)
        
        return(p)
    })
    
    for (m in 1:length(from)) {
        res[[m]]@ID = as.character(m)
    }
    
    return( SpatialPolygons(res) )
}

setAs("SpatialPolygons", "gpc.poly", rgeos_SpatialPolygons2gpcpoly)
setAs("gpc.poly", "SpatialPolygons", rgeos_gpcpoly2SpatialPolygons)

setAs("SpatialPolygons", "gpc.poly.nohole", rgeos_SpatialPolygons2gpcpoly)
setAs("gpc.poly.nohole", "SpatialPolygons", rgeos_gpcpoly2SpatialPolygons)


areaGPC <- function(x.mat) {
    if(nrow(x.mat) < 3) 
        return(0);   
    x.segmat <- cbind(x.mat, rbind(x.mat[2:nrow(x.mat), ],
         x.mat[1, ]));
    abs(sum(x.segmat[,1] * x.segmat[,4] - x.segmat[,3]
        * x.segmat[,2])) / 2
}

# Calculate the coordinate inside "pol" where a rectangle 
# of width "labw" and height "labh" centred on the coordinate
# has the largest possible distance from the polygon boundary.
# Uses a grid search with "gridpoints" coordinate pairs for the
# initial search, and refines the result using numerical 
# optimisation (the Nelder-Mead algorithm).
labpos.maxdist = function(pol, labw, labh, gridpoints) {

  # Create a rectangular polygon with a given size, centred at a given position
  makerect = function(x, y, wd, ht, rectID)
    Polygons(list(Polygon(cbind(c(x-wd/2, x+wd/2, x+wd/2, x-wd/2, x-wd/2), 
                                c(y-ht/2, y-ht/2, y+ht/2, y+ht/2, y-ht/2)))), rectID)

  # Calculate the distance from the given coordinates (2-column matrix)
  # to the polygon boundary. Returns 0 for any coordinates that results
  # in a rectangle not fully inside the polygon.
  getDists = function(co) {
    # Create a candidate label rectangle for each coordinate
    rects = SpatialPolygons(sapply(seq_len(nrow(co)),
                            function(i) makerect(co[i,1], co[i,2], labw, labh, i)),
                            proj4string=CRS(proj4string(pol)))

    # Check each rectangle to see if it"s inside the polygon
    inside = apply(gContains(pol, rects, byid = TRUE), 1, any)

    # Calculate and return the distance to the polygon boundary for
    # each rectangle (0 for any rectangle (partially) outside the polygon)
    di = numeric(nrow(co))
    if(any(inside))
      di[inside] = gDistance(pol.l, rects[inside], byid = TRUE)
    di
  }

  # Convert the polygon to lines, so that we can easily measure
  # the distance from the rectangles to the polygon boundary
  pol.l = as(pol, "SpatialLines")
  
  # Sample a regular grid of points inside the polygon
  co = coordinates(spsample(pol, n = gridpoints, type = "regular"))
  
  # Calculate the distances to the polygon boundary
  di = getDists(co)
  
  # Stop if no rectangles were inside the polygon
  if(all(di == 0))
    stop("Could not fit label inside polygon (with the given number of grid points)")
  
  # Use numerical optimisation to zero in on the optimal position,
  # with the coordinate found by grid search as initial values.
  # Unfortunately, the Nelder-Mead algorithm in "optim" has some
  # strange heuristics for the step size (size of the initial 
  # simplex) which is not possible to override, so, as a workaround, 
  # we do our own affine transformation inside a wrapper function.
  origin = co[which.max(di),]                                          # Initial value
  stepsize = min(apply(co, 2, function(x) diff(sort(unique(x))[1:2]))) # Distance between grid points
  
  getDistsScaled = function(co, origin, stepsize) {
    -getDists(matrix(co, ncol=2)*stepsize + origin)
  }
  optres = optim(c(0,0), getDistsScaled, method = "Nelder-Mead", 
               control = list(trace = FALSE, reltol = .001),
               origin = origin, stepsize = stepsize)
  optval = optres$par*stepsize + origin # "Optimal" label position
  
  # Only return the calculated position if the numerical optimisation succeeded
  if(optres$convergence != 0) {
    warning("Numerical optimisation did not converge. Returning result of grid search.")
    optval = origin
  }
  
  # Return the "optimal" label position
  optval
}


# Shrink the polygon (using a negative buffer) until
# the convex hull of the shrunken polygon is entirely
# contained inside the original polygon. Then calculate
# the label position as the centroid of the shrunken 
# polygon. (The centroid of the convex hull also gives
# similar results.)
labpos.buffer = function(pol, getLargestPolyPart) {
    init = 0                       # Initial amount to shrink
    estep = sqrt(gArea(pol)/pi)/10 # Additional amount to shrink for each step
    
    # Try repeatedly shrinking the polygon until we"re left
    # with a polygon whose convex hull fits inside the
    # original polygon.
    repeat {
      repeat {
        r = init + estep                 # Amount to shrink
        pol.b = gBuffer(pol, width = -r) # Shrink the polygon
        if (is.null(pol.b)) {
          estep = estep/2
        } else {
          if( gArea(pol.b) <= 0 )        # If the shrunken polygon is empty ...
            estep = estep/2 else break   # ... try again with a smaller value
        }
      }
      
      # If we"re left with more than one polygon, choose the largest one
      polb = getLargestPolyPart(pol.b)
      
      # Calculate the convex hull of the inner polygon.
      # If this is wholly contained in the original polygon,
      # break out of the loop and set the label point to
      # the centroid of the inner polygon.
      if( gContains(pol, gConvexHull(pol.b)) ) break else init=init+estep
    }
    coordinates(pol.b)
}


# Generate a random position inside the polygon
labpos.random = function(pol) {
  # Note that the "spsample" function sometimes fail to
  # find a random point inside the polygon (on the first try),
  # so we may need repeated sampling. Eventually a point is found.
  repeat {
    coord.rand = tryCatch(spsample(pol, n = 1, type = "random"), error = function(x) NULL)
    if(!is.null(coord.rand)) break
  }
  coordinates(coord.rand)
}


# Calculate optimal polygon labels.
#     pols: SpatialPolygons(DataFrame) object.
#   labels: The labels to apply to each polygon.
#           If NULL, the positition is calculated as if the
#           label is a square with one line long sides
#           (given the current value of "cex").
#   method: The method(s) used to calculate label positions.
#           Possible values: maxdist, buffer, centroid,
#                            random, pointonsurface
# polypart: Which parts each multipolygon to use ("all" or "largest").
#           Note that "largest" also removes any holes before
#           calculating the label position, so the labels are
#           no longer guaranteed not to overlap a hole.
#   doplot: Should the labels be plotted on the current graphics device?
#      ...: Additional arguments sent to "text"
polygonsLabel = function(pols, labels = NULL, method = c("maxdist",
                         "buffer", "centroid", "random", "inpolygon")[1],
                         gridpoints = 60, polypart = c("all", "largest")[1],
                         cex = 1, doPlot = TRUE, ...) {

  # Return a SpatialPolygons object containing the
  # biggest polygon part of a multipolygon
  getLargestPolyPart = function(multipol) {
    pols = multipol@polygons[[1]]@Polygons
    
    if(length(pols) > 1) {
      areas = lapply(pols, function(x) x@area) # List of areas of the polygon parts
      pols = pols[which.max(areas)]            # The largest polygon part
    
    # Create new SpatialPolygons object only containing the largest polygon part
    multipol = SpatialPolygons(list(Polygons(pols, ID="1")),
                             proj4string=CRS(as.character(proj4string(multipol))))
    }
    
    multipol
  }
  
  # If no labels are given, assume empty labels
  if(is.null(labels)) labels = ""
  
  # If ncessary, convert the labels into character labels
  # (needed for factor labels)
  if( !is.character(labels))
    labels=as.character(labels)
  
  # Recycle all arguments so they contain the same
  # number of elements as there are polygons
  n = length(pols)
  labels = rep(labels, length = n)
  method = rep(method, length = n)
  polypart = rep(polypart, length = n)
  
  # For each polygon, calculate the optimal label position
  ret = matrix(ncol=2, nrow = n)
  for (i in seq_along(labels)) {
      labw = strwidth(labels[i], cex = cex)  # Label width
      labh = strheight(labels[i], cex = cex) # Label height
      if(labw == 0) labw = labh # For the empty string, use a one-line high square
      pol = pols[i,]            # The polygon of interest
      
      # Optionally remove smaller polygon parts
      if(polypart[i] == "largest") pol = getLargestPolyPart(pol)
          
      # Calculate the label optimal label position
      ret[i,] = switch(method[i], "maxdist" = labpos.maxdist(pol, labw, labh, gridpoints),
                                  "buffer" = labpos.buffer(pol, getLargestPolyPart=getLargestPolyPart),
                                  "centroid" = coordinates(pol),
                                  "random" = labpos.random(pol),
                                  "inpolygon" = coordinates(gPointOnSurface(pol)),
                                  stop(paste("Unknown method:", method[i])))
  }
  
  # Optionally plot the labels
  if(doPlot)
    text(ret, labels, cex=cex, ...)
  
  ret
}

# TODO:
#
#   Automatic reprojection for unprojected maps
#     (simple quirectangular, to match what "plot" does).
#
#   Option to auto-rotate labels (default < +/-30 degrees)
#     to make them fit (better).
#
#   Better error handling (option to stop or to use
#   centroids when no valid label positions are found).
#
#   A "removeholes" option?

gBuffer = function(spgeom, byid=FALSE, id=NULL, width=1.0, quadsegs=5, 
                     capStyle="ROUND", joinStyle="ROUND", mitreLimit=1.0) {

  .Deprecated("", package="rgeos", msg="GEOS support is provided by the sf and terra packages among others")
    stopifnot(is.logical(byid))
    if (!is.na(is.projected(spgeom)) && !is.projected(spgeom))
     warning("Spatial object is not projected; GEOS expects planar coordinates")
# Josh O'Brien 2016-02-08
    byid_status <- byid
    if (byid && length(spgeom) == 1) {
        id <- row.names(spgeom)[1]
        byid <- FALSE
        byid_status <- TRUE
        #message("byid set to FALSE; single feature detected")
    }
    GEOSCapStyles = c("ROUND","FLAT","SQUARE")
    GEOSJoinStyles = c("ROUND","MITRE","BEVEL")

    
    curids = unique(row.names(spgeom))
    if (is.null(id)) {
        if (byid)   id = curids
        else        id = "buffer"
    }
    
    if (byid == TRUE  && length(id) != length(curids) )
        stop("if applying by ids, new ids must be same length as current ids")
    if (byid == FALSE && length(id) != 1 ) 
        stop("if applying across ids, new id must be length 1")
    
    id = as.character(id)
    width = as.numeric(width)
    n <- length(curids)
    if (byid) {
        if (length(width) == 1) width <- rep(width, n)
        stopifnot(length(width) == n)
    } else {
        stopifnot(length(width) == 1)
    }
    quadsegs = as.integer(quadsegs)
    byid = as.logical(byid)
    mitreLimit=as.numeric(mitreLimit)
    
    if (is.character(capStyle)) 
        capStyle = which(match.arg(toupper(capStyle),GEOSCapStyles) == GEOSCapStyles)
    if (is.character(joinStyle)) 
        joinStyle = which(match.arg(toupper(joinStyle),GEOSJoinStyles) == GEOSJoinStyles)
    
    if ( !(capStyle %in% 1:length(GEOSCapStyles)) ) stop("invalid cap style")
    if ( !(joinStyle %in% 1:length(GEOSJoinStyles)) ) stop("invalid join style")
    
    capStyle= as.integer(capStyle)
    joinStyle= as.integer(joinStyle)
    
    if (mitreLimit <= 0) 
        stop("mitreLimit must be greater than 0")
    if (capStyle == 2 && inherits(spgeom,"SpatialPoints")) 
        stop("Flat capstyle is incompatible with SpatialPoints geometries")
    if (any(width < 0) && !inherits(spgeom,"SpatialPolygons")) 
        stop("Negative width values may only be used with SpatialPolygons geometries")

    ans = .Call("rgeos_buffer", .RGEOS_HANDLE, spgeom, byid, id, width, quadsegs,
                                capStyle, joinStyle, mitreLimit, PACKAGE="rgeos")
 
	if (!is.null(ans) && byid_status) {
	    if (.hasSlot(spgeom, 'data')) {
                m1 <- match(row.names(ans), id)
                df1 <- spgeom@data[m1, , drop=FALSE]
                row.names(df1) <- id[m1]
	        ans <- SpatialPolygonsDataFrame(ans, df1)
		}	
	}
 
    return(ans)
}

RGEOSBuffer = function(spgeom, byid=TRUE, id=NULL, width=1.0, quadsegs=5, 
                       capStyle="ROUND", joinStyle="ROUND", mitreLimit=1.0) {
   .Deprecated("gBuffer")
   return( gBuffer(spgeom, byid, id, width, quadsegs, capStyle, joinStyle, mitreLimit) )
}

#RGEOSSingleSidedBuffer = function(spgeom, width, quadsegs, joinStyle, mitreLimit) {
#    
#    GEOSCapStyles = c("ROUND","FLAT","SQUARE")
#    GEOSJoinStyles = c("ROUND","MITRE","BEVEL")
#}

\name{gCrosses}
\alias{gCrosses}
\alias{RGEOSCrosses}
\alias{gOverlaps}
\alias{RGEOSOverlaps}

\title{Geometry Relationships - Crosses and Overlaps}
\description{Functions for testing whether geometries share some but not all interior points}
\usage{
	gCrosses(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE,
 checkValidity=FALSE)
	gOverlaps(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE,
 checkValidity=FALSE)
}
	
\arguments{
  \item{spgeom1, spgeom2}{sp objects as defined in package sp. If spgeom2 is NULL then spgeom1 is compared to itself.}
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{returnDense}{default TRUE, if false returns a list of the length of spgeom1 of integer vectors listing the \code{1:length(spgeom2)} indices which would be TRUE in the dense logical matrix representation; useful when the sizes of the byid=TRUE returned matrix is very large and it is sparse; essential when the returned matrix would be too large}
  \item{checkValidity}{default FALSE; error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is TRUE, \code{gIsValid} is run on each in turn in an environment in which object names are available. If objects are invalid, this is reported and those affected are named}
}

\value{\code{gCrosses} returns TRUE when the geometries share some but not all interior points, and the dimension of the intersection is less than that of at least one of the geometries.

\code{gOverlaps} returns TRUE when the geometries share some but not all interior points, and the intersection has the same dimension as the geometries themselves.
}

\note{Error messages from GEOS, in particular topology exceptions, report 0-based object order, so geom 0 is spgeom1, and geom 1 is spgeom2.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gContains}}
\code{\link{gContainsProperly}}
\code{\link{gCovers}}
\code{\link{gCoveredBy}}
\code{\link{gDisjoint}}
\code{\link{gEquals}}
\code{\link{gEqualsExact}}
\code{\link{gIntersects}}
\code{\link{gRelate}}
\code{\link{gTouches}}
\code{\link{gWithin}}
}

\examples{
	l1 = readWKT("LINESTRING(0 3,1 1,2 2,3 0)")
	l2 = readWKT("LINESTRING(0 0.5,1 1,2 2,3 2.5)")
	l3 = readWKT("LINESTRING(1 3,1.5 1,2.5 2)")
	
	pt1 = readWKT("MULTIPOINT(1 1,3 0)")
	pt2 = readWKT("MULTIPOINT(1 1,3 0,1 2)")

	p1 = readWKT("POLYGON((0 0,0 2,1 3.5,3 3,4 1,3 0,0 0))")
	p2 = readWKT("POLYGON((2 2,3 4,4 1,4 0,2 2))")
	
	par(mfrow=c(2,3))
	plot(l1,col='blue');plot(pt1,add=TRUE,pch=16)
	title(paste("Crosses:",gCrosses(l1,pt1),
				"\nOverlaps:",gOverlaps(l1,pt1)))
	
	plot(l1,col='blue');plot(pt2,add=TRUE,pch=16)
	title(paste("Crosses:",gCrosses(l1,pt2),
				"\nOverlaps:",gOverlaps(l1,pt2)))
				
	plot(l1,col='blue');plot(l2,add=TRUE)
	title(paste("Crosses:",gCrosses(l1,l2),
				"\nOverlaps:",gOverlaps(l1,l2)))
				
	plot(l1,col='blue');plot(l3,add=TRUE)
	title(paste("Crosses:",gCrosses(l1,l3),
				"\nOverlaps:",gOverlaps(l1,l3)))
				
	plot(p1,border='blue',col='blue');plot(l1,add=TRUE)
	title(paste("Crosses:",gCrosses(p1,l1),
				"\nOverlaps:",gOverlaps(p1,l1)))

	plot(p1,border='blue',col='blue');plot(p2,add=TRUE)
	title(paste("Crosses:",gCrosses(p1,p2),
				"\nOverlaps:",gOverlaps(p1,p2)))
				
}
\keyword{spatial}

\name{rgeos-deprecated}
\alias{rgeos-deprecated}
\alias{gBuffer}
\alias{RGEOSBuffer}
\alias{gDifference}
\alias{gIntersection}
\alias{gSymdifference}
\alias{gUnion}
\title{Deprecated functions and methods}
\description{Cumulative deprecated functions and methods from rgeos prior to package retirement/archiving during 2023.}
\usage{
gBuffer(spgeom, byid=FALSE, id=NULL, width=1.0, quadsegs=5, capStyle="ROUND",
 joinStyle="ROUND", mitreLimit=1.0)
gDifference(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_lower_td=FALSE,
 unaryUnion_if_byid_false=TRUE, checkValidity=NULL)
gSymdifference(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_lower_td=FALSE,
 unaryUnion_if_byid_false=TRUE, checkValidity=NULL)
gIntersection(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_not_poly,
 drop_lower_td=FALSE, unaryUnion_if_byid_false=TRUE, checkValidity=NULL)
gUnion(spgeom1, spgeom2, byid=FALSE, id=NULL, drop_lower_td=FALSE,
 unaryUnion_if_byid_false=TRUE, checkValidity=NULL)
}
\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
  \item{width}{Distance from original geometry to include in the new geometry. Negative values are allowed. Either a numeric vector of length 1 when byid is FALSE; if byid is TRUE: of length 1 replicated to the number of input geometries, or of length equal to the number of input geometries}
  \item{quadsegs}{Number of line segments to use to approximate a quarter circle.}
  \item{capStyle}{Style of cap to use at the ends of the geometry. Allowed values: \code{ROUND},\code{FLAT},\code{SQUARE}}
  \item{joinStyle}{Style to use for joints in the geometry. Allowed values: \code{ROUND},\code{MITRE},\code{BEVEL}}
  \item{mitreLimit}{Numerical value that specifies how far a joint can extend if a mitre join style is used.}
  \item{spgeom1, spgeom2}{sp objects as defined in package sp}
  \item{drop_lower_td}{default FALSE; if TRUE, objects will be dropped from output GEOMETRYCOLLECTION objects to simplify output if their topological dinension is less than the minimum topological dinension of the input objects.}
  \item{unaryUnion_if_byid_false}{default TRUE; if \code{byid} takes a FALSE in either position, the subgeometries are combined first to avoid possible topology exceptions (change in 0.3-13, previous behaviour did not combine subgeometries, and may be achieved by setting this argument FALSE}
  \item{checkValidity}{default NULL, integer 0L (no action), 1L (check), 2L (check and try to buffer by zero distance to repair). If NULL, a value set to 0L for GEOS < 3.7.2, 1L for GEOS >= 3.7.2 is read from values assigned on load. Error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is > 0L, \code{gIsValid} is run on each in turn}
  \item{drop_not_poly}{deprecated argument, use drop_lower_td}
}
\examples{
p1 = readWKT("POLYGON((0 1,0.95 0.31,0.59 -0.81,-0.59 -0.81,-0.95 0.31,0 1))")
p2 = readWKT("POLYGON((2 2,-2 2,-2 -2,2 -2,2 2),(1 1,-1 1,-1 -1,1 -1,1 1))")

par(mfrow=c(2,3))
plot(gBuffer(p1,width=-0.2),col='black',xlim=c(-1.5,1.5),ylim=c(-1.5,1.5))
plot(p1,border='blue',lwd=2,add=TRUE);title("width: -0.2")
plot(gBuffer(p1,width=0),col='black',xlim=c(-1.5,1.5),ylim=c(-1.5,1.5))
plot(p1,border='blue',lwd=2,add=TRUE);title("width: 0")
plot(gBuffer(p1,width=0.2),col='black',xlim=c(-1.5,1.5),ylim=c(-1.5,1.5))
plot(p1,border='blue',lwd=2,add=TRUE);title("width: 0.2")

plot(gBuffer(p2,width=-0.2),col='black',pbg='white',xlim=c(-2.5,2.5),ylim=c(-2.5,2.5))
plot(p2,border='blue',lwd=2,add=TRUE);title("width: -0.2")
plot(gBuffer(p2,width=0),col='black',pbg='white',xlim=c(-2.5,2.5),ylim=c(-2.5,2.5))
plot(p2,border='blue',lwd=2,add=TRUE);title("width: 0")
plot(gBuffer(p2,width=0.2),col='black',pbg='white',xlim=c(-2.5,2.5),ylim=c(-2.5,2.5))
plot(p2,border='blue',lwd=2,add=TRUE);title("width: 0.2")

p3 <- readWKT(paste("GEOMETRYCOLLECTION(",
 "POLYGON((0 1,0.95 0.31,0.59 -0.81,-0.59 -0.81,-0.95 0.31,0 1)),",
 "POLYGON((2 2,-2 2,-2 -2,2 -2,2 2),(1 1,-1 1,-1 -1,1 -1,1 1)))"))

par(mfrow=c(1,1))
plot(gBuffer(p3, byid=TRUE, width=c(-0.2, -0.1)),col='black',pbg='white',
xlim=c(-2.5,2.5),ylim=c(-2.5,2.5))
plot(p3,border=c('blue', 'red'),lwd=2,add=TRUE);title("width: -0.2, -0.1")
library(sp)
p3df <- SpatialPolygonsDataFrame(p3, data=data.frame(i=1:length(p3),
 row.names=row.names(p3)))
dim(p3df)
row.names(p3df)
dropEmpty = gBuffer(p3df, byid=TRUE, id=letters[1:nrow(p3df)], width=c(-1, 0))
dim(dropEmpty)
row.names(dropEmpty)
row.names(slot(dropEmpty, "data"))
plot(dropEmpty, col='black', pbg='white', xlim=c(-2.5,2.5),ylim=c(-2.5,2.5))
plot(p3df,border=c('blue'),lwd=2,add=TRUE);title("width: -1, 0")
par(mfrow=c(2,3))


#Style options
l1 = readWKT("LINESTRING(0 0,1 5,4 5,5 2,8 2,9 4,4 6.5)")
par(mfrow=c(2,3))
plot(gBuffer(l1,capStyle="ROUND"));plot(l1,col='blue',add=TRUE);title("capStyle: ROUND")
plot(gBuffer(l1,capStyle="FLAT"));plot(l1,col='blue',add=TRUE);title("capStyle: FLAT")
plot(gBuffer(l1,capStyle="SQUARE"));plot(l1,col='blue',add=TRUE);title("capStyle: SQUARE")

plot(gBuffer(l1,quadsegs=1));plot(l1,col='blue',add=TRUE);title("quadsegs: 1")
plot(gBuffer(l1,quadsegs=2));plot(l1,col='blue',add=TRUE);title("quadsegs: 2")
plot(gBuffer(l1,quadsegs=5));plot(l1,col='blue',add=TRUE);title("quadsegs: 5")



l2 = readWKT("LINESTRING(0 0,1 5,3 2)")
par(mfrow=c(2,3))
plot(gBuffer(l2,joinStyle="ROUND"));plot(l2,col='blue',add=TRUE);title("joinStyle: ROUND")
plot(gBuffer(l2,joinStyle="MITRE"));plot(l2,col='blue',add=TRUE);title("joinStyle: MITRE")
plot(gBuffer(l2,joinStyle="BEVEL"));plot(l2,col='blue',add=TRUE);title("joinStyle: BEVEL")

plot(gBuffer(l2,joinStyle="MITRE",mitreLimit=0.5));plot(l2,col='blue',add=TRUE)
 title("mitreLimit: 0.5")
plot(gBuffer(l2,joinStyle="MITRE",mitreLimit=1));plot(l2,col='blue',add=TRUE)
 title("mitreLimit: 1")
plot(gBuffer(l2,joinStyle="MITRE",mitreLimit=3));plot(l2,col='blue',add=TRUE)
 title("mitreLimit: 3")
x = readWKT("POLYGON ((0 0, 0 10, 10 10, 10 0, 0 0))")
y = readWKT("POLYGON ((3 3, 7 3, 7 7, 3 7, 3 3))")

d = gDifference(x,y)
plot(d,col='red',pbg='white')

# Empty geometry since y is completely contained with x
d2 = gDifference(y,x)
if (require(maptools)) {
xx <- readShapeSpatial(system.file("shapes/fylk-val-ll.shp", package="maptools")[1],
 proj4string=CRS("+proj=longlat +datum=WGS84"))
bbxx <- bbox(xx)
wdb_lines <- system.file("share/wdb_borders_c.b", package="maptools")
xxx <- Rgshhs(wdb_lines, xlim=bbxx[1,], ylim=bbxx[2,])$SP
res <-gIntersection(xx, xxx)
plot(xx, axes=TRUE)
plot(xxx, lty=2, add=TRUE)
plot(res, add=TRUE, pch=16,col='red')
}
pol <- readWKT(paste("POLYGON((-180 -20, -140 55, 10 0, -140 -60, -180 -20),",
 "(-150 -20, -100 -10, -110 20, -150 -20))"))
library(sp)
GT <- GridTopology(c(-175, -85), c(10, 10), c(36, 18))
gr <- as(as(SpatialGrid(GT), "SpatialPixels"), "SpatialPolygons")
try(res <- gIntersection(pol, gr, byid=TRUE))
res <- gIntersection(pol, gr, byid=TRUE, drop_lower_td=TRUE)
# Robert Hijmans difficult intersection case
load(system.file("test_cases/polys.RData", package="rgeos"))
try(res <- gIntersection(a, b, byid=TRUE))
res <- gIntersection(a, b, byid=TRUE, drop_lower_td=TRUE)
unlist(sapply(slot(res, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
# example from Pius Korner 2015-10-25
poly1 <- SpatialPolygons(list(Polygons(list(Polygon(coords=matrix(c(0, 0, 2, 2, 0, 1, 1, 0),
 ncol=2, byrow=FALSE))), ID=c("a")), Polygons(list(Polygon(coords=matrix(c(0, 0, 2, 2, 2, 3, 3, 2),
 ncol=2, byrow=FALSE))), ID=c("b"))))
poly2 <- SpatialPolygons(list(Polygons(list(Polygon(coords=matrix(c(0, 0, 2, 2,
 1, 1, 1, 3, 3, 0, 0, 2), ncol=2, byrow=FALSE))), ID=c("c"))))
plot(poly1, border="orange")
plot(poly2, border="blue", add=TRUE, lty=2, density=8, angle=30, col="blue")
gI <- gIntersection(poly1, poly2, byid=TRUE, drop_lower_td=TRUE)
plot(gI, add=TRUE, border="red", lwd=3)
oT <- get_RGEOS_polyThreshold()
oW <- get_RGEOS_warnSlivers()
oD <- get_RGEOS_dropSlivers()
set_RGEOS_polyThreshold(1e-3)
set_RGEOS_warnSlivers(TRUE)
res1 <- gIntersection(a, b, byid=TRUE, drop_lower_td=TRUE)
unlist(sapply(slot(res1, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
set_RGEOS_dropSlivers(TRUE)
res2 <- gIntersection(a, b, byid=TRUE, drop_lower_td=TRUE)
unlist(sapply(slot(res2, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
set_RGEOS_dropSlivers(FALSE)
oo <- gUnaryUnion(res1, c(rep("1", 3), "2", "3", "4"), checkValidity=2L)
unlist(sapply(slot(oo, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
ooo <- gIntersection(b, oo, byid=TRUE, checkValidity=2L)
gArea(ooo, byid=TRUE)
unlist(sapply(slot(ooo, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
set_RGEOS_dropSlivers(TRUE)
ooo <- gIntersection(b, oo, byid=TRUE, checkValidity=2L)
gArea(ooo, byid=TRUE)
unlist(sapply(slot(ooo, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
set_RGEOS_polyThreshold(oT)
set_RGEOS_warnSlivers(oW)
set_RGEOS_dropSlivers(oD)
# see thread https://stat.ethz.ch/pipermail/r-sig-geo/2015-September/023468.html
Pol1=rbind(c(0,0),c(0,10),c(10,10),c(10,0),c(0,0))
Pol2=rbind(c(0,0),c(10,0),c(10,-10),c(0,-10),c(0,0))
library(sp)
Pols1=Polygons(list(Polygon(Pol1)),"Pols1")
Pols2=Polygons(list(Polygon(Pol2)),"Pols2")
MyLay=SpatialPolygons(list(Pols1,Pols2))
Pol1l=Pol1+0.5
Pol2l=Pol2+0.5
Pols1l=Polygons(list(Polygon(Pol1l)),"Pols1l")
Pols2l=Polygons(list(Polygon(Pol2l)),"Pols2l")
MyLayl=SpatialPolygons(list(Pols1l,Pols2l))
inter=gIntersection(MyLay, MyLayl)
plot(MyLay)
plot(MyLayl,add=TRUE)
plot(inter, add=TRUE, border="green")
try(gIntersection(MyLay, MyLayl, unaryUnion_if_byid_false=FALSE))
Pol1=rbind(c(0,0),c(0,1),c(1,1),c(1,0),c(0,0))
Pol2=rbind(c(0,0),c(1,0),c(1,-1),c(0,-1),c(0,0))
Pols1=Polygons(list(Polygon(Pol1)),"Pols1")
Pols2=Polygons(list(Polygon(Pol2)),"Pols2")
MyLay=SpatialPolygons(list(Pols1,Pols2))
Pol1l=Pol1+0.1
Pol2l=Pol2+0.1
Pols1l=Polygons(list(Polygon(Pol1l)),"Pols1l")
Pols2l=Polygons(list(Polygon(Pol2l)),"Pols2l")
MyLayl=SpatialPolygons(list(Pols1l,Pols2l))
inter=gIntersection(MyLay, MyLayl, unaryUnion_if_byid_false=FALSE)
gEquals(inter, MyLay)
inter1=gIntersection(MyLay, MyLayl, unaryUnion_if_byid_false=TRUE)
gEquals(inter1, MyLay)
gEquals(inter, inter1)
plot(MyLay, ylim=c(-1, 1.1))
plot(MyLayl, add=TRUE)
plot(inter, angle=45, density=10, add=TRUE)
plot(inter1, angle=135, density=10, add=TRUE)
inter2=gIntersection(MyLay, MyLayl)
gEquals(inter2, MyLay)
gEquals(inter1, inter2)
x = readWKT("POLYGON ((0 0, 0 10, 10 10, 10 0, 0 0))")
y = readWKT("POLYGON ((5 5, 15 5, 15 15, 5 15, 5 5))")

d = gSymdifference(x,y)
plot(d,col='red',pbg='white')
}

\name{RGEOS WKT Functions}
\alias{readWKT}
\alias{writeWKT}

\title{RGEOS WKT Functions}
\description{Functions for reading and writing Well Known Text (WKT)}
\usage{
	readWKT(text, id = NULL, p4s = NULL)
	writeWKT(spgeom, byid = FALSE)
}

\arguments{
  \item{text}{character string of WKT}
  \item{id}{character vector of unique ids to label geometries. Length must match the number of subgeometries in the WKT}
  \item{p4s}{Either a character string or an object of class \code{CRS}}
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
}

\details{readWKT processes the given WKT string and returns an appropriate sp geometry object. If id is not specified then geometries will be labeled by their index position. Because no sp Spatial object may be empty, \code{readWKT} is not permitted to create an empty object.

writeWKT converts an sp geometry object to a GEOS C object which is then written out as a WKT string. If byid is TRUE then each subgeometry is individually converted to a WKT string.}

\references{Additional information on WKT Simple Feature Specification can be found at the following locations:

\url{https://www.ogc.org/standards/sfs}

\url{https://en.wikipedia.org/wiki/Well-known_text}

\url{https://en.wikipedia.org/wiki/Simple_Features}
}

\author{Colin Rundel}


\examples{
g1=readWKT("POINT(6 10)")
g2=readWKT("LINESTRING(3 4,10 50,20 25)")
g3=readWKT("POLYGON((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2))")
g4=readWKT("MULTIPOINT((3.5 5.6),(4.8 10.5))")
g5=readWKT("MULTILINESTRING((3 4,10 50,20 25),(-5 -8,-10 -8,-15 -4))")
g6=readWKT("MULTIPOLYGON(((1 1,5 1,5 5,1 5,1 1),(2 2,2 3,3 3,3 2,2 2)),((6 3,9 2,9 4,6 3)))")
try(readWKT("POINT EMPTY"))
try(readWKT("MULTIPOLYGON EMPTY"))
g9=readWKT("GEOMETRYCOLLECTION(POINT(4 6),LINESTRING(4 6,7 10))")

writeWKT(g1)
writeWKT(g2)
writeWKT(g3)
writeWKT(g4)
writeWKT(g5)
writeWKT(g6)
writeWKT(g9,byid=FALSE)
writeWKT(g9,byid=TRUE)
}

\keyword{spatial}

\name{SpatialCollections-class}
\docType{class}
\alias{SpatialCollections-class}
\alias{SpatialLinesNULL-class}
\alias{SpatialRingsNULL-class}
\alias{SpatialPolygonsNULL-class}
\alias{SpatialPointsNULL-class}
\alias{row.names,SpatialCollections-method}
\alias{plot,SpatialCollections,missing-method}


\title{Class "SpatialCollections"}
\description{  class to hold SpatialPoints, SpatialLines, SpatialRings, and SpatialPolygons (without attributes) }
\section{Objects from the Class}{
Objects can be created by calls to the function \link{SpatialCollections}
}
\section{Slots}{
  \describe{
	\item{\code{pointobj}:}{Object of class SpatialPoints or NULL}
    \item{\code{lineobj}:}{Object of class SpatialLines or NULL}
	\item{\code{ringobj}:}{Object of class SpatialRings or NULL}
	\item{\code{polyobj}:}{Object of class SpatialPolygons or NULL}
	\item{\code{plotOrder}:}{Numeric vector of length 4}
  }
}

\section{Extends}{
	Class \code{"Spatial"}, directly.
}

\section{Methods}{
Methods defined with class "SpatialCollections" in the signature:
  \describe{
	\item{plot}{\code{signature(x = "SpatialCollections", y = "missing")}: plot objects within the SpatialCollections object in the order specified by plotOrder slot}
	\item{row.names}{\code{signature(object = "SpatialCollections")}: retrieves the ID elements from non-NULL geometry slots}
  }
}

\author{ Colin Rundel }
\seealso{ \link{SpatialCollections} \link{SpatialPoints} \link{SpatialLines} \link{SpatialRings} \link{SpatialPolygons} }

\examples{ 
	#NONE 
}

\keyword{classes}

\name{gNode}
\alias{gNode}

\title{Linestring Noder}
\description{Function attempts to node a linestring object, inserting coordinates at intersection points; only available for GEOS >= 3.4.0.}
\usage{
	gNode(spgeom);
}

\arguments{
  \item{spgeom}{an sp object inheriting from SpatialLines}
}

\value{Returns a noded linestring object.}

\details{Because \code{\link{gPolygonize}} expects linestrings to be fully noded, as such they must not cross and must touch only at endpoints. \code{gNodee} takes an object inheriting from \code{SpatialLines} and attempts to add omitted nodes. Issue reported by Nicola Farina 21 March 2014.}


\author{Roger Bivand}

\seealso{\code{\link{gPolygonize}}}

\examples{
library(sp)
pol1 <- readWKT(paste("POLYGON((39.936 43.446, 39.94 43.446, 39.94 43.45,",
 "39.936 43.45, 39.936 43.446))"))
pol2 <- readWKT(paste("POLYGON((39.9417 43.45, 39.9395 43.4505,",
 "39.9385 43.4462, 39.9343 43.4452, 39.9331 43.4469, 39.9417 43.45))"))
plot(pol2, axes=TRUE)
plot(pol1, add=TRUE, border="blue")
gIsValid(pol1)
gIsValid(pol2)
try(res <- gUnion(pol1, pol2))
if (version_GEOS0() > "3.4.0") {
pol2a <- gPolygonize(gNode(as(pol2, "SpatialLines")))
try(res <- gUnion(pol1, pol2a))
plot(res, add=TRUE, border="red", lty=2, lwd=2)
set.seed(1)
# rw from Jim Holtman's R-help posting 2010-12-2
n <- 1000
rw <- matrix(0, ncol = 2, nrow = n)
indx <- cbind(seq(n), sample(c(1, 2), n, TRUE))
rw[indx] <- sample(c(-1, 1), n, TRUE)
rw[,1] <- cumsum(rw[, 1])
rw[, 2] <- cumsum(rw[, 2])
slrw <- SpatialLines(list(Lines(list(Line(rw)), "1")))
res0 <- gNode(slrw)
print(length(slrw))
print(length(res0))
res <- gPolygonize(res0)
print(summary(res))
print(length(res))
plot(res0, axes=TRUE)
plot(res, add=TRUE, col=sample(rainbow(length(res))))
# library(spatstat)
# set.seed(0)
# X <- psp(runif(100), runif(100), runif(100), runif(100), window=owin())
# library(maptools)
# sppsp <- as(X, "SpatialLines")
# writeLines(writeWKT(sppsp, byid=FALSE), con="sppsp.wkt")
sppsp <- readWKT(readLines(system.file("wkts/sppsp.wkt", package="rgeos")))
plot(sppsp, axes=TRUE)
res0 <- gNode(sppsp)
res <- gPolygonize(res0)
plot(res, add=TRUE, col=sample(rainbow(length(res))))
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{new-generics}
\alias{new-generics}
\alias{append.poly}
\alias{append.poly-methods}
%\alias{append.poly,gpc.poly,gpc.poly-method}
\alias{get.bbox}
\alias{get.bbox-methods}
%\alias{get.bbox,gpc.poly-method}
\alias{area.poly}
\alias{area.poly-methods}
%\alias{area.poly,gpc.poly-method}
\alias{get.pts}
\alias{get.pts-methods}
%\alias{get.pts,gpc.poly-method}
\alias{scale.poly}
\alias{scale.poly-methods}
%\alias{scale.poly,gpc.poly-method}
%\alias{[-methods}
%\alias{[,gpc.poly-method}
\alias{tristrip}
\alias{tristrip-methods}
\alias{triangulate}
\alias{triangulate-methods}
\alias{symdiff}

\title{Generics/Methods for polygon objects}

\description{
  Some generic functions and methods for polygon objects
}

\usage{
append.poly(x, y)
area.poly(object, \dots)
get.pts(object)
get.bbox(x)
scale.poly(x, \dots)
tristrip(x)
triangulate(x)
}

\arguments{
  \item{x,object}{A polygon object}
  \item{y}{A polygon object}
  \item{\dots}{Other arguments passed to methods}
}

\section{Methods}{
  \describe{
    \item{append.poly}{\code{signature(x = "gpc.poly", y =
	"gpc.poly")}:  Combine all contours of two \code{"gpc.poly"}
      objects and return the combined polygon as a \code{"gpc.poly"}
      object.}
    \item{area.poly}{\code{signature(object = "gpc.poly")}:  Compute and
      return the sum of the areas of all contours in a \code{"gpc.poly"}
      object.}
    \item{scale.poly}{\code{signature(x = "gpc.poly")}:  Scale (divide)
      the x and y coordinates of a \code{"gpc.poly"} object by the
      amount \code{xscale} and \code{yscale}, respectively.  Return a
      scaled \code{"gpc.poly"} object.}
    \item{get.pts}{\code{signature(object = "gpc.poly")}:  Return the
      list of x and y coordinates of the vertices of a \code{"gpc.poly"}
      object.}
    \item{get.bbox}{\code{signature(x = "gpc.poly")}:  Return the
      bounding box for a \code{"gpc.poly"} object.}
    \item{tristrip}{\code{signature(x = "gpc.poly")}:  Return a tristrip
      list for a  \code{"gpc.poly"} object.}
    \item{triangulate}{\code{signature(x = "gpc.poly")}:  Return a matrix
      of vertices of a triangulation of a \code{"gpc.poly"} object.}
  }
  
}

\details{
The result of \code{tristrip(x)} is a list of two-column matrices.  Each
matrix is a tristrip, i.e. the rows are vertices of triangles, with
each overlapping triple of rows corresponding to a separate triangle.

The result of \code{triangulate(x)} is a single two-column matrix.  The 
rows are vertices of triangles, taken in non-overlapping triples.
  
}


\author{Roger D. Peng; GPC Library by Alan Murta; tristrip additions by
Duncan Murdoch}


\seealso{\code{"gpc.poly"} class documentation.}
\examples{
holepoly <- read.polyfile(system.file("poly-ex-gpc/hole-poly.txt",
 package ="rgeos"), nohole = FALSE)
area.poly(holepoly)
stopifnot(area.poly(holepoly) == 8)
}
\keyword{methods}

\name{gSimplify}
\alias{gSimplify}

\title{Simplify Geometry}
\description{Function simplifies the given geometry using the Douglas-Peuker algorithm}
\usage{
	gSimplify(spgeom, tol, topologyPreserve=FALSE)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{tol}{Numerical tolerance value to be used by the Douglas-Peuker algorithm}
  \item{topologyPreserve}{Logical determining if the algorithm should attempt to preserve the topology of the original geometry}
}

\value{Returns a simplified version of the given geometry when applied to [MULTI]LINEs or [MULTI]POLYGONs.}

\details{When applied to lines it is possible for the resulting geometry to lose simplicity (\code{\link{gIsSimple}}). If topologyPreserve is not specified it is also possible that the resulting geometries may no longer be valid (\code{\link{gIsValid}}). Remember to check the resulting geometry as many other functions rely on simplicity and or validity when performing their calculations.}

\author{Roger Bivand & Colin Rundel}

\references{
Douglas-Peuker Algorithm:
\url{https://en.wikipedia.org/wiki/Ramer-Douglas-Peucker_algorithm}
}


\examples{
p = readWKT(paste("POLYGON((0 40,10 50,0 60,40 60,40 100,50 90,60 100,60",
 "60,100 60,90 50,100 40,60 40,60 0,50 10,40 0,40 40,0 40))"))
l = readWKT("LINESTRING(0 7,1 6,2 1,3 4,4 1,5 7,6 6,7 4,8 6,9 4)")

par(mfrow=c(2,4))
plot(p);title("Original")
plot(gSimplify(p,tol=10));title("tol: 10")
plot(gSimplify(p,tol=20));title("tol: 20")
plot(gSimplify(p,tol=25));title("tol: 25")

plot(l);title("Original")
plot(gSimplify(l,tol=3));title("tol: 3")
plot(gSimplify(l,tol=5));title("tol: 5")
plot(gSimplify(l,tol=7));title("tol: 7")
par(mfrow=c(1,1))
}

\keyword{spatial}

\name{SpatialRingsDataFrame-class}
\docType{class}
\alias{SpatialRingsDataFrame-class}
\alias{[,SpatialRingsDataFrame-method}
\alias{plot,SpatialRingsDataFrame-method}
\alias{bbox,SpatialRingsDataFrame-method}
\alias{coordinates,SpatialRingsDataFrame-method}
\alias{coordnames,SpatialRingsDataFrame-method}
\alias{coordnames<-,SpatialRingsDataFrame,character-method}
\alias{row.names,SpatialRingsDataFrame-method}
\alias{row.names<-,SpatialRingsDataFrame,character-method}

\alias{names,SpatialRingsDataFrame-method}
\alias{names<-,SpatialRingsDataFrame,character-method}

\alias{dim,SpatialRingsDataFrame-method}

\alias{spChFIDs,SpatialRingsDataFrame,character-method}
\alias{coerce,SpatialRingsDataFrame,SpatialPoints-method}

\alias{coerce,SpatialRingsDataFrame,SpatialRings-method}
\alias{coerce,SpatialRingsDataFrame,data.frame-method}


\title{Class "SpatialRingsDataFrame"}
\description{  class to hold linear ring topology (without attributes) }
\section{Objects from the Class}{
Objects can be created by calls to the function \link{SpatialRingsDataFrame}
}
\section{Slots}{
  \describe{
	\item{\code{data}:}{Object of class \code{"data.frame"}; attribute table }
    \item{\code{rings}:}{Object of class \code{"list"}; list elements are
	all of class \link{Ring-class}}
    \item{\code{bbox}:}{Object of class \code{"matrix"}; see \link{Spatial-class} }
    \item{\code{proj4string}:}{Object of class \code{"CRS"}; see \link{CRS-class}}
  }
}

\section{Extends}{
Class \code{"SpatialRings"}, directly.
Class \code{"Spatial"}, by class \code{"SpatialRings"}.
}

\section{Methods}{
Methods defined with class "SpatialRingsDataFrame" in the signature:
  \describe{
    \item{[}{\code{signature(obj = "SpatialRingsDataFrame")}: select subset of (sets of) rings; NAs are not permitted in the row index}
	\item{plot}{\code{signature(x = "SpatialRingsDataFrame", y = "missing")}: plot rings in SpatialRingsDataFrame object}
	\item{bbox}{\code{signature(obj = "SpatialRingsDataFrame")}: retrieves the bbox element }
	\item{coordinates}{\code{signature(object = "SpatialRingsDataFrame")}: retrieves the coords element from Ring objects in rings slot}
	\item{coordnames}{\code{signature(object = "SpatialRingsDataFrame")}: retrieves coordinate names}
	\item{row.names}{\code{signature(object = "SpatialRingsDataFrame")}: retrieves the ID element from Ring objects in rings slot}
	\item{spChFIDs}{\code{signature(obj="SpatialRingsDataFrame", x="character")}: replaces ID element}
	
	\item{names}{\code{signature(object = "SpatialRingsDataFrame")}: retrieves names from data element}
	\item{dim}{\code{signature(object = "SpatialRingsDataFrame")}: retrieves dimensions of data element}
	
	\item{coerce}{\code{signature(from = "SpatialRingsDataFrame", to = "SpatialPoints")}: ... }
	\item{coerce}{\code{signature(from = "SpatialRingsDataFrame", to = "SpatialRings")}: ... }
	\item{coerce}{\code{signature(from = "SpatialRingsDataFrame", to = "data.frame")}: ... }
  }
}

\author{ Colin Rundel }
\seealso{ \link{SpatialRingsDataFrame} \link{Ring-class} \link{SpatialRings-class} }

\examples{ 
	#NONE 
}

\keyword{classes}

\name{gUnion}
\alias{gUnaryUnion}
\alias{gUnionCascaded}
\alias{RGEOSUnionCascaded}
\alias{gLineMerge}
\alias{RGEOSLineMerge}

\title{Geometry Union}
\description{Functions for joining intersecting geometries.}
\usage{
gUnionCascaded(spgeom, id = NULL)
gUnaryUnion(spgeom, id = NULL, checkValidity=NULL)
gLineMerge(spgeom, byid=FALSE, id = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels; it may contain NA values for input objects not included in the union; it should define the memberships of the output Polygons objects}
  \item{spgeom}{sp Polygon(s) or Line(s) depending on the function used}
  \item{checkValidity}{default NULL, integer 0L (no action), 1L (check), 2L (check and try to buffer by zero distance to repair). If NULL, a value set to 0L for GEOS < 3.7.2, 1L for GEOS >= 3.7.2 is read from values assigned on load. Error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is > 0L, \code{gIsValid} is run on each in turn}
}

\details{gUnionCascaded expects a single sp object of class SpatialPolygons with subgeometries which it unions together. gUnionCascaded can only dissolve MultiPolygon objects, so GeometryCollection objects to be dissolved, here a SpatialPolygons object, must be flattened a Polygons object; if GEOS version 3.3.0 is available, use gUnaryUnion.

gUnaryUnion expects a single sp object of class SpatialPolygons with subgeometries which it unions together; introduced in GEOS version 3.3.0, and handles GeometryCollection objects. If the id argument is used, it should be a character vector defining the memberships of the output Polygons objects, equal in length to the length of the polygons slot of spgeom.

gLineMerge is similar to gUnionCascaded but is written to work with lines, specifically it joins line segments with intersecting end points. 
}

\note{Error messages from GEOS, in particular topology exceptions, report 0-based object order, so geom 0 is spgeom1, and geom 1 is spgeom2.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gDifference}}
\code{\link{gIntersection}}
\code{\link{gSymdifference}}
}

\examples{
if (require(maptools)) {
nc1 <- readShapePoly(system.file("shapes/sids.shp", package="maptools")[1],
 proj4string=CRS("+proj=longlat +datum=NAD27"))
lps <- coordinates(nc1)
ID <- cut(lps[,1], quantile(lps[,1]), include.lowest=TRUE)
if (version_GEOS0() < "3.3.0") {
   reg4 <- gUnionCascaded(nc1, ID)
} else {
   reg4 <- gUnaryUnion(nc1, ID)
}
row.names(reg4)
par(mfrow=c(2,1))
plot(nc1)
plot(reg4)
par(mfrow=c(1,1))
}
gt <- GridTopology(c(0.05,0.05), c(0.1,0.1), c(2,2))
set.seed(1)
xv <- rnorm(length(coordinates(gt)[,1]))
xvs <- ifelse(xv > 0.2,1,0)
grd <- SpatialGridDataFrame(gt, data.frame(xvs))
spix <- as(grd, "SpatialPixelsDataFrame")
spol <- as(spix, "SpatialPolygonsDataFrame")
image(grd, axes=TRUE)
if (version_GEOS0() < "3.3.0") {
  spol1 <- gUnionCascaded(spol, as.character(spol$xvs))
} else {
  spol1 <- gUnaryUnion(spol, as.character(spol$xvs))
}
plot(spol1, add=TRUE)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{gCentroid}
\alias{gCentroid}
\alias{RGEOSGetCentroid}

\title{Centroid of Geometry}
\description{Function calculates the centroid of the given geometry.}
\usage{
gCentroid(spgeom, byid=FALSE, id = NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
}

\details{Returns a SpatialPoints object of the centroid(s) for spgeom.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gBoundary}}
\code{\link{gConvexHull}}
\code{\link{gEnvelope}}
\code{\link{gPointOnSurface}}
}

\examples{

x = readWKT(paste("GEOMETRYCOLLECTION(POLYGON((0 0,10 0,10 10,0 10,0 0)),",
 "POLYGON((15 0,25 15,35 0,15 0)))"))

# Centroids of both the square and circle independently
c1 = gCentroid(x,byid=TRUE) 
# Centroid of square and circle together
c2 = gCentroid(x)

plot(x)
plot(c1,col='red',add=TRUE)
plot(c2,col='blue',add=TRUE)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{SpatialCollections}
\alias{SpatialCollections}

\title{ create SpatialCollections}

\description{ create object of class \code{SpatialCollections} }

\usage{ 
SpatialCollections(points=NULL, lines=NULL, rings=NULL, polygons=NULL,
 plotOrder=c(4,3,2,1), proj4string=CRS(as.character(NA)))
}

\arguments{
\item{points}{ list with objects of class \link{SpatialPoints-class}}
\item{lines}{ list with objects of class \link{SpatialLines-class}}
\item{rings}{ list with objects of class \link{SpatialRings-class}}
\item{polygons}{ list with objects of class \link{SpatialPolygons-class}}
\item{plotOrder}{ numeric vector of length 4 that determines the order in which the geometries will be plotted. By default polygons will be plotted followed by rings, then lines and finally points.}
\item{proj4string}{Object of class \code{"CRS"} holding a valid proj4 string}
}

\value{
\code{SpatialCollections} returns object of class \code{SpatialCollections}
}

\seealso{ \link{SpatialCollections-class} \link{SpatialPoints-class} \link{SpatialLines-class} \link{SpatialRings-class} \link{SpatialPolygons-class} }

\keyword{manip}

\name{gRelate}
\alias{gRelate}
\alias{RGEOSRelate}

\title{Geometry Relationships - Intersection Matrix Pattern (DE-9IM)}
\description{Determines the relationships between two geometries by comparing the intersection of Interior, Boundary and Exterior  of both geometries to each other. The results are summarized by the Dimensionally Extended 9-Intersection Matrix or DE-9IM.}
\usage{
	gRelate(spgeom1, spgeom2 = NULL, pattern = NULL, byid = FALSE,
 checkValidity=FALSE)
}
	
\arguments{
  \item{spgeom1, spgeom2}{sp objects as defined in package sp. If spgeom2 is NULL then spgeom1 is compared to itself.}
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{pattern}{Character string containing intersection matrix pattern to match against DE-9IM for given geometries. Wild card \code{*} or \code{*} characters allowed.}
  \item{checkValidity}{default FALSE; error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is TRUE, \code{gIsValid} is run on each in turn in an environment in which object names are available. If objects are invalid, this is reported and those affected are named}
}

\value{By default returns a 9 character string that represents the DE-9IM.

If \code{pattern} returns TRUE if the pattern matches the DE-9IM.}

\details{Each geometry is decomposed into an interior, a boundary, and an exterior region, all the resulting geometries are then tested by intersection against one another resulting in 9 total comparisons. These comparisons are summarized by the dimensions of the intersection region, as such intersection at point(s) is labeled \code{0}, at linestring(s) is labeled \code{1}, at polygons(s) is labeled \code{2}, and if they do not intersect labeled \code{F}.

If a pattern is specified then limited matching with wildcards is possible, \code{*} matches any character whereas \code{T} matches any non-\code{F} character.

See references for additional details.
} 

\note{Error messages from GEOS, in particular topology exceptions, report 0-based object order, so geom 0 is spgeom1, and geom 1 is spgeom2.}

\references{
Documentation of Intersection Matrix Patterns:
\url{http://docs.geotools.org/stable/userguide/library/jts/dim9.html}
}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gContains}}
\code{\link{gContainsProperly}}
\code{\link{gCovers}}
\code{\link{gCoveredBy}}
\code{\link{gCrosses}}
\code{\link{gDisjoint}}
\code{\link{gEquals}}
\code{\link{gEqualsExact}}
\code{\link{gIntersects}}
\code{\link{gOverlaps}}
\code{\link{gTouches}}
\code{\link{gWithin}}
}

\examples{
	x = readWKT("POLYGON((1 0,0 1,1 2,2 1,1 0))")
	x.inter = x
	x.bound = gBoundary(x)
	
	y = readWKT("POLYGON((2 0,1 1,2 2,3 1,2 0))")
	y.inter = y
	y.bound = gBoundary(y)
	
	
	xy.inter = gIntersection(x,y)
	xy.inter.bound = gBoundary(xy.inter)
	
	xy.union = gUnion(x,y)
	bbox = gBuffer(gEnvelope(xy.union),width=0.5,joinStyle='mitre',mitreLimit=3)

	x.exter = gDifference(bbox,x)
	y.exter = gDifference(bbox,y)

	# geometry decomposition
	par(mfrow=c(2,3))
	plot(bbox,border='grey');plot(x,col="black",add=TRUE);title("Interior",ylab = "Polygon X")
	plot(bbox,border='grey');plot(x.bound,col="black",add=TRUE);title("Boundary")
	plot(bbox,border='grey');plot(x.exter,col="black",pbg='white',add=TRUE);title("Exterior")
	plot(bbox,border='grey');plot(y,col="black",add=TRUE);title(ylab = "Polygon Y")
	plot(bbox,border='grey');plot(y.bound,col="black",add=TRUE)
	plot(bbox,border='grey');plot(y.exter,col="black",pbg='white',add=TRUE)
	
	
	
	defaultplot = function() {
		plot(bbox,border='grey')
		plot(x,add=TRUE,col='red1',border="red3")
		plot(y,add=TRUE,col='blue1',border="blue3")		
		plot(xy.inter,add=TRUE,col='orange1',border="orange3")
	}
	
	# Dimensionally Extended 9-Intersection Matrix
	pat = gRelate(x,y)
	patchars = strsplit(pat,"")[[1]]
	
	par(mfrow=c(3,3))
	defaultplot(); plot(gIntersection(x.inter,y.inter),add=TRUE,col='black')
	title(paste("dim:",patchars[1]))
	defaultplot(); plot(gIntersection(x.bound,y.inter),add=TRUE,col='black',lwd=2)
	title(paste("dim:",patchars[2]))
	defaultplot(); plot(gIntersection(x.exter,y.inter),add=TRUE,col='black')
	title(paste("dim:",patchars[3]))
	
	defaultplot(); plot(gIntersection(x.inter,y.bound),add=TRUE,col='black',lwd=2)
	title(paste("dim:",patchars[4]))
	defaultplot(); plot(gIntersection(x.bound,y.bound),add=TRUE,col='black',pch=16)
	title(paste("dim:",patchars[5]))
	defaultplot(); plot(gIntersection(x.exter,y.bound),add=TRUE,col='black',lwd=2)
	title(paste("dim:",patchars[6]))
	
	defaultplot(); plot(gIntersection(x.inter,y.exter),add=TRUE,col='black')
	title(paste("dim:",patchars[7]))
	defaultplot(); plot(gIntersection(x.bound,y.exter),add=TRUE,col='black',lwd=2)
	title(paste("dim:",patchars[8]))
	defaultplot(); plot(gIntersection(x.exter,y.exter),add=TRUE,col='black')
	title(paste("dim:",patchars[9]))
	
}
\keyword{spatial}

\name{gCoverageUnion}
\alias{gCoverageUnion}

\title{Coverage Union}
\description{GEOSCoverageUnion is an optimized union algorithm for polygonal inputs that are correctly noded and do not overlap. It will not generate an error (return NULL) for inputs that do not satisfy this constraint.}
\usage{
gCoverageUnion(spgeom, byid=FALSE, id = NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
}


\author{Roger Bivand}

\seealso{
\code{\link{gUnaryUnion}}
}

\examples{
run <- FALSE
if (require(maptools)) run <- TRUE
if (run) {
    nc1 <- readShapePoly(system.file("shapes/sids.shp", package="maptools")[1],
        proj4string=CRS("+proj=longlat +datum=NAD27"))
}
if (run) {
    print(system.time(oU <- gUnionCascaded(nc1)))
    if (version_GEOS0() >= "3.8.0") {
        print(system.time(oCU <- gCoverageUnion(nc1)))
    }
}

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{RGEOS Utility Functions}
\alias{getScale}
\alias{setScale}
\alias{translate}
\alias{checkP4S}
\alias{version_GEOS}
\alias{version_GEOS0}
\alias{set_RGEOS_polyThreshold}
\alias{get_RGEOS_polyThreshold}
\alias{set_RGEOS_warnSlivers}
\alias{get_RGEOS_warnSlivers}
\alias{set_RGEOS_dropSlivers}
\alias{get_RGEOS_dropSlivers}
\alias{set_RGEOS_CheckValidity}
\alias{get_RGEOS_CheckValidity}
\alias{rgeos_extSoftVersion}

\title{RGEOS Utility Functions}
\description{Utility functions for the RGEOS package}
\usage{
	getScale()
	setScale(scale=100000000)
	translate(spgeom)
	checkP4S(p4s)
        version_GEOS(runtime = TRUE)
        rgeos_extSoftVersion()
        version_GEOS0()
        set_RGEOS_polyThreshold(value)
        get_RGEOS_polyThreshold()
        set_RGEOS_warnSlivers(value)
        get_RGEOS_warnSlivers()
        set_RGEOS_dropSlivers(value)
        get_RGEOS_dropSlivers()
        get_RGEOS_CheckValidity()
        set_RGEOS_CheckValidity(value)
}

\arguments{
  \item{scale}{Numeric value determining the precision of translated geometries}
  \item{spgeom}{sp object as defined in package sp}
  \item{p4s}{Either a character string or an object of class \code{CRS}}
  \item{runtime}{default TRUE; if FALSE, installation GEOS version}
  \item{value}{the value to be passed to an RGEOS option in its environment}
}

\details{getScale and setScale are used to get and set the scale option in the rgeos environment. This option is used to determine the precision of coordinates when translating to and from GEOS C objects. Precision is defined as 1 / scale. The final example is a use case reported by Mao-Gui Hu, who has also made the objects available, where the default scale defeats an intended line intersection operation; changing the scale temporarily resoves the issue.

In order to permit polygon slivers to be detected, reported and dropped, the user may set a numeric value for polyThreshold and logical values for warnSlivers and dropSlivers. By default, the threshold is 0.0, and warning and dropping are FALSE. To detect slivers, the threshold may be set to a small value and warnSlivers set to TRUE. To drop slivers from returned Polygons and Polygon objects, set dropSlivers to TRUE for a non-zero threshold.

translate is a testing function which translates the sp object into a GEOS C object and then back into an sp object and is used extensively in the translation unit tests. In all cases it is expected that \code{spgeom} and \code{translate(spgeom)} should be identical.

checkP4S is a validation function for proj4strings and is used in testing.

version_GEOS returns the full runtime version string, and version_GEOS0 only the GEOS version number.
set_RGEOS_CheckValidity takes an integer 0:2, 0L is no operation, 1L is check validity, and 2L is check and if invalid try to repair with a zero width buffer.
}

\author{Roger Bivand & Colin Rundel}


\examples{
	readWKT("POINT(1.5 1.5)")

	# With scale set to 1, the following point will be rounded
	setScale(1)
	readWKT("POINT(1.5 1.5)")
	
	setScale(10)
	readWKT("POINT(1.5 1.5)")
	
	getScale()
	# Set scale option back to default
	setScale()
	
	
	
	# scale option only affect objects when they are translated through rgeos
	setScale(1)
	library(sp)
	SpatialPoints(data.frame(x=1.5,y=1.5))
	translate( SpatialPoints(data.frame(x=1.5,y=1.5)) )
	
	setScale()

        # added example of scale impact on intersection 120905
sline1 <- readWKT(readLines(system.file("wkts/sline1.wkt", package="rgeos")))
sline2 <- readWKT(readLines(system.file("wkts/sline2.wkt", package="rgeos")))
rslt <- gIntersection(sline1, sline2)
class(rslt)
getScale()
setScale(1e+6)
rslt <- gIntersection(sline1, sline2)
class(rslt)
sapply(slot(rslt, "lines"), function(x) length(slot(x, "Lines")))
rslt <- gLineMerge(rslt, byid=TRUE)
sapply(slot(rslt, "lines"), function(x) length(slot(x, "Lines")))
setScale()
get_RGEOS_dropSlivers()
get_RGEOS_warnSlivers()
get_RGEOS_polyThreshold()
# Robert Hijmans difficult intersection case
load(system.file("test_cases/polys.RData", package="rgeos"))
try(res <- gIntersection(a, b, byid=TRUE))
res <- gIntersection(a, b, byid=TRUE, drop_lower_td=TRUE)
sort(unlist(sapply(slot(res, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area"))))
oT <- get_RGEOS_polyThreshold()
oW <- get_RGEOS_warnSlivers()
oD <- get_RGEOS_dropSlivers()
set_RGEOS_polyThreshold(1e-3)
set_RGEOS_warnSlivers(TRUE)
res1 <- gIntersection(a, b, byid=TRUE, drop_lower_td=TRUE)
sort(unlist(sapply(slot(res, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area"))))
set_RGEOS_dropSlivers(TRUE)
res2 <- gIntersection(a, b, byid=TRUE, drop_lower_td=TRUE)
sort(unlist(sapply(slot(res, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area"))))
set_RGEOS_dropSlivers(FALSE)
oo <- gUnaryUnion(res1, c(rep("1", 3), "2", "3", "4"), checkValidity=2L)
unlist(sapply(slot(oo, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
ooo <- gIntersection(b, oo, byid=TRUE, checkValidity=2L)
gArea(ooo, byid=TRUE)
unlist(sapply(slot(ooo, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
set_RGEOS_dropSlivers(TRUE)
ooo <- gIntersection(b, oo, byid=TRUE, checkValidity=2L)
gArea(ooo, byid=TRUE)
unlist(sapply(slot(ooo, "polygons"), function(p) sapply(slot(p, "Polygons"), slot, "area")))
set_RGEOS_polyThreshold(oT)
set_RGEOS_warnSlivers(oW)
set_RGEOS_dropSlivers(oD)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{gIsSimple}
\alias{gIsSimple}
\alias{RGEOSisSimple}

\title{Is Geometry Simple?}
\description{Function tests if the given geometry is simple}
\usage{
gIsSimple(spgeom, byid = FALSE) 
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
}

\value{Returns TRUE if the given geometry does not contain anomalous points, such as self intersection or self tangency.}

\details{Simplicity is used in reference to 0 and 1-dimensional geometries ([MULTI]POINT and [MULTI]LINESTRING) whereas Validity (\code{\link{gIsValid}}) is used in reference to 2-dimensional geometries ([MULTI]POLYGON). 

A POINT is always simple.

A MULTIPOINT is simple if no two points are identical.

A LINESTRING is simple if it does not pass through the same point twice (self intersection) except at the end points, in which case it is a ring (\code{\link{gIsRing}}).

A MULTILINESTRING is simple if all of its subgeometries are simple and none of the subgeometries intersect except at end points.

A [MULTI]POLYGON is simple by definition.

Many of the functions in rgeos expect simple/valid geometries and may exhibit unpredictable behavior if given an invalid geometry. Checking of validity/simplicity can be computationally expensive for complex geometries and so is not done by default, any new geometries should be checked.
}


\references{
Validity Details:
\url{http://postgis.net/docs/manual-2.0/using_postgis_dbmanagement.html#OGC_Validity}
}



\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gIsEmpty}}
\code{\link{gIsRing}}
\code{\link{gIsValid}}
}

\examples{
# MULTIPOINT examples
gIsSimple(readWKT("MULTIPOINT(1 1,2 2,3 3)"))
gIsSimple(readWKT("MULTIPOINT(1 1,2 2,1 1)"))

# LINESTRING examples
l1 = readWKT("LINESTRING(0 5,3 4,2 3,5 2)")
l2 = readWKT("LINESTRING(0 5,4 2,5 4,0 1)")
l3 = readWKT("LINESTRING(3 5,0 4,0 2,2 0,5 1,4 4,4 5,3 5)")
l4 = readWKT("LINESTRING(3 5,0 4,4 3,5 2,3 0,1 2,4 5,3 5)")

par(mfrow=c(2,2))
plot(l1);title(paste("Simple:",gIsSimple(l1)))
plot(l2);title(paste("Simple:",gIsSimple(l2)))
plot(l3);title(paste("Simple:",gIsSimple(l3)))
plot(l4);title(paste("Simple:",gIsSimple(l4)))

# MULTILINESTRING examples
ml1 = readWKT("MULTILINESTRING((0 5,1 2,5 0),(3 5,5 4,4 1))")
ml2 = readWKT("MULTILINESTRING((0 5,1 2,5 0),(0 5,5 4,4 1))")
ml3 = readWKT("MULTILINESTRING((0 5,1 2,5 0),(3 5,5 4,2 0))")

par(mfrow=c(1,3))
plot(ml1);title(paste("Simple:",gIsSimple(ml1)))
plot(ml2);title(paste("Simple:",gIsSimple(ml2)))
plot(ml3);title(paste("Simple:",gIsSimple(ml3)))	
}

\keyword{spatial}

\name{gMaximumInscribedCircle}
\alias{gMaximumInscribedCircle}

\title{Centroid of Geometry}
\description{.}
\usage{
gMaximumInscribedCircle(spgeom, byid=FALSE, id = NULL, tol=.Machine$double.eps^(1/2),
 checkValidity=NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
  \item{tol}{Numerical tolerance value}
  \item{checkValidity}{default FALSE; error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is TRUE, \code{gIsValid} is run on each in turn in an environment in which object names are available. If objects are invalid, this is reported and those affected are named}
}

\details{.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gBoundary}}
\code{\link{gConvexHull}}
\code{\link{gEnvelope}}
\code{\link{gPointOnSurface}}
}

\examples{

if (version_GEOS0() >= "3.9.0") {
x = readWKT(paste("GEOMETRYCOLLECTION(POLYGON((0 0,10 0,10 10,0 10,0 0)),",
 "POLYGON((15 0,25 15,35 0,15 0)))"))

# Maximum inscribed circles of both the square and circle independently
c1 = gMaximumInscribedCircle(x, byid=TRUE) 
c1_sp <- as(c1, "SpatialPoints") # coercion of straight line segments to points
c1_sp1 <- NULL
if ((length(c1_sp) \%\% 2) == 0) c1_sp1 <- c1_sp[seq(1, length(c1_sp), 2)]
if (!is.null(c1_sp1)) c1_circ <- gBuffer(c1_sp1, byid=TRUE,
 width=gLength(c1, byid=TRUE))
# Maximum inscribed circle of square and circle together, needs gUnaryUnion(), 
# inscribes circle in the component permitting the largest circle
c2 = gMaximumInscribedCircle(gUnaryUnion(x))

opar <- par(mfrow=c(2,1))
plot(x)
plot(c1, col='red', add=TRUE, lwd=2)
if (!is.null(c1_sp1)) plot(c1_circ, border="red", add=TRUE)
plot(x)
plot(c2, col='blue', add=TRUE)
par(opar)
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rgeos_misc.R
\name{gNearestPoints}
\alias{gNearestPoints}
\title{Closest Points of two Geometries}
\usage{
gNearestPoints(spgeom1, spgeom2)
}
\arguments{
\item{spgeom1, spgeom2}{sp objects as defined in package sp.}
}
\value{
The closest points of the two geometries or NULL on exception.
  The first point comes from spgeom1 geometry and the second point comes
  from spgeom2.
}
\description{
Return closest points of two geometries.
}
\examples{
g1 <- readWKT("MULTILINESTRING((34 54, 60 34), (0 10, 50 10, 100 50))")
g2 <- readWKT("MULTIPOINT(30 0, 100 30)")
plot(g1, pch=4, axes=TRUE)
plot(g2, add=TRUE)
plot(gNearestPoints(g1, g2), add=TRUE, col="red", pch=7)
gDistance(g1, g2)
}
\seealso{
gDistance
}
\author{
Rainer Stuetz
}
\keyword{spatial}

\name{gArea}
\alias{gArea}
\alias{RGEOSArea}

\title{Area of Geometry}
\description{Calculates the area of the given geometry.}
\usage{
gArea(spgeom, byid=FALSE)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
}

\value{Returns the area of the geometry in the units of the current projection. By definition non-[MULTI]POLYGON geometries have an area of 0. The area of a POLYGON is the area of its shell less the area of any holes. Note that this value may be different from the \code{area} slot of the \code{Polygons} class as this value does not subtract the area of any holes in the geometry.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gLength}}
}

\examples{
	gArea(readWKT("POINT(1 1)"))
	gArea(readWKT("LINESTRING(0 0,1 1,2 2)"))
	gArea(readWKT("LINEARRING(0 0,3 0,3 3,0 3,0 0)"))
	
	
	p1 = readWKT("POLYGON((0 0,3 0,3 3,0 3,0 0))")
	p2 = readWKT("POLYGON((0 0,3 0,3 3,0 3,0 0),(1 1,2 1,2 2,1 2,1 1))")
	
	gArea(p1)
	p1@polygons[[1]]@area
	
	gArea(p2)
	p2@polygons[[1]]@area
}

\keyword{spatial}

\name{gPolygonize}
\alias{gPolygonize}

\title{Linestring Polygonizer}
\description{Function attempts to polygonize the given list of linestrings. If the linestrings are not noded (coordinates inserted at intersection points), the function may fail. \code{\link{gNode}} may be tried to insert such missing points}
\usage{
	gPolygonize( splist, getCutEdges=FALSE);
}

\arguments{
  \item{splist}{a list of sp SpatialLines objects}
  \item{getCutEdges}{Logical vector indicating if cut edges should be returned}
}

\value{By default returns polygons generated by polygonizing the given linestrings. If \code{getCutEdges} is TRUE then any cut edges are returned.}

\details{Polygonization is the process of forming polygons from linestrings which enclose an area. Linestrings are expected to be fully noded, as such they must not cross and must touch only at endpoints. \code{gPolygonize} takes a list of fully noded linestrings and forms all the polygons which are enclosed by the lines. Polygonization errors such as dangling lines or cut lines can be identified and reported.}


\author{Roger Bivand & Colin Rundel}

\seealso{\code{\link{gNode}}}

\examples{
library(sp)
linelist = list(readWKT("LINESTRING (0 0 , 10 10)"),
				readWKT("LINESTRING (185 221, 100 100)"),
				readWKT("LINESTRING (185 221, 88 275, 180 316)"),
				readWKT("LINESTRING (185 221, 292 281, 180 316)"), 
				readWKT("LINESTRING (189 98, 83 187, 185 221)"), 
				readWKT("LINESTRING (189 98, 325 168, 185 221)"))

par(mfrow=c(1,2))
plot(linelist[[1]],xlim=c(0,350),ylim=c(0,350))
title("Linestrings with nodes")
plot(as(linelist[[1]],"SpatialPoints"),pch=16,add=TRUE)

for(i in 2:length(linelist)) {
	plot(linelist[[i]],add=TRUE)
	plot(as(linelist[[i]],"SpatialPoints"),pch=16,add=TRUE)
}

plot(gPolygonize(linelist),xlim=c(0,350),ylim=c(0,350))
title("Polygonized Results")

gPolygonize(linelist,getCutEdges=TRUE) # no cut edges



linelist2 = list(readWKT("LINESTRING(1 3, 3 3, 3 1, 1 1, 1 3)"),
				 readWKT("LINESTRING(1 3, 3 3, 3 1, 1 1, 1 3)"))

gPolygonize(linelist2,getCutEdges=FALSE) # NULL
gPolygonize(linelist2,getCutEdges=TRUE) # Contains LineStrings
# bug fix 130206
LS = list(
readWKT("LINESTRING (425963 576719, 425980 576703)"),
readWKT("LINESTRING (425963 576719, 425882 577073)"),
readWKT("LINESTRING (425980 576703, 426082 577072)"),
readWKT("LINESTRING (425882 577073, 426082 577072)"),
readWKT("LINESTRING (426138 577068, 426082 577072)"),
readWKT("LINESTRING (426138 577068, 426420 577039)"),
readWKT("LINESTRING (426420 577039, 426554 576990)"),
readWKT("LINESTRING (426751 576924, 426776 576823)"),
readWKT("LINESTRING (426751 576924, 426783 576919)"),
readWKT("LINESTRING (426751 576924, 426714 576953)"),
readWKT("LINESTRING (426776 576823, 426783 576919)"),
readWKT("LINESTRING (426658 576966, 426554 576990)"),
readWKT("LINESTRING (426658 576966, 426667 577031)"),
readWKT("LINESTRING (426658 576966, 426714 576953)"),
readWKT("LINESTRING (426667 577031, 426714 576953)")
)
plot(gPolygonize(LS))
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{gIntersects}
\alias{gIntersects}
\alias{RGEOSIntersects}
\alias{gDisjoint}
\alias{RGEOSDisjoint}

\title{Geometry Relationships - Intersects and Disjoint}
\description{Function for testing if the geometries have at least one point in common or no points in common}
\usage{
gIntersects(spgeom1, spgeom2 = NULL, byid = FALSE, prepared=TRUE,
 returnDense=TRUE, checkValidity=FALSE)
gDisjoint(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE,
 checkValidity=FALSE)
}
	
\arguments{
  \item{spgeom1, spgeom2}{sp objects as defined in package sp. If spgeom2 is NULL then spgeom1 is compared to itself.}
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{prepared}{Logical determining if prepared geometry (spatially indexed) version of the GEOS function should be used. In general prepared geometries should be faster than the alternative.}
  \item{returnDense}{default TRUE, if false returns a list of the length of spgeom1 of integer vectors listing the \code{1:length(spgeom2)} indices which would be TRUE in the dense logical matrix representation; useful when the sizes of the byid=TRUE returned matrix is very large and it is sparse; essential when the returned matrix would be too large}
  \item{checkValidity}{default FALSE; error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is TRUE, \code{gIsValid} is run on each in turn in an environment in which object names are available. If objects are invalid, this is reported and those affected are named}
}

\value{\code{gIntersects} returns TRUE if \code{spgeom1} and \code{spgeom2} have at least one point in common.

\code{gDisjoint} returns TRUE if \code{spgeom1} and \code{spgeom2} have no points in common.

Both return a conforming logical matrix if \code{byid = TRUE}.
}

\note{Error messages from GEOS, in particular topology exceptions, report 0-based object order, so geom 0 is spgeom1, and geom 1 is spgeom2.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gContains}}
\code{\link{gContainsProperly}}
\code{\link{gCovers}}
\code{\link{gCoveredBy}}
\code{\link{gCrosses}}
\code{\link{gEquals}}
\code{\link{gEqualsExact}}
\code{\link{gOverlaps}}
\code{\link{gRelate}}
\code{\link{gTouches}}
\code{\link{gWithin}}
}

\examples{
	p1 = readWKT("POLYGON((0 0,1 0,1 1,0 1,0 0))")
	p2 = readWKT("POLYGON((0.5 1,0 2,1 2,0.5 1))")
	p3 = readWKT("POLYGON((0.5 0.5,0 1.5,1 1.5,0.5 0.5))")

	l1 = readWKT("LINESTRING(0 3,1 1,2 2,3 0)")
	l2 = readWKT("LINESTRING(1 3.5,3 3,2 1)")
	l3 = readWKT("LINESTRING(-0.1 0,-0.1 1.1,1 1.1)")
	
	pt1 = readWKT("MULTIPOINT(1 1,3 0,2 1)")
	pt2 = readWKT("MULTIPOINT(0 3,3 0,2 1)")
	pt3 = readWKT("MULTIPOINT(-0.2 0,1 -0.2,1.2 1,0 1.2)")

	
	par(mfrow=c(3,2))
	plot(p1,col='blue',border='blue',ylim=c(0,2.5));plot(p2,col='black',add=TRUE,pch=16)
	title(paste("Intersects:",gIntersects(p1,p2),
				"\nDisjoint:",gDisjoint(p1,p2)))
	
	plot(p1,col='blue',border='blue',ylim=c(0,2.5));plot(p3,col='black',add=TRUE,pch=16)
	title(paste("Intersects:",gIntersects(p1,p3),
				"\nDisjoint:",gDisjoint(p1,p3)))
				
	plot(l1,col='blue');plot(pt1,add=TRUE,pch=16)
	title(paste("Intersects:",gIntersects(l1,pt1),
				"\nDisjoint:",gDisjoint(l1,pt1)))
	
	plot(l1,col='blue');plot(pt2,add=TRUE,pch=16)
	title(paste("Intersects:",gIntersects(l1,pt2),
				"\nDisjoint:",gDisjoint(l1,pt2)))
	
	plot(p1,col='blue',border='blue',xlim=c(-0.5,2),ylim=c(0,2.5))
	plot(l3,lwd=2,col='black',add=TRUE)
	title(paste("Intersects:",gIntersects(p1,l3),
				"\nDisjoint:",gDisjoint(p1,l3)))
	
	plot(p1,col='blue',border='blue',xlim=c(-0.5,2),ylim=c(-0.5,2))
	plot(pt3,pch=16,col='black',add=TRUE)
	title(paste("Intersects:",gIntersects(p1,pt3),
				"\nDisjoint:",gDisjoint(p1,pt3)))

# Michael Chirico bug report and fix 2019-08-16
	SP1 = SpatialPoints(
	  cbind(c(.25, .75), c(.75, .25))	)
	SP2 = SpatialPolygons(list(
	  Polygons(list(Polygon(cbind(c(0, 0, 1, 1), c(0, 1, 1, 0)))), ID = 'a'),
	  Polygons(list(Polygon(cbind(c(1, 1, 2, 2), c(1, 2, 2, 1)))), ID = 'b')
	))

	gIntersects(SP1, SP2, byid = c(TRUE, FALSE))
	gIntersects(SP1, SP2, byid = c(TRUE, TRUE))
        gIntersects(SP1, SP2, byid = c(FALSE, TRUE))
        gIntersects(SP1, SP2, byid = c(FALSE, FALSE))
        
}
\keyword{spatial}

\name{polyfile}
\alias{polyfile}
\alias{read.polyfile}
\alias{write.polyfile}

\title{Read/Write polygon data}
\description{
  Read/Write polygon and contour information from/to a text file.  
}
\usage{
read.polyfile(filename, nohole = TRUE)
write.polyfile(poly, filename = "GPCpoly.txt")
}
\arguments{
  \item{filename}{the name of the file (a character string) from/to which
    data should be read/written.}
  \item{nohole}{Is this a polygon without holes?}
  \item{poly}{an object of class \code{"gpc.poly"}}
}
\details{
  The text file representation of a polygon is of the following format:
 
  <number of contours>\cr
  <number of points in first contour>\cr
  x1  y1\cr
  x2  y2\cr
  ...\cr
  <number of points in second contour>\cr
  x1  y1\cr
  x2  y2\cr
  ...\cr

  For example, a data file for a polygon with 2 contours (a four-sided
  object and a triangle) might look like:

  2\cr
  4\cr
  1.0 1.0\cr
  1.0 2.0\cr
  3.4 3.21\cr
  10 11.2\cr
  3\cr
  21.0 11.2\cr
  22.3 99.2\cr
  4.5 5.4\cr

  The vertices of the polygon can be ordered either clockwise or
  counter-clockwise.

  If a polygon has contours which are holes, then the format is slightly
  different.  Basically, a flag is set to indicate that a particular
  contour is a hole.  The format is

  <number of contours>\cr
  <number of points in first contour>\cr
  <hole flag>\cr
  x1  y1\cr
  x2  y2\cr
  ...\cr
  <number of points in second contour>\cr
  <hole flag>\cr
  x1  y1\cr
  x2  y2\cr
  ...\cr

  The hole flag is either 1 to indicate a hole, or 0 for a regular
  contour.  For example, a four-sided polygon with a triangular hole
  would be written as:

  2\cr
  3\cr
  1\cr
  4.0   4.0\cr
  6.0   5.0\cr
  5.0   6.0\cr
  4\cr
  0\cr
  2.0   1.0\cr
  8.0   2.0\cr
  7.0   9.0\cr
  1.0   7.0\cr
}

\value{
  If \code{nohole} is \code{TRUE} (the default) \code{read.polyfile}
  returns an  object of class \code{"gpc.poly.nohole"}.  This object has
  the hole flag set to \code{FALSE} for all contours.  If \code{nohole} is
  \code{FALSE}, then an object of class \code{"gpc.poly"} is
  returned.
  
  \code{write.polyfile} does not return anything useful.
}
\author{Roger D. Peng}

\seealso{
  \code{\link{gpc.poly-class}}, \code{\link{gpc.poly.nohole-class}}
}

\examples{
## None right now.
}
\keyword{IO}

\name{gInterpolate}
\alias{gInterpolate}
\title{Interpolate Points along Line Geometry}
\usage{
gInterpolate(spgeom, d, normalized = FALSE)
}
\arguments{
\item{spgeom}{SpatialLines or SpatialLinesDataFrame object}

\item{d}{Numeric vector specifying the distance along the line geometry}

\item{normalized}{Logical determining if normalized distances
should be used}
}
\value{
SpatialPoints object
}
\description{
Return points at specified distances along a line.
}
\details{
If \code{normalized=TRUE}, the distances will be interpreted
  as fractions of the line length.
}
\examples{
gInterpolate(readWKT("LINESTRING(25 50, 100 125, 150 190)"),
             d=seq(0, 1, by = 0.2), normalized = TRUE)
}
\seealso{
gInterpolate
}
\author{
Rainer Stuetz
}
\keyword{spatial}

\name{gLength}
\alias{gLength}
\alias{RGEOSLength}

\title{Length of Geometry}
\description{Calculates the length of the given geometry.}
\usage{
	gLength(spgeom, byid=FALSE)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
}

\value{Returns the length of the geometry in the units of the current projection. By definition [MULTI]POINTs have a length of 0. The length of POLYGONs is the sum of the length of their shell and their hole(s).}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gArea}}
}

\examples{
gLength(readWKT("POINT(1 1)"))

gLength(readWKT("LINESTRING(0 0,1 1,2 2)"))
gLength(readWKT("LINESTRING(0 0,1 1,2 0,3 1)"))

gLength(readWKT("POLYGON((0 0,3 0,3 3,0 3,0 0))"))
gLength(readWKT("POLYGON((0 0,3 0,3 3,0 3,0 0),(1 1,2 1,2 2,1 2,1 1))"))
}

\keyword{spatial}

\name{RGEOS Experimental Functions}
\alias{poly_findInBoxGEOS}
\alias{gUnarySTRtreeQuery}
\alias{gBinarySTRtreeQuery}

\title{Experimental Functions}
\description{Functions still under development using the GEOS STRtree structure to find intersecting object component envelopes (bounding boxes).}
\usage{
    gUnarySTRtreeQuery(obj)
    gBinarySTRtreeQuery(obj1, obj2)
    poly_findInBoxGEOS(spl, as_points=TRUE)
}

\arguments{
  \item{obj, obj1, obj2}{Objects inheriting from either \code{SpatialPolygons} or \code{SpatialLines}, obj2 may also inherit from \code{SpatialPoints}}
  \item{spl}{Object that inherits from the \code{SpatialPolygons} class}
  \item{as_points}{Logical value indicating if the polygon should be treated as points}
}

\details{\code{gUnarySTRtreeQuery} and \code{poly_findInBoxGEOS} do the same thing, but \code{poly_findInBoxGEOS} uses the \code{as_points} argument to build the input envelopes from proper geometries. \code{gUnarySTRtreeQuery} and \code{gBinarySTRtreeQuery} build input envelopes by disregarding topology and reducing the coordinates to a multipoint representation. This permits the tree to be built and queried even when some geometries are invalid. \code{gUnarySTRtreeQuery} and \code{poly_findInBoxGEOS} return a list of length \code{(n-1)} of 1-based indices only for the \dQuote{greater than i} indices. \code{gBinarySTRtreeQuery} returns a list of the length of \code{obj2} with 1-based indices of \code{obj1}.
}

\author{Roger Bivand & Colin Rundel}

\keyword{spatial}

\examples{
if (require(maptools)) {
xx <- readShapeSpatial(system.file("shapes/fylk-val-ll.shp",
 package="maptools")[1], proj4string=CRS("+proj=longlat +datum=WGS84"))
a0 <- gUnarySTRtreeQuery(xx)
a0
bbxx <- bbox(xx)
wdb_lines <- system.file("share/wdb_borders_c.b", package="maptools")
xxx <- Rgshhs(wdb_lines, xlim=bbxx[1,], ylim=bbxx[2,])$SP
a1 <- gBinarySTRtreeQuery(xx, xxx)
a1
nc1 <- readShapePoly(system.file("shapes/sids.shp", package="maptools")[1],
 proj4string=CRS("+proj=longlat +datum=NAD27"))
a2 <- gUnarySTRtreeQuery(nc1)
#a3 <- poly_findInBoxGEOS(nc1)
#all.equal(a2, a3)
a2
pl <- slot(nc1, "polygons")[[4]]
a5 <- gUnarySTRtreeQuery(pl)
a5
SG <- Sobj_SpatialGrid(nc1, n=400)$SG
obj1 <- as(as(SG, "SpatialPixels"), "SpatialPolygons")
a4 <- gBinarySTRtreeQuery(nc1, obj1)
plot(nc1, col="orange", border="yellow")
plot(obj1, angle=sapply(a4, is.null)*45, density=20, lwd=0.5, add=TRUE)
set.seed(1)
pts <- spsample(nc1, n=10, type="random")
res <- gBinarySTRtreeQuery(nc1, pts)
}
}

\encoding{UTF-8}
\name{polygonsLabel}
\alias{polygonsLabel}

\title{Compute optimal label positions for polygons}
\description{Compute optimal positions for placing labels inside polygons, and optionally plot the labels.
Various algorithms for finding the ‘optimal’ label positions are supported.}
\usage{
polygonsLabel(pols, labels = NULL, method = c("maxdist",
              "buffer", "centroid", "random", "inpolygon")[1],
              gridpoints = 60, polypart = c("all", "largest")[1],
              cex = 1, doPlot = TRUE, ...)
}

\arguments{
  \item{pols}{ Object of class, or deriving from, \code{SpatialPolygons}.}
  
  \item{labels}{ Character vector of labels. Will be recycled to have
  the same number of elements as the number of polygons in \code{pols}.
  If \code{labels} is \code{NULL} or empty, the label box is taken as a square
  with sides equal to the current line height (see the \code{cex} argument).}
  
  \item{method}{ The method(s) to use when finding label positions.
  Will be recycled. Valid methods are \code{maxdist} (currently the default),
  \code{buffer}, \code{centroid}, \code{random} and \code{inpolygon}.}
  
  \item{gridpoints}{ Number of grid points to use for the initial grid search
  in the \code{maxdist} method.}
  
  \item{polypart}{ Should \code{all} (default) or only the \code{largest}
  polygon part of each polygon in \code{pols} be used for the calculations?
  Will be recycled. Setting this to \code{largest} is very useful when labelling
  detailed coastlines of a country, consisting of a large polygon (where the
  label should be placed) and very many tiny islands, as it will greatly
  speed up the search for an optimal label position. But do note that this
  also removes any holes (e.g., lakes) before calculating the label position,
  so the labels are no longer guaranteed not to overlap a hole.}
  
  \item{cex}{ Magnification factor for text labels. Is used both when
  plotting the labels and when calculating the label positions.}
  
  \item{doPlot}{ Plot the labels on the current graphics device.
  Calls the \code{text} function internally.}
  
  \item{...}{ Further arguments to be passed to \code{text} (e.g., \code{col}).}
}

\details{There are no perfect definitions of ‘optimal’ label positions,
but any such position should at least satisfy a few requirements:
The label should be positioned wholly inside the polygon. It should also
be far from any polygon edges. And, though more difficult to quantify,
it should be positioned in the visual centre (or bulk) of the polygon.
The algorithms implemented here seems to generally do a very good job
of finding optimal (or at least ‘good’) label positions.

The \code{maxdist} method is currently the default, and tries to
find the label position with a maximal distance from the polygon edges.
More precisely, it finds a position where the minimal distance of
any point on the (rectangular) label box to the polygon boundary is maximised.
It does this by first trying a grid search, using \code{gridpoints}
regular grid points on the polygon, and then doing local optimisation on
the best grid point. The default grid is quite coarse, but usually gives
good results in a short amount of time. But for very complicated
(and narrow) polygons, it may help increasing \code{gridpoints}. Note
that while this method gives good results for most natural polygons,
e.g., country outlines, the theoretical optimal position is not 
necessarily unique, and this is sometimes seen when applying the method
to regular polygons, like rectangles (see example below), where
the resulting position may differ much from what one would judge to
be the visual centre of the polygon.

The \code{buffer} method works by shrinking the polygon (using
negative buffering) until the convex hull of the shrunken polygon
can fit wholly inside the original polygon. The label position is
then taken as the centroid of the shrunken polygon. This method
usually gives excellent results, is surprisingly fast, and seems
to capture the ‘visual centre’ idea of an optimal label position well.
However, it does not guarantee that the label can fit wholly inside the
polygon. (However, if it does not fit, there are usually no other
better position either.)

The \code{centroid} method simply returns the centroid of each polygon.
Note that although this is the geometrical/mathematical centre of 
the polygon, it may actually be positioned outside the polygon.
For regular polygons (rectangles, hexagons), it gives perfect results.
Internally, this method uses the \code{coordinates} function.
There are three reasons this method is supported:
To make it easy to find the centroid of the
largest polygon part of a polygon (using the \code{polypart}
argument), to make it easy to use the centroid algorithm
along with other algorithms (using the vector nature of the
\code{method} argument), and for completeness.

The \code{random} method returns a random position guaranteed
to be inside the polygon. This will rarely be an optimal label
position!

The \code{inpolygon} method finds an arbitrary position in the polygon.
This position is usually quite similar to the centroid, but is
guaranteed the be inside the polygon. Internally, the method uses
the \code{gPointOnSurface} function.
}

\note{
Note that both the \code{labels}, \code{method} and \code{polypart}
arguments are vectors, so it’s possible to use different options for each
polygon in the \code{pols} object.
}


\value{ A two-colum matrix is returned, with each row
containing the horizontal and vertical coordinates
for the corresponding polygon. If \code{doPlot} is \code{TRUE}
(the default), the labels are also plotted on the current
graphics device, with the given value of \code{cex}
(font size scaling).}

\author{Karl Ove Hufthammer, \email{karl@huftis.org}.}

\seealso{\code{\link[maptools]{pointLabel}}}

\references{The \code{buffer} method was inspired by
(but is slightly different from) the algorithm described
in the paper \cite{Using Shape Analyses for Placement of Polygon Labels}
by Hoseok Kang and Shoreh Elhami, available at
\url{https://www.esri.com/training/}
.}

\examples{
# Simple example with a single polygon
x = c(0, 1.8, 1.8, 1, 1, 3, 3, 2.2, 2.2, 4,
      4, 6, 6, 14, 14, 6, 6,  4, 4, 0, 0)
y = c(0, 0, -2, -2, -10, -10, -2, -2, 0, 0,
      1.8, 1.8, 1, 1, 3, 3, 2.2, 2.2, 4, 4, 0)
xy = data.frame(x,y)
library(sp)
xy.sp = SpatialPolygons(list(Polygons(list(Polygon(xy)), ID = "test")))
plot(xy.sp, col = "khaki")
polygonsLabel(xy.sp, "Hi!")


# Example with multiple polygons, text labels and colours
x1 = c(0, 4, 4, 0, 0)
y1 = c(0, 0, 4, 4, 0)
x2 = c(1, 1, 3, 3, 1)
y2 = c(-2, -10, -10, -2, -2)
x3 = c(6, 14, 14, 6, 6)
y3 = c(1, 1, 3, 3, 1)
xy.sp = SpatialPolygons(list(
  Polygons(list(Polygon(cbind(x1,y1))), ID = "test1"), # box
  Polygons(list(Polygon(cbind(x3,y3))), ID = "test3"), # wide
  Polygons(list(Polygon(cbind(x2,y2))), ID = "test2")  # high
))
plot(xy.sp, col=terrain.colors(3))
labels=c("Hi!", "A very long text string", "N\na\nr\nr\no\nw")

# Note that the label for the tall and narrow box is
# not necessarily centred vertically in the box.
# The reason is that method="maxdist" minimises the 
# maximum distance from the label box to the surrounding
# polygon, and this distance is not changed by moving
# the label vertically, as long the vertical distance
# to the polygon boundary is less than the horizontal
# distance. For regular polygons like this, the other
# label positions (e.g., method="buffer") work better.
polygonsLabel(xy.sp, labels, cex=.8,
              col = c('white', 'black', 'maroon'))


\dontrun{
## Example showing how bad the centroid 
## position can be on real maps.

# Needed libraries
if (require(maps) && require(maptools) && require(rgdal)) {

# Load map data and convert to spatial object
nmap = map("world", c("Norway", "Sweden", "Finland"),
           exact = TRUE, fill = TRUE, col = "transparent", plot = FALSE)
nmap.pol = map2SpatialPolygons(nmap, IDs = nmap$names,
                               proj4string = CRS("+init=epsg:4326"))
nmap.pol = spTransform(nmap.pol, CRS("+init=epsg:3035"))

# Plot map, centroid positions (red dots) and optimal
# label positions using the ‘buffer’ method.
plot(nmap.pol, col = "khaki")
nmap.centroids = polygonsLabel(nmap.pol, names(nmap.pol),
                               method = "centroid", doPlot = FALSE)
points(nmap.centroids, col = "red", pch=19)
polygonsLabel(nmap.pol, names(nmap.pol), method = "buffer", cex=.8)
}
}
}

\keyword{spatial}

\name{gEnvelope}
\alias{gEnvelope}
\alias{RGEOSEnvelope}

\title{Envelope of Geometry}
\description{Function calculates the rectangular bounding box for the given geometry}
\usage{
gEnvelope(spgeom, byid=FALSE, id = NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
}

\details{Returns the rectangular bounding box as a SpatialPolygons object. If spgeom is a degenerate case (horizontal/vertical line, single point) then the function may return an object with lower dimension (SpatialLines or SpatialPoints) or an invalid polygon.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gBoundary}}
\code{\link{gCentroid}}
\code{\link{gConvexHull}}
\code{\link{gPointOnSurface}}
}

\examples{
x = readWKT(paste("POLYGON((0 40,10 50,0 60,40 60,40 100,50 90,60 100,60",
 "60,100 60,90 50,100 40,60 40,60 0,50 10,40 0,40 40,0 40))"))
env = gEnvelope(x)

plot(x,col='blue',border='blue')
plot(env,add=TRUE)

#Degenerate Cases
gEnvelope(readWKT("POINT(1 1)")) #returns SpatialPoints
gEnvelope(readWKT("LINESTRING(1 1,1 2)")) #invalid polygon
gEnvelope(readWKT("LINESTRING(1 1,2 1)")) #invalid polygon

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{gpc.poly-class}
\docType{class}
\alias{gpc.poly-class}
\alias{[,gpc.poly,ANY,ANY-method}
\alias{[,gpc.poly-method}
\alias{append.poly,gpc.poly,gpc.poly-method}
\alias{area.poly,gpc.poly-method}
\alias{coerce,matrix,gpc.poly-method}
\alias{coerce,data.frame,gpc.poly-method}
\alias{coerce,gpc.poly,matrix-method}
\alias{coerce,gpc.poly,numeric-method}
\alias{coerce,gpc.poly,SpatialPolygons-method}
\alias{coerce,SpatialPolygons,gpc.poly-method}
\alias{coerce,numeric,gpc.poly-method}
\alias{coerce,list,gpc.poly-method}
\alias{get.bbox,gpc.poly-method}
\alias{get.pts,gpc.poly-method}
\alias{intersect,gpc.poly,gpc.poly-method}
\alias{plot,gpc.poly-method}
\alias{plot,gpc.poly,ANY-method}
\alias{scale.poly,gpc.poly-method}
\alias{setdiff,gpc.poly,gpc.poly-method}
\alias{show,gpc.poly-method}
\alias{symdiff,gpc.poly,gpc.poly-method}
\alias{union,gpc.poly,gpc.poly-method}
\alias{tristrip,gpc.poly-method}
\alias{triangulate,gpc.poly-method}

\title{Class "gpc.poly"}
\description{
  A class for representing polygons composed of multiple contours, some
  of which may be holes.
}
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("gpc.poly",
    ...)} or by reading in from a file using \code{read.polyfile}.
}
\section{Slots}{
  \describe{
    \item{pts}{Object of class \dQuote{list}.  Actually,
      \code{pts} is a list of lists with length equal to the number of
      contours in the \code{"gpc.poly"} object.  Each element of
      \code{pts} is a list of length 3 with names \code{x}, \code{y},
      and \code{hole}.  \code{x} and \code{y} are vectors containing the
      x and y coordinates, respectively, while \code{hole} is a logical
      indicating whether or not the contour is a hole.}
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "gpc.poly")}: ... }
    \item{append.poly}{\code{signature(x = "gpc.poly", y = "gpc.poly")}: ... }
    \item{area.poly}{\code{signature(object = "gpc.poly")}: ... }
    \item{coerce}{\code{signature(from = "matrix", to = "gpc.poly")}: ... }
    \item{coerce}{\code{signature(from = "data.frame", to = "gpc.poly")}: ... }
    \item{coerce}{\code{signature(from = "numeric", to = "gpc.poly")}: ... }
    \item{coerce}{\code{signature(from = "list", to = "gpc.poly")}: ... }
	\item{coerce}{\code{signature(from = "SpatialPolygons", to = "gpc.poly")}: ... }
    \item{coerce}{\code{signature(from = "gpc.poly", to = "matrix")}: ... }
    \item{coerce}{\code{signature(from = "gpc.poly", to = "numeric")}: ... }
	\item{coerce}{\code{signature(from = "gpc.poly", to = "SpatialPolygons")}: ... }
	\item{get.bbox}{\code{signature(x = "gpc.poly")}: ... }
    \item{get.pts}{\code{signature(object = "gpc.poly")}: ... }
    \item{intersect}{\code{signature(x = "gpc.poly", y = "gpc.poly")}: ... }
    \item{plot}{\code{signature(x = "gpc.poly")}: The argument
      \code{poly.args} can be used to pass a list of additional
      arguments to be passed to the underlying \code{polygon} call.}
    \item{scale.poly}{\code{signature(x = "gpc.poly")}: ... }
    \item{setdiff}{\code{signature(x = "gpc.poly", y = "gpc.poly")}: ... }
    \item{show}{\code{signature(object = "gpc.poly")}: Scale x and y
      coordinates by amount \code{xscale} and \code{yscale}.  By default
      \code{xscale} equals \code{yscale}.}
    \item{symdiff}{\code{signature(x = "gpc.poly", y = "gpc.poly")}: ... }
	\item{union}{\code{signature(x = "gpc.poly", y = "gpc.poly")}: ... }
    \item{tristrip}{\code{signature(x = "gpc.poly")}: ... }
    \item{triangulate}{\code{signature(x = "gpc.poly")}: ... }


  }
}
\author{Roger D. Peng}

\note{
  The class \code{"gpc.poly.nohole"} is identical to
  \code{"gpc.poly"} except the \code{hole} flag for each contour of a
  \code{"gpc.poly.nohole"} object is always \code{FALSE}.
}

\examples{
## Make some random polygons
set.seed(100)
a <- cbind(rnorm(100), rnorm(100))
a <- a[chull(a), ]

## Convert `a' from matrix to "gpc.poly"
a <- as(a, "gpc.poly")

b <- cbind(rnorm(100), rnorm(100))
b <- as(b[chull(b), ], "gpc.poly")

## More complex polygons with an intersection
p1 <- read.polyfile(system.file("poly-ex-gpc/ex-poly1.txt", package = "rgeos"))
p2 <- read.polyfile(system.file("poly-ex-gpc/ex-poly2.txt", package = "rgeos"))

## Plot both polygons and highlight their intersection in red
plot(append.poly(p1, p2))
plot(intersect(p1, p2), poly.args = list(col = 2), add = TRUE)

## Highlight the difference p1 \ p2 in green
plot(setdiff(p1, p2), poly.args = list(col = 3), add = TRUE)

## Highlight the difference p2 \ p1 in blue
plot(setdiff(p2, p1), poly.args = list(col = 4), add = TRUE)

## Plot the union of the two polygons
plot(union(p1, p2))

## Take the non-intersect portions and create a new polygon
## combining the two contours
p.comb <- append.poly(setdiff(p1, p2), setdiff(p2, p1))
plot(p.comb, poly.args = list(col = 2, border = 0))

## Coerce from a matrix
x <- 
structure(c(0.0934073560027759, 0.192713393476752, 0.410062456627342, 
0.470020818875781, 0.41380985426787, 0.271408743927828, 0.100902151283831, 
0.0465648854961832, 0.63981588032221, 0.772382048331416,
0.753739930955121, 0.637744533947066, 0.455466052934407,
0.335327963176065, 0.399539700805524, 
0.600460299194476), .Dim = c(8, 2))
y <- 
structure(c(0.404441360166551, 0.338861901457321, 0.301387925052047, 
0.404441360166551, 0.531852879944483, 0.60117973629424, 0.625537820957668, 
0.179976985040276, 0.341542002301496, 0.445109321058688,
0.610817031070196, 0.596317606444189, 0.459608745684695,
0.215189873417722), .Dim = c(7, 2))

x1 <- as(x, "gpc.poly")
y1 <- as(y, "gpc.poly")

plot(append.poly(x1, y1))
plot(intersect(x1, y1), poly.args = list(col = 2), add = TRUE)

## Show the triangulation
#plot(append.poly(x1, y1))
#triangles <- triangulate(append.poly(x1,y1))
#for (i in 0:(nrow(triangles)/3 - 1)) 
#    polygon(triangles[3*i + 1:3,], col="lightblue")


}
\keyword{classes}

\name{gDistance}
\alias{gDistance}
\alias{RGEOSDistance}
\alias{gWithinDistance}
\alias{RGEOSisWithinDistance}
\alias{RGEOSHausdorffDistance}

\title{Distance between geometries}
\description{Calculates the distance between the given geometries}
\usage{
gDistance(spgeom1, spgeom2=NULL, byid=FALSE, hausdorff=FALSE, densifyFrac = NULL)
gWithinDistance(spgeom1, spgeom2=NULL, dist, byid=FALSE,
 hausdorff=FALSE, densifyFrac=NULL)
}

\arguments{
  \item{spgeom1, spgeom2}{sp objects as defined in package sp. If spgeom2 is NULL then spgeom1 is compared to itself.}
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{hausdorff}{Logical determining if the discrete Hausdorff distance should be calculated}
  \item{densifyFrac}{Numerical value between 0 and 1 that determines the fraction by which to densify each segment of the geometry.}
  \item{dist}{Numerical value that determines cutoff distance}
}

\value{gDistance by default returns the cartesian minimum distance between the two geometries in the units of the current projection. If \code{hausdorff} is TRUE then the Hausdorff distance is returned for the two geometries.

gWithinDistance returns TRUE if returned distance is less than or equal to the specified \code{dist}.
}

\details{
Discrete Hausdorff distance is essentially a measure of the similarity or dissimilarity of the two geometries, see references below for more detailed explanations / descriptions.

If \code{hausdorff} is TRUE and \code{densifyFrac} is specified then the geometries' segments are densified by splitting each segment into equal length subsegments whose fraction of the total length is equal to \code{densifyFrac}.
} 

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gWithinDistance}}
}

\references{
Hausdorff Differences:
\url{https://en.wikipedia.org/wiki/Hausdorff_distance}
\url{http://lin-ear-th-inking.blogspot.com/2009/01/computing-geometric-similarity.html}
}

\examples{

pt1 = readWKT("POINT(0.5 0.5)")
pt2 = readWKT("POINT(2 2)")

p1 = readWKT("POLYGON((0 0,1 0,1 1,0 1,0 0))")
p2 = readWKT("POLYGON((2 0,3 1,4 0,2 0))")

gDistance(pt1,pt2)
gDistance(p1,pt1)
gDistance(p1,pt2)
gDistance(p1,p2)


p3 = readWKT("POLYGON((0 0,2 0,2 2,0 2,0 0))")
p4 = readWKT("POLYGON((0 0,2 0,2 1.9,1.9 2,0 2,0 0))")
p5 = readWKT("POLYGON((0 0,2 0,2 1.5,1.5 2,0 2,0 0))")
p6 = readWKT("POLYGON((0 0,2 0,2 1,1 2,0 2,0 0))")
p7 = readWKT("POLYGON((0 0,2 0,0 2,0 0))")

gDistance(p3,hausdorff=TRUE)
gDistance(p3,p4,hausdorff=TRUE)
gDistance(p3,p5,hausdorff=TRUE)
gDistance(p3,p6,hausdorff=TRUE)
gDistance(p3,p7,hausdorff=TRUE)
}

\keyword{spatial}

\name{gEquals}
\alias{gEquals}
\alias{RGEOSEquals}
\alias{gEqualsExact}
\alias{RGEOSEqualsExact}

\title{Geometry Relationships - Equality}
\description{Function for testing equivalence of the given geometries}
\usage{
	gEquals(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE,
 checkValidity=FALSE)
	gEqualsExact(spgeom1, spgeom2 = NULL, tol=0.0, byid = FALSE,
 returnDense=TRUE, checkValidity=FALSE)
}

\arguments{
  \item{spgeom1, spgeom2}{sp objects as defined in package sp. If spgeom2 is NULL then spgeom1 is compared to itself.}
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{tol}{Numerical value of tolerance to use when assessing equivalence}
  \item{returnDense}{default TRUE, if false returns a list of the length of spgeom1 of integer vectors listing the \code{1:length(spgeom2)} indices which would be TRUE in the dense logical matrix representation; useful when the sizes of the byid=TRUE returned matrix is very large and it is sparse; essential when the returned matrix would be too large}
  \item{checkValidity}{default FALSE; error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is TRUE, \code{gIsValid} is run on each in turn in an environment in which object names are available. If objects are invalid, this is reported and those affected are named}
}

\value{\code{gEquals} returns TRUE if geometries are "spatially equivalent" which requires that \code{spgeom1} is within \code{spgeom2} and \code{spgeom2} is within \code{spgeom1}, this ignores ordering of points within the geometries. Note that it is possible for geometries with different coordinates to be "spatially equivalent".

\code{gEqualsExact} returns TRUE if geometries are "exactly equivalent" which requires that \code{spgeom1} and \code{spgeom1} are "spatially equivalent" and that their constituent points are in the same order.
}

\note{Error messages from GEOS, in particular topology exceptions, report 0-based object order, so geom 0 is spgeom1, and geom 1 is spgeom2.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gContains}}
\code{\link{gContainsProperly}}
\code{\link{gCovers}}
\code{\link{gCoveredBy}}
\code{\link{gCrosses}}
\code{\link{gDisjoint}}
\code{\link{gEqualsExact}}
\code{\link{gIntersects}}
\code{\link{gOverlaps}}
\code{\link{gRelate}}
\code{\link{gTouches}}
\code{\link{gWithin}}
}


\examples{

# p1 and p2 are spatially identical but not exactly identical due to point ordering
p1=readWKT("POLYGON((0 0,1 0,1 1,0 1,0 0))")
p2=readWKT("POLYGON((1 1,0 1,0 0,1 0,1 1))")
p3=readWKT("POLYGON((0.01 0.01,1.01 0.01,1.01 1.01,0.01 1.01,0.01 0.01))")

gEquals(p1,p2)
gEquals(p1,p3)
gEqualsExact(p1,p2)
gEqualsExact(p1,p3,tol=0)
gEqualsExact(p1,p3,tol=0.1)

# pt1 and p2t are spatially identical but not exactly identical due to point ordering
pt1 = readWKT("MULTIPOINT(1 1,2 2,3 3)")
pt2 = readWKT("MULTIPOINT(3 3,2 2,1 1)")
pt3 = readWKT("MULTIPOINT(1.01 1.01,2.01 2.01,3.01 3.01)")

gEquals(pt1,pt2)
gEquals(pt1,pt3)
gEqualsExact(pt1,pt2)
gEqualsExact(pt1,pt3,tol=0)
gEqualsExact(pt1,pt3,tol=0.1)


# l2 contains a point that l1 does not
l1 = readWKT("LINESTRING (10 10, 20 20)")
l2 = readWKT("LINESTRING (10 10, 15 15,20 20)")
gEquals(l1,l2)
gEqualsExact(l1,l2)

}
\keyword{spatial}

\name{RGEOS Polygon Hole Comment Functions}
\alias{createSPComment}
\alias{createPolygonsComment}
\alias{get_do_poly_check}
\alias{set_do_poly_check}
\title{RGEOS Polygon Hole Comment Functions}
\description{Utility functions for assigning ownership of holes to parent polygons}
\usage{
	createSPComment(sppoly,which=NULL,overwrite=TRUE)
	createPolygonsComment(poly)
        set_do_poly_check(value)
        get_do_poly_check()
}

\arguments{
  \item{sppoly}{Object that inherits from the \code{SpatialPolygons} class}
  \item{which}{Vector, which subset of geometries in sppoly should comment attributes be generated}
  \item{overwrite}{Logical, if a comment attribute already exists should it be overwritten}
  \item{poly}{Object of class \code{Polygons}}
  \item{value}{logical value to set \dQuote{do_poly_check} option, default TRUE}
}

\section{Warning: check polygons}{
The helper functions get and set the imposition of checking of objects inheriting from \code{SpatialPolygons} for proper assignment of hole \emph{interior rings} to \emph{exterior rings} in \code{Polygons} objects. The internal GEOS representation defines a POLYGON object as a collection of only one exterior ring and from zero to many interior rings, so an \pkg{sp} \code{Polygons} object corresponds to a GEOS MULTIPOLYGON object, but without proper hole assignment. By default \code{do_poly_check} is TRUE; if it is set to FALSE using \code{set_do_poly_check(FALSE)}, and the \code{Polygons} object is not valid in GEOS terms, GEOS may crash R, which is why checks are imposed by default. 

The details below show how hole assignment is handled in the package; here we assume that the hole status slots of all Polygon objects in a given Polygons object are set correctly. In the examples below, we use a data set from \pkg{maptools} which has the holes correctly assigned, and we see that the SpatialPolygons object is geometrically valid both initially and after removing the comment attribute on the only Polygons object in \code{usa} - regenerating internally within \pkg{rgeos} from the hole status slots since \code{do_poly_check} is TRUE.

If we modify \code{usa} by setting all hole status slots to FALSE, the SpatialPolygons object is geometrically invalid even though a comment attribute can be created - the function \code{createSPComment} is deceived by the incorrect hole status slots. To rectify this, we use \code{\link[maptools]{checkPolygonsHoles}} from \pkg{maptools} on each \code{Polygons} object. This function calls \code{\link{gContains}}, \code{\link{gContainsProperly}}, \code{\link{gEquals}} and \code{\link{createPolygonsComment}} from \pkg{rgeos} to check whether the hole status slots are set correctly. Experience shows that many imported datasets from for example publically provided shapefiles have incorrect hole status values. Running \code{checkPolygonsHoles} is time-consuming when the number of member \code{Polygon} objects is large - attempts will be made to make this more efficient.
}

\section{Warning: planar geometries}{
The geometries handled by GEOS are assumed to be planar, so that any \pkg{rgeos} functions making measurements will give incorrect results when used on geographical coordinates measured in decimal degrees. Topological functions may work satisfactorily, but will not understand spherical wrap-around.
}

\details{In order for rgeos to function properly it is necessary that all holes within a given POLYGON or MULTIPOLYGON geometry must belong to a specific polygon. The \code{SpatialPolygons} class implementation does not currently include this information. To work around this limitation rgeos uses an additional comment attribute on the \code{Polygons} class that indicates which hole belongs to which polygon.

Under the current implementation this comment is a text string of numbers separated by spaces where the order of the numbers corresponds to the order of the \code{Polygon} objects in the \code{Polygons} slot of the \code{Polygons} object. A \code{0} implies the \code{Polygon} object is a polygon, a non-zero number implies that the \code{Polygon} object is a hole with the value indicating the index of the \code{Polygon} that \dQuote{owns} the hole.

\code{createPolygonsComment} attempts to create a valid comment for a \code{Polygons} object by assessing which polygons contain a given hole (using \code{\link{gContains}}). Ownership is assigned to the smallest polygon (by area) that contains the given hole. This is not guaranteed to generate valid polygons, always check the resulting objects for validity.

\code{createSPComment} attempts to create valid comments for all or a subset of polygons within a \code{SpatialPolygons} object. Refer to Bivand et al. (2013), pages 47-48 and 132-133 for a further discussion and \code{\link[sp]{SpatialPolygons}}
}

\author{Roger Bivand & Colin Rundel}

\references{Roger Bivand, Edzer Pebesma and Virgilio Gomez-Rubio, 2013. Applied spatial data analysis with R, Second edition. Springer, NY. \url{https://asdar-book.org/}}


\examples{
	
library(sp)
p1 <- Polygon(cbind(x=c(0, 0, 10, 10, 0), y=c(0, 10, 10, 0, 0)), hole=FALSE) # I
p2 <- Polygon(cbind(x=c(3, 3, 7, 7, 3), y=c(3, 7, 7, 3, 3)), hole=TRUE) # H
p8 <- Polygon(cbind(x=c(1, 1, 2, 2, 1), y=c(1, 2, 2, 1, 1)), hole=TRUE) # H
p9 <- Polygon(cbind(x=c(1, 1, 2, 2, 1), y=c(5, 6, 6, 5, 5)), hole=TRUE) # H
p3 <- Polygon(cbind(x=c(20, 20, 30, 30, 20), y=c(20, 30, 30, 20, 20)),
 hole=FALSE) # I
p4 <- Polygon(cbind(x=c(21, 21, 29, 29, 21), y=c(21, 29, 29, 21, 21)),
 hole=TRUE) # H
p5 <- Polygon(cbind(x=c(22, 22, 28, 28, 22), y=c(22, 28, 28, 22, 22)),
 hole=FALSE) # I
p6 <- Polygon(cbind(x=c(23, 23, 27, 27, 23), y=c(23, 27, 27, 23, 23)),
 hole=TRUE) # H
p7 <- Polygon(cbind(x=c(13, 13, 17, 17, 13), y=c(13, 17, 17, 13, 13)),
 hole=FALSE) # I
p10 <- Polygon(cbind(x=c(24, 24, 26, 26, 24), y=c(24, 26, 26, 24, 24)),
 hole=FALSE) # I
p11 <- Polygon(cbind(x=c(24.25, 24.25, 25.75, 25.75, 24.25),
 y=c(24.25, 25.75, 25.75, 24.25, 24.25)), hole=TRUE) # H
p12 <- Polygon(cbind(x=c(24.5, 24.5, 25.5, 25.5, 24.5),
 y=c(24.5, 25.5, 25.5, 24.5, 24.5)), hole=FALSE) # I
p13 <- Polygon(cbind(x=c(24.75, 24.75, 25.25, 25.25, 24.75),
 y=c(24.75, 25.25, 25.25, 24.75, 24.75)), hole=TRUE) # H
	
lp <- list(p1, p2, p13, p7, p6, p5, p4, p3, p8, p11, p12, p9, p10)
#           1   2    3   4   5   6   7   8   9   10   11  12   13
#           0   1   11   0   6   0   8   0   1   13    0   1    0
#           I   H    H   I   H   I   H   I   H    H    I   H    I
pls <- Polygons(lp, ID="1")
comment(pls)
	
comment(pls) = createPolygonsComment(pls)
comment(pls)
	
	
plot(SpatialPolygons(list(pls)), col="magenta", pbg="cyan")
 title(xlab="Hole slot values before checking")
\dontrun{
# running this illustration may be time-consuming
if (require(maptools)) {
data(wrld_simpl)
usa <- wrld_simpl[wrld_simpl$ISO3=="USA",]
lapply(slot(usa, "polygons"), comment)
gIsValid(usa, reason=TRUE)
comment(slot(usa, "polygons")[[1]]) <- NULL
lapply(slot(usa, "polygons"), comment)
gIsValid(usa)
any(c(sapply(slot(usa, "polygons"),
 function(x) sapply(slot(x, "Polygons"), slot, "hole"))))
lapply(slot(createSPComment(usa), "polygons"), comment)
usa1 <- usa
Pls <- slot(usa1, "polygons")
pls <- slot(Pls[[1]], "Polygons")
pls1 <- lapply(pls, function(p) {slot(p, "hole") <- FALSE; return(p)})
slot(Pls[[1]], "Polygons") <- pls1
slot(usa1, "polygons") <- Pls
any(c(sapply(slot(usa1, "polygons"),
 function(x) sapply(slot(x, "Polygons"), slot, "hole"))))
lapply(slot(createSPComment(usa1), "polygons"), comment)
gIsValid(usa1, reason=TRUE)
Pls <- slot(usa1, "polygons")
Pls1 <- lapply(Pls, checkPolygonsHoles)
slot(usa1, "polygons") <- Pls1
lapply(slot(usa1, "polygons"), comment)
gIsValid(usa1, reason=TRUE)
}
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{gpc.poly.nohole-class}
\docType{class}
\alias{gpc.poly.nohole-class}
\alias{coerce,numeric,gpc.poly.nohole-method}
\alias{coerce,gpc.poly.nohole,SpatialPolygons-method}
\alias{coerce,SpatialPolygons,gpc.poly.nohole-method}

\title{Class "gpc.poly.nohole"}
\description{
  A class for representing polygons with multiple contours but without
  holes.
}
\section{Objects from the Class}{
  Objects can be created by calls of the form
  \sQuote{new("gpc.poly.nohole", ...) or by calling \code{read.polyfile}}.
}
\section{Slots}{
  \describe{
    \item{pts}{Object of class \dQuote{list}.  See the help for
      \dQuote{gpc.poly} for details.}
  }
}
\section{Extends}{
Class \dQuote{gpc.poly}, directly.
}
\section{Methods}{
  \describe{
    \item{coerce}{\code{signature(from = "numeric", to = "gpc.poly.nohole")}: ... }
  }
}
\author{Roger D. Peng}
\note{
  This class is identical to \dQuote{"gpc.poly"} and is needed because the
  file formats for polygons without holes is slightly different from the
  file format for polygons with holes.  For a \dQuote{gpc.poly.nohole}
  object, the \verb{hole} flag for each contour is always \code{FALSE}.

  Also, \code{write.polyfile} will write the correct file format,
  depending on whether the object is of class \dQuote{gpc.poly} or
  \dQuote{gpc.poly.nohole}.
}

\seealso{
  \code{\link{gpc.poly-class}}
}
\examples{
## None
}
\keyword{classes}

\name{SpatialRings-class}
\docType{class}
\alias{SpatialRings-class}
\alias{[,SpatialRings-method}
\alias{plot,SpatialRings,missing-method}
\alias{coordinates,SpatialRings-method}
\alias{coordnames,SpatialRings-method}
\alias{coordnames<-,SpatialRings,character-method}
\alias{row.names,SpatialRings-method}
\alias{row.names<-,SpatialRings,character-method}
\alias{spChFIDs,SpatialRings,character-method}
\alias{coerce,SpatialRings,SpatialPoints-method}



\title{Class "SpatialRings"}
\description{  class to hold linear ring topology (without attributes) }
\section{Objects from the Class}{
Objects can be created by calls to the function \link{SpatialRings}
}
\section{Slots}{
  \describe{
    \item{\code{rings}:}{Object of class \code{"list"}; list elements are
	all of class \link{Ring-class}}
    \item{\code{bbox}:}{Object of class \code{"matrix"}; see \link{Spatial-class} }
    \item{\code{proj4string}:}{Object of class \code{"CRS"}; see \link{CRS-class}}
  }
}

\section{Extends}{
Class \code{"Spatial"}, directly.
}

\section{Methods}{
Methods defined with class "SpatialRings" in the signature:
  \describe{
    \item{[}{\code{signature(obj = "SpatialRings")}: select subset of (sets of) rings; NAs are not permitted in the row index}
	\item{plot}{\code{signature(x = "SpatialRings", y = "missing")}: plot rings in SpatialRings object}
	\item{bbox}{\code{signature(obj = "SpatialRings")}: retrieves the bbox element }
	\item{coordinates}{\code{signature(object = "SpatialRings")}: retrieves the coords element from Ring objects in rings slot}
	\item{coordnames}{\code{signature(object = "SpatialRings")}: retrieves coordinate names}
	\item{row.names}{\code{signature(object = "SpatialRings")}: retrieves the ID element from Ring objects in rings slot}
	\item{spChFIDs}{\code{signature(obj="SpatialRings", x="character")}: replaces ID element}
	\item{coerce}{\code{signature(from = "SpatialRings", to = "SpatialPoints")}: ... }
  }
}

\author{ Colin Rundel }
\seealso{ \link{SpatialRings} \link{Ring-class} }

\examples{ 
	#NONE 
}

\keyword{classes}

\name{over}
\alias{overGeomGeom}
\alias{overGeomGeomDF}

\title{Find spatial join or intersections}
\description{Find spatial join or intersections}
\usage{
overGeomGeom(x, y, returnList = FALSE, fn = NULL, ..., minDimension = -1)
overGeomGeomDF(x, y, returnList = FALSE, fn = NULL, ..., minDimension = -1)
}

\arguments{
  \item{x}{see \link[sp]{over}}
  \item{y}{see \link[sp]{over}}
  \item{returnList}{see \link[sp]{over}}
  \item{fn}{see \link[sp]{over}}
  \item{...}{see \link[sp]{over}}
  \item{minDimension}{integer; if \code{-1}, \link{gIntersects} is used to find
  geometry intersections; if \code{0}, \code{1} or \code{2}, \link{gRelate} is used. if
  \link{gRelate} is used, intersecting geometries are ordered by the dimension of the
  intersection (2: area overlap; 1: line in common; 0: point in common), and \code{minDimension}
  determines the mininum dimension of intersection required. }
}

\value{see \link[sp]{over}}
\note{\link{gRelate} (\code{minDimension} > -1) is likely to be substantially slower than
\link{gIntersects}.}

\author{Edzer Pebesma}
\examples{
p1 = readWKT("POLYGON((0 1,0.95 0.31,0.59 -0.81,-0.59 -0.81,-0.95 0.31,0 1))")
p2 = readWKT("POLYGON((2 2,-2 2,-2 -2,2 -2,2 2),(1 1,-1 1,-1 -1,1 -1,1 1))")

overGeomGeom(p1,p2)
}
\keyword{spatial}

\name{gIsRing}
\alias{gIsRing}
\alias{RGEOSisRing}

\title{Is Geometry a Ring?}
\description{Tests if the given geometry is a ring}
\usage{
gIsRing(spgeom, byid = FALSE) 
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
}

\value{Returns TRUE if the geometry is a LINEARRING.

Returns TRUE if the geometry is a LINESTRING that is both Simple (\link{gIsSimple}) and Closed (end points intersect), FALSE otherwise.

Returns FALSE if the geometry is a [MULTI]POINT, MULTILINESTRING, or [MULTI]POLYGON.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gIsEmpty}}
\code{\link{gIsSimple}}
\code{\link{gIsValid}}
}

\examples{

l1 = readWKT("LINESTRING(0 0, 1 1, 1 0, 0 1, 0 0)")
l2 = readWKT("LINESTRING(0 0,1 0,1 1,0 1,0 0)")
r1 = readWKT("LINEARRING(0 0, 1 1, 1 0, 0 1, 0 0)")
r2 = readWKT("LINEARRING(0 0,1 0,1 1,0 1,0 0)")
p1 = readWKT("POLYGON((0 0, 1 1, 1 0, 0 1, 0 0))")
p2 = readWKT("POLYGON((0 0,1 0,1 1,0 1,0 0))")

par(mfrow=c(3,2))
plot(l1);title(paste("LINESTRING\nRing:",gIsRing(l1)))
plot(l2);title(paste("LINESTRING\nRing:",gIsRing(l2)))
plot(r1);title(paste("LINEARRING\nRing:",gIsRing(r1)))
plot(r2);title(paste("LINEARRING\nRing:",gIsRing(r2)))
plot(p1);title(paste("POLYGON\nRing:",gIsRing(p1)))
plot(p2);title(paste("POLYGON\nRing:",gIsRing(p2)))
}

\keyword{spatial}

\name{gDelaunayTriangulation}
\alias{gDelaunayTriangulation}

\title{Compute Delaunay triangulation between points}
\description{Function to compute the Delaunay triangulation between points; only available for GEOS >= 3.4.0.}
\usage{
	gDelaunayTriangulation(spgeom, tolerance=0.0, onlyEdges=FALSE)
}

\arguments{
  \item{spgeom}{sp points object as defined in package sp}
  \item{tolerance}{Numerical tolerance value to be used in triangulation}
  \item{onlyEdges}{Logical, default returns triangles as polygons, if TRUE, returns a SpatialLines object with a single MULTILINESTRING}
}

\value{Either a SpatialPolygons object or a SpatialLines object containing a single Lines object of the undirected edges in the triangulation.}

\details{When onlyEdges is TRUE, the SpatialLines object may be de-merged to identify the input points that are touched by each edge, making it possible to identify spatial neighbours.}

\author{Roger Bivand}

\references{
\url{https://en.wikipedia.org/wiki/Delaunay_triangulation}
}


\examples{
if (version_GEOS0() > "3.4.0") {
library(sp)
data(meuse)
coordinates(meuse) <- c("x", "y")
plot(gDelaunayTriangulation(meuse))
points(meuse)
out <- gDelaunayTriangulation(meuse, onlyEdges=TRUE)
lns <- slot(slot(out, "lines")[[1]], "Lines")
out1 <- SpatialLines(lapply(seq(along=lns), function(i) Lines(list(lns[[i]]),
 ID=as.character(i))))
out2 <- lapply(1:length(out1), function(i) which(gTouches(meuse, out1[i],
 byid=TRUE)))
out3 <- do.call("rbind", out2)
o <- order(out3[,1], out3[,2])
out4 <- out3[o,]
out5 <- data.frame(from=out4[,1], to=out4[,2], weight=1)
head(out5)
\dontrun{
if (require(spdep)) {
class(out5) <- c("spatial.neighbour", class(out5))
attr(out5, "n") <- length(meuse)
attr(out5, "region.id") <- as.character(1:length(meuse))
nb1 <- sn2listw(out5)$neighbours
nb2 <- make.sym.nb(nb1)
}
}
}
}

\keyword{spatial}

\name{gMakeValid}
\alias{gMakeValid}

\title{Make invalid geometries valid}
\description{Function returns a valid geometry, not available before GEOS 3.8.0; from 3.10.0 two correction strategies}
\usage{
gMakeValid(spgeom, byid=FALSE, id = NULL, original=NULL, keepCollapsed=NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
  \item{original}{default NULL; if GEOS < 3.10.0, TRUE, if GEOS >= 3.10.0, either set directly or taken from environment variable \code{GEOS_MAKE_VALID} with values \code{LINEWORK} for the original algorithm or \code{STRUCTURE} for the new algorithm. If \code{GEOS_MAKE_VALID} is \code{STRUCTURE}, \code{original} is FALSE}
  \item{keepCollapsed}{default NULL; If GEOS >= 3.10.0 and \code{original} is FALSE, the argument is used to control whether objects with dimension reduction are discarded (keepCollapsed is FALSE) or retained (TRUE). It may be set directly, or if NULL controlled by environment variable \code{GEOS_MAKE_VALID_KEEPCOLLAPSED} with values \code{FALSE} or \code{TRUE}. If \code{GEOS_MAKE_VALID_KEEPCOLLAPSED} is \code{TRUE}, \code{keepCollapsed} is TRUE}
}

\details{Returns a valid geometry or collection of geometries of different types. For details on the buffered geometry fixer, see links from \url{https://github.com/r-spatial/sf/issues/1655}.}

\author{Roger Bivand}

\seealso{\link{SpatialCollections-class}}


\examples{
# Based on test geometries from sf
run <- FALSE
if (version_GEOS0() >= "3.8.0") run <- TRUE
if (run) {
X <- readWKT("POLYGON ((0 0, 0.5 0, 0.5 0.5, 0.5 0, 1 0, 1 1, 0 1, 0 0))")
gIsValid(X)
}
if (run) {
class(X)
}
if (run) {
row.names(X)
}
if (run) {
Y <- gMakeValid(X)
}
if (run) {
gIsValid(Y)
}
if (run) {
class(Y)
}
if (run) {
plot(slot(Y, "polyobj"))
plot(slot(Y, "lineobj"), add=TRUE, col="red")
}
if (run) {
row.names(slot(Y, "polyobj"))
}
if (run) {
row.names(slot(Y, "lineobj"))
}
run <- FALSE
if (version_GEOS0() >= "3.10.0") run <- TRUE
if (run) {
JTSplot <- function(x, fill="grey90", pts="black", main="", xlim, ylim) {
  if (inherits(x, "SpatialCollections")) {
    xl <- xp <- xpl <- NULL
    if (!is.null(slot(x, "lineobj"))) xl <- slot(x, "lineobj")
    if (!is.null(slot(x, "pointobj"))) xp <- slot(x, "pointobj")
    if (!is.null(slot(x, "polyobj"))) xpl <- slot(x, "polyobj")
    if (is.null(xl)) xl <- as(xpl, "SpatialLines")
    else xl <- rbind(xl, as(xpl, "SpatialLines"))
    if (is.null(xp)) xp <- as(xl, "SpatialPoints")
    else xp <- rbind(xp, as(xl, "SpatialPoints"))
  } else {
    xl <- as(x, "SpatialLines")
    xp <- as(xl, "SpatialPoints")
  }
  plot(coordinates(xp), type="n", main=main, xlab="", ylab="", axes=FALSE, xlim=xlim, ylim=ylim)
  plot(x, col=fill, border="transparent", add=TRUE, xlim=xlim, ylim=ylim)
  plot(xl, col=pts, add=TRUE, xlim=xlim, ylim=ylim)
  plot(xp, col=pts, add=TRUE, pch=14, xlim=xlim, ylim=ylim)
}
}
if (run) {
X <- readWKT(paste0("POLYGON ((10 70, 90 70, 90 50, 30 50, 30 30, ",
 "50 30, 50 90, 70 90, 70 10, 10 10, 10 70))", sep=""))
bb <- bbox(X)
opar <- par(mfrow=c(2,2))
JTSplot(X, fill="#dfdfff", pts="#00007c", main="input", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=TRUE), fill="#ffffa4", pts="#78b400",
 main="linework", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE), fill="#ffffa4", pts="#78b400",
 main="structure", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE, keepCollapsed=TRUE), fill="#ffffa4",
 pts="#78b400", main="structure + keep collapsed", xlim=bb[1,], ylim=bb[2,])
par(opar)
}
if (run) {
X <- readWKT(paste0("POLYGON ((10 70, 90 70, 90 10, 10 10, 10 70), ",
 "(60 80, 50 30, 0 20, 10 30, 60 80), (30 40, 60 30, 40 0, 30 40))", sep=""))
bb <- rbind(c(0, 90), c(0, 80))
opar <- par(mfrow=c(2,2))
JTSplot(X, fill="#dfdfff", pts="#00007c", main="input", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=TRUE), fill="#ffffa4", pts="#78b400",
 main="linework", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE), fill="#ffffa4", pts="#78b400",
 main="structure", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE, keepCollapsed=TRUE), fill="#ffffa4",
 pts="#78b400", main="structure + keep collapsed", xlim=bb[1,], ylim=bb[2,])
par(opar)
}
if (run) {
X <- readWKT(paste0("MULTIPOLYGON (((10 90, 60 90, 60 40, 10 40, 10 90)), ",
 "((40 60, 70 60, 70 30, 40 30, 40 60)), ((20 50, 50 50, 50 20, 20 20, 20 50)))", sep=""))
bb <- bbox(X)
opar <- par(mfrow=c(2,2))
JTSplot(X, fill="#dfdfff", pts="#00007c", main="input", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=TRUE), fill="#ffffa4", pts="#78b400",
 main="linework", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE), fill="#ffffa4", pts="#78b400",
 main="structure", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE, keepCollapsed=TRUE), fill="#ffffa4",
 pts="#78b400", main="structure + keep collapsed", xlim=bb[1,], ylim=bb[2,])
par(opar)
}
if (run) {
X <- readWKT(paste0("MULTIPOLYGON (((10 40, 40 40, 40 10, 10 10, 10 40), ", 
"(16 17, 31 32, 24 25, 16 17)), ((50 40, 50 40, 50 40, 50 40, 50 40)))", sep=""))
bb <- bbox(X)
opar <- par(mfrow=c(2,2))
JTSplot(X, fill="#dfdfff", pts="#00007c", main="input", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=TRUE), fill="#ffffa4", pts="#78b400",
 main="linework", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE), fill="#ffffa4", pts="#78b400",
 main="structure", xlim=bb[1,], ylim=bb[2,])
JTSplot(gMakeValid(X, original=FALSE, keepCollapsed=TRUE), fill="#ffffa4",
 pts="#78b400", main="structure + keep collapsed", xlim=bb[1,], ylim=bb[2,])
par(opar)
}
if (run) {
X <- readWKT(paste0("MULTIPOLYGON (((10 40, 40 40, 40 10, 10 10, 10 40), ", 
"(16 17, 31 32, 24 25, 16 17)), ((50 40, 50 40, 50 40, 50 40, 50 40)))", sep=""))
bb <- bbox(X)
opar <- par(mfrow=c(2,2))
JTSplot(X, fill="#dfdfff", pts="#00007c", main="input", xlim=bb[1,], ylim=bb[2,])
Sys.setenv("GEOS_MAKE_VALID"="LINEWORK")
JTSplot(gMakeValid(X), fill="#ffffa4", pts="#78b400", main="linework (env-var)",
 xlim=bb[1,], ylim=bb[2,])
Sys.setenv("GEOS_MAKE_VALID"="STRUCTURE")
Sys.setenv("GEOS_MAKE_VALID_KEEPCOLLAPSED"="FALSE")
JTSplot(gMakeValid(X), fill="#ffffa4", pts="#78b400", main="structure (env-vars)",
 xlim=bb[1,], ylim=bb[2,])
Sys.setenv("GEOS_MAKE_VALID_KEEPCOLLAPSED"="TRUE")
JTSplot(gMakeValid(X), fill="#ffffa4", pts="#78b400", main="structure + keep collapsed (env-vars)",
 xlim=bb[1,], ylim=bb[2,])
par(opar)
Sys.unsetenv("GEOS_MAKE_VALID")
Sys.unsetenv("GEOS_MAKE_VALID_KEEPCOLLAPSED")

}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{gPointOnSurface}
\alias{gPointOnSurface}
\alias{RGEOSPointOnSurface}

\title{Point on Surface of Geometry}
\description{Function returns a point on the surface of the given geometry}
\usage{
gPointOnSurface(spgeom, byid=FALSE, id = NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
}

\details{Returns a SpatialPoints object with a point that intersects with the geometry}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gBoundary}}
\code{\link{gCentroid}}
\code{\link{gConvexHull}}
\code{\link{gEnvelope}}
}

\examples{
# Based on test geometries from JTS
g1 = readWKT(paste("MULTIPOINT (60 300, 200 200, 240 240, 200 300, 40 140,",
 "80 240, 140 240, 100 160, 140 200, 60 200)"))
g2 = readWKT("LINESTRING (0 0, 7 14)")
g3 = readWKT("LINESTRING (0 0, 3 15, 6 2, 11 14, 16 5, 16 18, 2 22)")
g4 = readWKT(paste("MULTILINESTRING ((60 240, 140 300, 180 200, 40 140, 100 100, 120 220),",
 "(240 80, 260 160, 200 240, 180 340, 280 340, 240 180, 180 140, 40 200, 140 260))"))
g5 = readWKT("POLYGON ((0 0, 0 10, 10 10, 10 0, 0 0))")
g6 = readWKT(paste("MULTIPOLYGON (((50 260, 240 340, 260 100, 20 60, 90 140, 50 260),",
 "(200 280, 140 240, 180 160, 240 140, 200 280)),",
 "((380 280, 300 260, 340 100, 440 80, 380 280),",
 "(380 220, 340 200, 400 100, 380 220)))"))

par(mfrow=c(2,3))
plot(g1); plot(gPointOnSurface(g1),col='red',add=TRUE)
plot(g2); plot(gPointOnSurface(g2),col='red',add=TRUE)
plot(g3); plot(gPointOnSurface(g3),col='red',add=TRUE)
plot(g4); plot(gPointOnSurface(g4),col='red',add=TRUE)
plot(g5); plot(gPointOnSurface(g5),col='red',add=TRUE)
plot(g6); plot(gPointOnSurface(g6),col='red',add=TRUE)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{Ring-class}
\docType{class}
\alias{Ring-class}
\alias{bbox,Ring-method}
\alias{coordinates,Ring-method}
\alias{coordnames,Ring-method}
\alias{coordnames<-,Ring,character-method}
\alias{coerce,Ring,SpatialPoints-method}



\title{Class "Ring"}
\description{  class for linear ring }
\section{Objects from the Class}{
Objects can be created by calls to the function \link{Ring}
}
\section{Slots}{
  \describe{
    \item{\code{coords}:}{Object of class \code{"matrix"}; coordinates of the ring;
	first point should equal the last point }
    \item{\code{ID}:}{Object of class \code{"character"}; unique identifier string  }
  }
}

\section{Methods}{
Methods defined with class "Ring" in the signature:
  \describe{
    \item{bbox}{\code{signature(obj = "Ring")}: retrieves the bbox element }
	\item{coordinates}{\code{signature(object = "Ring")}: retrieves the coords element from Ring objects in rings slot}
	\item{coordnames}{\code{signature(object = "Ring")}: retrieves coordinate names}
	\item{coerce}{\code{signature(from = "Ring", to = "SpatialPoints")}: ... }
  }
}

\author{ Colin Rundel }
\seealso{ \link{Ring} }

\examples{ 
	#NONE 
}

\keyword{classes}

\name{gMinumumRotatedRectangle}
\alias{gMinumumRotatedRectangle}

\title{Centroid of Geometry}
\description{Returns the minimum rotated rectangular POLYGON which encloses the input geometry.}
\usage{
gMinumumRotatedRectangle(spgeom, byid=FALSE, id = NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
}

\details{Returns the minimum rotated rectangular POLYGON which encloses the input geometry. The rectangle has width equal to the minimum diameter, and a longer length. If the convex hill of the input is degenerate (a line or point) a LINESTRING or POINT is returned. The minimum rotated rectangle can be used as an extremely generalized representation for the given geometry.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gBoundary}}
\code{\link{gConvexHull}}
\code{\link{gEnvelope}}
\code{\link{gPointOnSurface}}
}

\examples{

if (version_GEOS0() >= "3.9.0") {
x = readWKT(paste("GEOMETRYCOLLECTION(POLYGON((0 0,10 1,10 11,0 10,0 0)),",
 "POLYGON((15 0,25 12,35 3,15 0)))"))

# Minimum rotated rectangles of both the square and circle independently
c1 = gMinumumRotatedRectangle(x,byid=TRUE) 
# Minimum rotated rectangle of square and circle together
c2 = gMinumumRotatedRectangle(x)

opar <- par(mfrow=c(2,1))
plot(c1, border='red', lwd=2, lty=2)
plot(x,add=TRUE)
plot(c2, border='blue', lwd=2, lty=3)
plot(x,add=TRUE)
par(opar)
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{bbox2SP}
\alias{bbox2SP}
\title{Converts a bounding box into a SpatialPolygons object.}
\description{Converts a bounding box into a SpatialPolygons object.}

\usage{bbox2SP(n,s,w,e,bbox=NA,proj4string=CRS("+init=epsg:4326"))}

\arguments{
  \item{n}{the top north latitude}
  \item{s}{the bottom south latitude}
  \item{w}{the most western longitude}
  \item{e}{the most eastern longitude}
  \item{bbox}{a bounding box 2 x 2 matrix as produced by  \code{\link[sp]{bbox}}}
  \item{proj4string}{a coordinate reference system as defined in  \code{\link[sp]{CRS}}}
}

\details{

This function converts a set of coordinates limiting a bounding box into a SpatialPolygons. It can be used for instance to clip a subset of a larger spatial object (e.g. using \code{\link[rgeos]{gIntersection}})
}

\value{ 
An object of \code{\link[sp]{SpatialPolygons}} class.
}


\examples{

library(sp)
run <- FALSE
if (require(rgdal, quietly=TRUE)) run <- TRUE
if (run) {
cities <- readOGR(dsn=system.file("vectors", package = "rgdal")[1], layer="cities")
n<-75
s<-30
w<--40
e<-32
myPoly<-bbox2SP(n,s,e,w)
}
if (run) {
plot(cities)
plot(myPoly,border="red",add=TRUE)
}
if (run) {
bb<-bbox(cities)
myPoly<-bbox2SP(bbox=bb,proj4string=CRS(proj4string(cities)))
plot(myPoly,add=TRUE,border="blue")
}
}




\keyword{utilities}

\name{gProject}
\alias{gProject}
\title{Project Points to Line Geometry}
\usage{
gProject(spgeom, sppoint, normalized = FALSE)
}
\arguments{
\item{spgeom}{SpatialLines or SpatialLinesDataFrame object}

\item{sppoint}{SpatialPoints or SpatialPointsDataFrame object}

\item{normalized}{Logical determining if normalized distances
should be used}
}
\value{
a numeric vector containing the distances along the line to
  points nearest to the specified points
}
\description{
Return distances along geometry to points nearest the specified points.
}
\details{
If \code{normalized=TRUE}, distances normalized to the length
  of the geometry are returned, i.e., values between 0 and 1.
}
\examples{
l <- readWKT("LINESTRING(0 1, 3 4, 5 6)")
p1 <- readWKT("MULTIPOINT(3 2, 3 5)")
frac <- gProject(l, p1)
p2 <- gInterpolate(l, frac)
plot(l, axes=TRUE)
plot(p1, col = "blue", add = TRUE)
plot(p2, col = "red", add = TRUE)
}
\seealso{
gInterpolate
}
\author{
Rainer Stuetz
}
\keyword{spatial}

\name{gBoundary}
\alias{gBoundary}
\alias{RGEOSBoundary}

\title{Boundary of Geometry}
\description{Function for determinging the Boundary of the given geometry as defined by SFS Section 2.1.13.1}
\usage{
gBoundary(spgeom, byid=FALSE, id = NULL)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{id}{Character vector defining id labels for the resulting geometries, if unspecified returned geometries will be labeled based on their parent geometries' labels.}
}

\value{Depending of the class of the spgeom the returned results will differ.

Based on the documentation of JTS (on which GEOS is based) the following outputs are expected:
\tabular{ll}{
Point 			\tab 	empty GeometryCollection \cr
MultiPoint		\tab 	empty GeometryCollection \cr
LineString		\tab 	if closed: empty MultiPoint
						if not closed: MultiPoint containing the two endpoints. \cr 
MultiLineString	\tab 	MultiPoint obtained by applying the Mod-2 rule to the boundaries of the element LineStrings \cr
LinearRing		\tab 	empty MultiPoint \cr
Polygon			\tab 	MultiLineString containing the LinearRings of the shell and holes, in that order (SFS 2.1.10) \cr
MultiPolygon	\tab 	MultiLineString containing the LinearRings for the boundaries of the element polygons, in the same order as they occur in the MultiPolygon (SFS 2.1.12/JTS) \cr
GeometryCollection	\tab The boundary of an arbitrary collection of geometries whose interiors are disjoint consist of geometries drawn from the boundaries of the element geometries by application of the Mod-2 rule (SFS Section 2.1.13.1)\cr
}

The mod-2 rule states that for a multiline a point is on the boundary if and only if it on the boundary of an odd number of subgeometries of the multiline (See example below).
}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gCentroid}}
\code{\link{gConvexHull}}
\code{\link{gEnvelope}}
\code{\link{gPointOnSurface}}
}

\examples{

x = readWKT("POLYGON((0 0,10 0,10 10,0 10,0 0))")
b = gBoundary(x)

plot(x,col='black')
plot(b,col='red',lwd=3,add=TRUE)

# mod-2 rule example
x1 = readWKT("MULTILINESTRING((2 2,2 0),(2 2,0 2))")
x2 = readWKT("MULTILINESTRING((2 2,2 0),(2 2,0 2),(2 2,4 2))")
x3 = readWKT("MULTILINESTRING((2 2,2 0),(2 2,0 2),(2 2,4 2),(2 2,2 4))")
x4 = readWKT("MULTILINESTRING((2 2,2 0),(2 2,0 2),(2 2,4 2),(2 2,2 4),(2 2,4 4))")

b1 = gBoundary(x1)
b2 = gBoundary(x2)
b3 = gBoundary(x3)
b4 = gBoundary(x4)

par(mfrow=c(2,2))
plot(x1); plot(b1,pch=16,col='red',add=TRUE)
plot(x2); plot(b2,pch=16,col='red',add=TRUE)
plot(x3); plot(b3,pch=16,col='red',add=TRUE)
plot(x4); plot(b4,pch=16,col='red',add=TRUE)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{gIsEmpty}
\alias{gIsEmpty}
\alias{RGEOSisEmpty}

\title{Is Geometry Empty?}
\description{Tests if the given geometry is empty}
\usage{
gIsEmpty(spgeom, byid = FALSE) 
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
}

\details{Because no sp Spatial object may be empty, the function exists but cannot work, as \code{readWKT} is not permitted to create an empty object.}

\value{Returns TRUE if the given geometry is empty, FALSE otherwise.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gIsRing}}
\code{\link{gIsSimple}}
\code{\link{gIsValid}}
}

\examples{
try(gIsEmpty(readWKT("POINT EMPTY")))
gIsEmpty(readWKT("POINT(1 1)"))
try(gIsEmpty(readWKT("LINESTRING EMPTY")))
gIsEmpty(readWKT("LINESTRING(0 0,1 1)"))
try(gIsEmpty(readWKT("POLYGON EMPTY")))
gIsEmpty(readWKT("POLYGON((0 0,1 0,1 1,0 1,0 0))"))
}

\keyword{spatial}

\name{SpatialRings}
\alias{Ring}
\alias{SpatialRings}
\alias{SpatialRingsDataFrame}

\title{ create SpatialRings or SpatialRingsDataFrame}

\description{ create objects of class \code{SpatialRings} or \code{SpatialRingsDataFrame} }

\usage{ 
Ring(coords,ID=as.character(NA))
SpatialRings(RingList, proj4string=CRS(as.character(NA)))
SpatialRingsDataFrame(sr, data, match.ID = TRUE)
}

\arguments{
\item{coords}{2-column numeric matrix with coordinates; first point (row) should
equal last coordinates (row); if the hole argument is not given, the status of the polygon as a hole or an island will be taken from the ring direction, with clockwise meaning island, and counter-clockwise meaning hole}
\item{ID}{character vector of length one with identifier}
\item{RingList}{ list with objects of class \link{Ring-class}}
\item{proj4string}{Object of class \code{"CRS"} holding a valid proj4 string}
\item{sr}{ object of class \link{SpatialRings-class}}
\item{data}{ object of class \code{data.frame}; the number of rows in \code{data}
should equal the number of \code{Lines} elements in \code{sl}}
\item{match.ID}{logical: (default TRUE): match SpatialLines member Lines ID slot values with data frame row names, and re-order the data frame rows if necessary}
}

\value{
\code{Ring} returns object of class \code{Ring}
\code{SpatialRings} returns object of class \code{SpatialRings}
\code{SpatialRingsDataFrame} returns object of class \code{SpatialRingsDataFrame}
}
\seealso{ \link{Ring-class} \link{SpatialRings-class} \link{SpatialRingsDataFrame-class}  }

\keyword{manip}

\name{gContains}
\alias{gContains}
\alias{gContainsProperly}
\alias{gCovers}
\alias{gCoveredBy}
\alias{gWithin}
\alias{RGEOSContains}
\alias{RGEOSWithin}

\title{Geometry Relationships - Contains and Within}
\description{Functions for testing whether one geometry contains or is contained within another geometry}
\usage{
gContains(spgeom1, spgeom2 = NULL, byid = FALSE, prepared=TRUE,
 returnDense=TRUE, STRsubset=FALSE, checkValidity=FALSE)
gContainsProperly(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE,
 checkValidity=FALSE)
gCovers(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE)
gCoveredBy(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE)
gWithin(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE, checkValidity=FALSE)
}
	
\arguments{
  \item{spgeom1, spgeom2}{sp objects as defined in package sp. If spgeom2 is NULL then spgeom1 is compared to itself.}
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{prepared}{Logical determining if prepared geometry (spatially indexed) version of the GEOS function should be used. In general prepared geometries should be faster than the alternative.}
  \item{returnDense}{default TRUE, if false returns a list of the length of spgeom1 of integer vectors listing the \code{1:length(spgeom2)} indices which would be TRUE in the dense logical matrix representation; useful when the sizes of the byid=TRUE returned matrix is very large and it is sparse; essential when the returned matrix would be too large}
  \item{checkValidity}{default FALSE; error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is TRUE, \code{gIsValid} is run on each in turn in an environment in which object names are available. If objects are invalid, this is reported and those affected are named}
  \item{STRsubset}{logical argument for future use}
}

\value{\code{gContains} returns TRUE if none of the point of \code{spgeom2} is outside of \code{spgeom1} and at least one point of \code{spgeom2} falls within \code{spgeom1}.

\code{gContainsProperly} returns TRUE under the same conditions as \code{gContains} with the additional requirement that \code{spgeom2} does not intersect with the boundary of \code{spgeom1}. As such any given geometry will Contain itself but will not ContainProperly itself. 

\code{gCovers} returns TRUE if no point in \code{spgeom2} is outside of \code{spgeom1}. This is slightly different from \code{gContains} as it does not require a point within \code{spgeom1} which can be an issue as boundaries are not considered to be "within" a geometry, see \code{\link{gBoundary}} for specifics of geometry boundaries.


\code{gCoveredBy} is the converse of \code{gCovers} and is equivalent to swapping \code{spgeom1} and \code{spgeom2}. 

\code{gWithin} is the converse of \code{gContains} and is equivalent to swapping \code{spgeom1} and \code{spgeom2}. 
}

\note{Error messages from GEOS, in particular topology exceptions, report 0-based object order, so geom 0 is spgeom1, and geom 1 is spgeom2.}

\references{
Helpful information on the subtle differences between these functions:
\url{http://lin-ear-th-inking.blogspot.com/2007/06/subtleties-of-ogc-covers-spatial.html}}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gCrosses}}
\code{\link{gDisjoint}}
\code{\link{gEquals}}
\code{\link{gEqualsExact}}
\code{\link{gIntersects}}
\code{\link{gOverlaps}}
\code{\link{gRelate}}
\code{\link{gTouches}}
}

\examples{
	l1 = readWKT("LINESTRING(0 3,1 1,2 2,3 0)")
	l2 = readWKT("LINESTRING(1 3.5,3 3,2 1)")
	l3 = readWKT("LINESTRING(1 3.5,3 3,4 1)")
	
	pt1 = readWKT("MULTIPOINT(1 1,3 0)")
	pt2 = readWKT("MULTIPOINT(0 3,3 0)")
	pt3 = readWKT("MULTIPOINT(1 1,2 2,3 1)")
	
	p1 = readWKT("POLYGON((0 0,0 2,1 3.5,3 3,4 1,3 0,0 0))")
	p2 = readWKT("POLYGON((1 1,1 2,2 2,2 1,1 1))")

	
	par(mfrow=c(2,3))
	plot(l1,col='blue');plot(pt1,add=TRUE,pch=16)
	title(paste("Contains:",gContains(l1,pt1),
				"\nContainsProperly:",gContainsProperly(l1,pt1),
				"\nCovers:",gCovers(l1,pt1)))
	
	plot(l1,col='blue');plot(pt2,add=TRUE,pch=16)
	title(paste("Contains:",gContains(l1,pt2),
				"\nContainsProperly:",gContainsProperly(l1,pt2),
				"\nCovers:",gCovers(l1,pt2)))
	
	plot(p1,col='blue',border='blue');plot(pt3,add=TRUE,pch=16)
	title(paste("Contains:",gContains(p1,pt3),
				"\nContainsProperly:",gContainsProperly(p1,pt3),
				"\nCovers:",gCovers(p1,pt3)))
	
	plot(p1,col='blue',border='blue');plot(l2,lwd=2,add=TRUE,pch=16)
	title(paste("Contains:",gContains(p1,l2),
				"\nContainsProperly:",gContainsProperly(p1,l2),
				"\nCovers:",gCovers(p1,l2)))

	plot(p1,col='blue',border='blue');plot(l3,lwd=2,add=TRUE,pch=16)
	title(paste("Contains:",gContains(p1,l3),
				"\nContainsProperly:",gContainsProperly(p1,l3),
				"\nCovers:",gCovers(p1,l3)))

	plot(p1,col='blue',border='blue');plot(p2,col='black',add=TRUE,pch=16)
	title(paste("Contains:",gContains(p1,p2),
				"\nContainsProperly:",gContainsProperly(p1,p2),
				"\nCovers:",gCovers(p1,p2)))
	
	
}
\keyword{spatial}

\name{gTouches}
\alias{gTouches}
\alias{RGEOSTouches}

\title{Geometry Relationships - Touches}
\description{Functions for testing if the geometries have at least one boundary point in common, but no interior points}
\usage{
	gTouches(spgeom1, spgeom2 = NULL, byid = FALSE, returnDense=TRUE,
 checkValidity=FALSE)
}
	
\arguments{
  \item{spgeom1, spgeom2}{sp objects as defined in package sp. If spgeom2 is NULL then spgeom1 is compared to itself.}
  \item{byid}{Logical vector determining if the function should be applied across ids (TRUE) or the entire object (FALSE) for spgeom1 and spgeom2}
  \item{returnDense}{default TRUE, if false returns a list of the length of spgeom1 of integer vectors listing the \code{1:length(spgeom2)} indices which would be TRUE in the dense logical matrix representation; useful when the sizes of the byid=TRUE returned matrix is very large and it is sparse; essential when the returned matrix would be too large}
  \item{checkValidity}{default FALSE; error meesages from GEOS do not say clearly which object fails if a topology exception is encountered. If this argument is TRUE, \code{gIsValid} is run on each in turn in an environment in which object names are available. If objects are invalid, this is reported and those affected are named}
}

\value{Returns TRUE if the intersection of the boundaries of the two geometries is not empty.}

\note{Error messages from GEOS, in particular topology exceptions, report 0-based object order, so geom 0 is spgeom1, and geom 1 is spgeom2.}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gContains}}
\code{\link{gContainsProperly}}
\code{\link{gCovers}}
\code{\link{gCoveredBy}}
\code{\link{gCrosses}}
\code{\link{gDisjoint}}
\code{\link{gEquals}}
\code{\link{gEqualsExact}}
\code{\link{gIntersects}}
\code{\link{gOverlaps}}
\code{\link{gRelate}}
\code{\link{gWithin}}
}

\examples{

	p1 = readWKT("POLYGON((0 0,1 0,1 1,0 1,0 0))")
	p2 = readWKT("POLYGON((0 1,0.5 2,1 1,0 1))")
	p3 = readWKT("POLYGON((0.5 1,0 2,1 2,0.5 1))")
	p4 = readWKT("POLYGON((0.5 0.5,0 1.5,1 1.5,0.5 0.5))")
	
	l0 = readWKT("LINESTRING(0 1,0.5 2,1 1)")
	
	l1 = readWKT("LINESTRING(0 0,2 2)")
	l2 = readWKT("LINESTRING(1 1,2 0)")
	l3 = readWKT("LINESTRING(0 2,2 0)")
	
	
	par(mfrow=c(2,3))
	plot(p1,col='blue',border='blue',ylim=c(0,2.5));plot(p2,col='black',add=TRUE,pch=16)
	title(paste("Touches:",gTouches(p1,p2)))
	
	plot(p1,col='blue',border='blue',ylim=c(0,2.5));plot(p3,col='black',add=TRUE,pch=16)
	title(paste("Touches:",gTouches(p1,p3)))
	
	plot(p1,col='blue',border='blue',ylim=c(0,2.5));plot(p4,col='black',add=TRUE,pch=16)
	title(paste("Touches:",gTouches(p1,p4)))
	
	plot(p1,col='blue',border='blue',ylim=c(0,2.5));plot(l0,lwd=2,col='black',add=TRUE,pch=16)
	title(paste("Touches:",gTouches(p1,l0)))
	
	plot(l1,lwd=2,col='blue');plot(l2,lwd=2,col='black',add=TRUE,pch=16)
	title(paste("Touches:",gTouches(l1,l2)))
	
	plot(l1,lwd=2,col='blue');plot(l3,lwd=2,col='black',add=TRUE,pch=16)
	title(paste("Touches:",gTouches(l1,l3)))
	
}
\keyword{spatial}

\name{gIsValid}
\alias{gIsValid}
\alias{RGEOSisValid}

\title{Is Geometry Valid?}
\description{Function tests if the given geometry is valid}
\usage{
gIsValid(spgeom, byid = FALSE, reason=FALSE)
}

\arguments{
  \item{spgeom}{sp object as defined in package sp}
  \item{byid}{Logical determining if the function should be applied across subgeometries (TRUE) or the entire object (FALSE)}
  \item{reason}{Logical determining if the function should return a character string describing why the geometry is invalid}
}

\value{By default will return TRUE if the given geometry is well formed, FALSE otherwise. If reason is set to TRUE then a character string is returned describing the geometry, "Valid Geometry" if it is valid or details of the specific issue. Any given geometry may have multiple issues that make it invalid, gIsValid will only return the first, once it has been corrected additionally checking is necessary to confirm that additional issues do not remain.}

\details{Validity is used in reference to 2-dimensional geometries (LINEARRING and [MULTI]POLYGON) whereas Simplicity (\code{\link{gIsSimple}}) is used in reference to 0 and 1-dimensional geometries ([MULTI]POINT and [MULTI]LINESTRING).

A LINEARRING is valid if it does not intersect itself.

A POLYGON is valid if no two rings in the boundary (made up of an exterior ring and interior rings) cross. The boundary of a POLYGON may intersect at a POINT but only as a tangent (i.e. not on a line). A POLYGON may not have cut lines or spikes and the interior rings must be contained entirely within the exterior ring.

A MULTIPOLYGON is valid if and only if all of its elements are valid and the interiors of no two elements intersect. The boundaries of any two elements may touch, but only at a finite number of POINTs.

Many of the functions in rgeos expect simple/valid geometries and may exhibit unpredictable behavior if given an invalid geometry. Checking of validity/simplicity can be computationally expensive for complex geometries and so is not done by default, any new geometries should be checked.
}


\references{
Validity Details:
\url{http://postgis.net/docs/manual-2.0/using_postgis_dbmanagement.html#OGC_Validity}
}

\author{Roger Bivand & Colin Rundel}

\seealso{
\code{\link{gIsEmpty}}
\code{\link{gIsRing}}
\code{\link{gIsSimple}}
}

\examples{
library(sp)
#LINEARRING Example
l = readWKT("LINEARRING(0 0, 100 100, 100 0, 0 100, 0 0)")
plot(l);title(paste("Valid:",gIsValid(l),"\n",gIsValid(l,reason=TRUE)))

#POLYGON and MULTIPOLYGON Examples
p1 = readWKT("POLYGON ((0 60, 0 0, 60 0, 60 60, 0 60), (20 40, 20 20, 40 20, 40 40, 20 40))")
p2 = readWKT("POLYGON ((0 60, 0 0, 60 0, 60 60, 0 60), (20 40, 20 20, 60 20, 20 40))")
p3 = readWKT(paste("POLYGON ((0 120, 0 0, 140 0, 140 120, 0 120),",
 "(100 100, 100 20, 120 20, 120 100, 100 100),",
 "(20 100, 20 40, 100 40, 20 100))"))

p4 = readWKT("POLYGON ((0 40, 0 0, 40 40, 40 0, 0 40))")
p5 = readWKT("POLYGON ((-10 50, 50 50, 50 -10, -10 -10, -10 50), (0 40, 0 0, 40 40, 40 0, 0 40))")
p6 = readWKT("POLYGON ((0 60, 0 0, 60 0, 60 20, 100 20, 60 20, 60 60, 0 60))")
p7 = readWKT(paste("POLYGON ((40 300, 40 20, 280 20, 280 300, 40 300),",
 "(120 240, 80 180, 160 220, 120 240),",
 "(220 240, 160 220, 220 160, 220 240),",
 "(160 100, 80 180, 100 80, 160 100),",
 "(160 100, 220 160, 240 100, 160 100))"))
p8 = readWKT(paste("POLYGON ((40 320, 340 320, 340 20, 40 20, 40 320),",
 "(100 120, 40 20, 180 100, 100 120),",
 "(200 200, 180 100, 240 160, 200 200),",
 "(260 260, 240 160, 300 200, 260 260),",
 "(300 300, 300 200, 340 320, 300 300))"))
p9 = readWKT(paste("MULTIPOLYGON (((20 380, 420 380, 420 20, 20 20, 20 380),",
 "(220 340, 180 240, 60 200, 200 180, 340 60, 240 220, 220 340)),",
 "((60 200, 340 60, 220 340, 60 200)))"))

par(mfrow=c(3,3))
plot(p1,col='black',pbg='white');title(paste("Valid:",gIsValid(p1),"\n",gIsValid(p1,reason=TRUE)))
plot(p2,col='black',pbg='white');title(paste("Valid:",gIsValid(p2),"\n",gIsValid(p2,reason=TRUE)))
plot(p3,col='black',pbg='white');title(paste("Valid:",gIsValid(p3),"\n",gIsValid(p3,reason=TRUE)))
plot(p4,col='black',pbg='white');title(paste("Valid:",gIsValid(p4),"\n",gIsValid(p4,reason=TRUE)))
plot(p5,col='black',pbg='white');title(paste("Valid:",gIsValid(p5),"\n",gIsValid(p5,reason=TRUE)))
plot(p6,col='black',pbg='white');title(paste("Valid:",gIsValid(p6),"\n",gIsValid(p6,reason=TRUE)))
plot(p7,col='black',pbg='white');title(paste("Valid:",gIsValid(p7),"\n",gIsValid(p7,reason=TRUE)))
plot(p8,col='black',pbg='white');title(paste("Valid:",gIsValid(p8),"\n",gIsValid(p8,reason=TRUE)))
plot(p9,col='black',pbg='white')
title(paste("Valid:",gIsValid(p9),"\n",gIsValid(p9,reason=TRUE)))	
}

\keyword{spatial}
